#!/bin/sh 
set -eu 
namespace=${1:-"default"} 
 
pod_selector="sidecar.microgateway.airlock.com/incompatible=true" 
 
rootController() { 
    namespace=$1 
    resource=$2 
    owner=$(kubectl get "${resource}" -n "${namespace}" -ojsonpath='{range .metadata.ownerReferences[?(@.controller==true)]}{.kind}/{.name}{"\n"}{end}') 
    if [ -n "$owner" ]; then 
        rootController "${namespace}" "${owner}" 
    elif echo "${resource}" | grep -vq Pod/; then 
        echo "${resource}" 
    fi 
} 
 
for pod in $(kubectl get pods -n "${namespace}" -l "${pod_selector}" -ojsonpath='{range .items[*]}Pod/{.metadata.name}{"\n"}{end}'); do 
        rootController "${namespace}" "${pod}" 
done | sort -u