<%@page import="org.apache.lucene.queryParser.MultiFieldQueryParser"%>
<%@page import="org.apache.lucene.analysis.LowerCaseFilter"%>
<%@page import="org.apache.lucene.search.TopScoreDocCollector"%>
<%@page import="org.apache.lucene.search.ScoreDoc"%>
<%@page import="org.apache.lucene.util.Version"%>
<%@page import="org.apache.lucene.store.SimpleFSDirectory"%>
<%@page import="org.apache.lucene.store.FSDirectory"%>
<%@page import="org.apache.lucene.store.Directory"%>
<%@page import="org.apache.lucene.document.Document"%>
<%@page import="org.apache.lucene.search.highlight.TextFragment"%>
<%@page import="org.apache.lucene.search.highlight.TokenSources"%>
<%@page import="org.apache.lucene.analysis.TokenStream"%>
<%@page import="org.apache.lucene.search.highlight.QueryScorer"%>
<%@page import="org.apache.lucene.search.highlight.Highlighter"%>
<%@page import="org.apache.lucene.search.highlight.SimpleHTMLFormatter"%>
<%@page import="org.apache.lucene.search.Query"%>
<%@page import="org.apache.lucene.search.IndexSearcher"%>
<%@page import="java.io.File"%>
<%@page import="org.apache.lucene.analysis.standard.StandardAnalyzer"%>
<%@page import="org.apache.lucene.queryParser.QueryParser"%>
<%@ page import="org.apache.lucene.search.BooleanQuery" %>
<%@ page import="org.apache.lucene.search.TermQuery" %>
<%@ page import="org.apache.lucene.index.Term" %>
<%@ page import="org.apache.lucene.search.BooleanClause" %>
<%!
	// private static IndexSearcher searcher;

	public IndexSearcher getIndexSearcher(HttpServletRequest request) {
		IndexSearcher searcher = null;
		//if (searcher == null)
		{
			String pathInfo = request.getServletPath() != null ? request.getServletPath().replace("/search.jsp", "") : "";
			File directory = new File(this.getServletContext().getRealPath(pathInfo), "searchindex");
			try
			{
				searcher = new IndexSearcher(new SimpleFSDirectory(directory), true);
			}
			catch (Exception e)
			{
				System.err.println("Could not initialize index: " + e);
				e.printStackTrace();
			}
		}
		return searcher;
	}

	/*public void jspDestroy() {
		try
		{
			if (searcher != null)
			{
				searcher.close();
				searcher = null;
			}
		}
		catch (Exception e)
		{
			System.err.println("Could not close index: " + e);
			e.printStackTrace();
		}
	}*/
%>
<div>
<%
request.setCharacterEncoding("UTF-8");
response.setContentType("text/html;charset=UTF-8");
StandardAnalyzer analyzer = new StandardAnalyzer(Version.LUCENE_24);
QueryParser parser = new MultiFieldQueryParser(Version.LUCENE_24, new String[] {"title", "contents"}, analyzer);
parser.setLowercaseExpandedTerms(true);
parser.setAllowLeadingWildcard(true);
String s = request.getParameter("s");
String bookID = request.getParameter("bookID");
String filterMetadataFields = request.getParameter("metadataFields");
if (s != null && s.length() > 1)
{
	s = s.replace("-", " ");
	if(bookID != null) {
		bookID = bookID.replace("&", "&amp").replace("<", "&lt").replace(">", "&gt");
	}

	if(filterMetadataFields != null) {
		filterMetadataFields = filterMetadataFields.replace("&", "&amp").replace("<", "&lt").replace(">", "&gt").replace("%7C","\\|");
	}
	
	//System.out.println(s);
	Query query = parser.parse(s);
	//System.out.println(query.toString());
	IndexSearcher searcher = this.getIndexSearcher(request);
	try
	{
		if (searcher == null)
		{
			out.println("<div>Could not initialize the search index!</div>");
		}
		else
		{
			TopScoreDocCollector collector = TopScoreDocCollector.create(10000, true);
			if(bookID != null && !"-".equals(bookID)) {
				BooleanQuery booleanQuery = new BooleanQuery();
				booleanQuery.add(new TermQuery(new Term("ancestorBookID", bookID)), BooleanClause.Occur.MUST);
				booleanQuery.add(query, BooleanClause.Occur.MUST);
				searcher.search(booleanQuery, collector);
			} else if(filterMetadataFields != null) {
				BooleanQuery booleanQuery = new BooleanQuery();
				booleanQuery.setMinimumNumberShouldMatch(1);
				String[] fields = filterMetadataFields.split("\\|");
				for(String field : fields) {
					booleanQuery.add(new TermQuery(new Term("metadataField", field)), BooleanClause.Occur.SHOULD);
					booleanQuery.add(new TermQuery(new Term("metadataField", "")), BooleanClause.Occur.SHOULD);
					booleanQuery.add(query, BooleanClause.Occur.MUST);
					searcher.search(booleanQuery, collector);
				}
			}
			else {
				searcher.search(query, collector);
			}
			ScoreDoc[] scoreDocs = collector.topDocs().scoreDocs;
	
			SimpleHTMLFormatter htmlFormatter = new SimpleHTMLFormatter();
			Highlighter highlighter = new Highlighter(htmlFormatter, new QueryScorer(query));
			
			for (int i = 0; i < scoreDocs.length; i++)
			{
				Document doc = searcher.doc(scoreDocs[i].doc);
				String ancestorBookName = doc.get("ancestorBookName");
				String ancestorBookID = doc.get("ancestorBookID");
				String text = doc.get("contents");
				TokenStream tokenStream =
						TokenSources.getAnyTokenStream(searcher.getIndexReader(), scoreDocs[i].doc, "contents", analyzer);
				TextFragment[] frag = highlighter.getBestTextFragments(tokenStream, text, false, 3);//highlighter.getBestFragments(tokenStream, text, 3, "...");
				out.println("<div class='smc-search-result-item'>");
				String objType = doc.get("objType");
				String path = doc.get("path");
				String target = "";
				if("file".equals(objType)){
					path = path.replace("data/../", "");
					target = "target='_blank'";
				}
				out.print("<div class='smc-search-result-title'><a href='" + path + "' " + target + " objType='" + objType + "'>");
				out.print(doc.get("title"));
				out.println("</a>");
				if(!"".equals(ancestorBookName) && ancestorBookName != null) {
					out.print("<p id='" + ancestorBookID +"' class='x-bookName'>");
					out.print(ancestorBookName);
					out.print("<p></div>");
				} else {
					out.print("</div>");
				}
				out.print("<div class='smc-search-result-text'>");
				for (int j = 0; j < frag.length; j++)
				{
					if ((frag[j] != null) && (frag[j].getScore() > 0))
					{
						out.print((frag[j].toString()));
					}
				}
				out.println("</div>");
				out.println("</div>");
			}
		}
	}
	finally
	{
		if (searcher != null)
		{
			searcher.close();
			searcher = null;
		}
	}
}
%>
</div>