var relearn_search_index = [
  {
    "breadcrumb": "API Reference",
    "content": "Reference documentation for configuration files\nOperatorConfigAPI Documentation for OperatorConfig\n",
    "description": "Reference documentation for configuration files",
    "tags": null,
    "title": "Configuration Reference",
    "uri": "/config/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e Configuration Reference \u003e OperatorConfig",
    "content": "config.airlock.com/v1alpha1 OperatorConfig is the schema for the Airlock Microgateway Operator configuration file\n​ Example Default # Example Operator configuration apiVersion: config.airlock.com/v1alpha1 kind: OperatorConfig log: level: info health: healthProbeBindAddress: :8081 metrics: bindAddress: 0.0.0.0:8080 webhook: port: 9443 pprof: bindAddress: localhost:6060 # Extensions: Airlock Microgateway Operator deployment: sidecar: engineContainerTemplate: \"/sidecar/engine_container_template.yaml\" engine: bootstrapConfigTemplate: \"/engine_bootstrap_config_template.yaml\" apiVersion: config.airlock.com/v1alpha1 kind: OperatorConfig metrics: bindAddress: \"0.0.0.0:8080\" health: healthProbeBindAddress: \":8081\" readinessEndpointName: \"/readyz\" livenessEndpointName: \"/healthz\" webhook: port: 9443 deployment: sidecar: engineContainerTemplate: \"/sidecar/engine_container_template.yaml\" networkValidatorContainerTemplate: \"/sidecar/network_validator_container_template.yaml\" engine: bootstrapConfigTemplate: \"/engine_bootstrap_config_template.yaml\" xdsServer: port: 13377 grpcSettings: maxConcurrentStreams: 4294967295 keepaliveTime: \"2h\" keepaliveTimeout: \"20s\" keepaliveClientMinTime: \"5m\" log: level: info OperatorConfig Field Type Description Required Default Allowed Values deployment object Deployment defines the configuration for the deployment strategy. no engine object Engine defines the configuration for the engine container. no health object Health contains the health configuration of the operator. no log object Log defines the log configuration of the operator. no metrics object Metrics contains the metrics configuration of the operator. no pprof object Pprof defines an optional pprof server with its binding address, if omitted no pprof server is started. no webhook object Webhook contains the webhook configuration of the operator. no xdsServer object XdsServer defines the configuration for the xDS server which communicates with the Airlock Microgateway Engine. no OperatorConfig.deployment Field Type Description Required Default Allowed Values sidecar object Sidecar defines the configuration for the sidecar deployment. no OperatorConfig.deployment.sidecar Field Type Description Required Default Allowed Values engineContainerTemplate string Defines the container which will be injected as sidecar. Can be useful to adjust the image, imagePullPolicy, capabilities or other settings. For more information please visit the official Kubernetes documentation website. no /sidecar/engine_container_template.yaml networkValidatorContainerTemplate string Defines the container which will be injected as init container to verify that the Airlock Microgateway CNI plugin correctly configured the pod’s network such that traffic is redirected through Airlock Microgateway Engine. Can be useful to adjust the image, imagePullPolicy, capabilities or other settings. For more information please visit the official Kubernetes documentation website. If explicitly set to an empty string, init container injection will be disabled and no network validation will be performed before pod startup. no /sidecar/network_validator_container_template.yaml OperatorConfig.engine Field Type Description Required Default Allowed Values bootstrapConfigTemplate string Defines the Envoy bootstrap configuration. For more information, please visit the official Envoy documentation website. no /engine_bootstrap_config_template.yaml OperatorConfig.health Field Type Description Required Default Allowed Values healthProbeBindAddress string HealthProbeBindAddress is the TCP address that the operator should bind to for serving health probes. It can be set to “0” to disable serving the health probe. no :8081 livenessEndpointName string LivenessEndpointName is the path under which the liveness probe is served. no /healthz readinessEndpointName string ReadinessEndpointName is the path under which the readiness probe is served. no /readyz OperatorConfig.log Field Type Description Required Default Allowed Values level enum Level defines the log level of the operator. no info error, warn, info, debug OperatorConfig.metrics Field Type Description Required Default Allowed Values bindAddress string BindAddress is the TCP address that the operator should bind to for serving prometheus metrics. It can be set to “0” to disable the metrics serving. no 0.0.0.0:8080 OperatorConfig.pprof Field Type Description Required Default Allowed Values bindAddress string BindAddress defines the TCP address that the operator should bind to for serving pprof. Since pprof may contain sensitive information, it is recommended to bind it to localhost only. yes OperatorConfig.webhook Field Type Description Required Default Allowed Values port int Port is the port on which the webhook server is served. no 9443 [1, 65535] OperatorConfig.xdsServer Field Type Description Required Default Allowed Values grpcSettings object Defines the gRPC Settings which are used by the xDS Server for the gRPC connections with the Airlock Microgateway Engine containers. no port int32 Defines the port where the xDS server is listening. no 13377 [1, 65535] OperatorConfig.xdsServer.grpcSettings Field Type Description Required Default Allowed Values keepaliveClientMinTime string (duration) Defines the minimum amount of time an Airlock Microgateway Engine (xDS client) should wait before sending a keepalive ping. The Airlock Microgateway Operator (xDS server) will close connection with a client that violates this policy. no 5m See link keepaliveTime string (duration) Defines the keep alive time. After this time without any activity from Airlock Microgateway Engine container a ping is sent to see if the transport is still alive. If set below 1s, a minimum value of 1s will be used instead. no 2h See link keepaliveTimeout string (duration) Defines the keep alive timeout. Time to wait after keepalive check before closing the connection in case that there was no activity. no 20s See link maxConcurrentStreams uint32 Defines the limit of max concurrent gRPC streams. no 4294967295 [0, 4294967295] ",
    "description": "API version v1alpha1",
    "tags": null,
    "title": "OperatorConfig",
    "uri": "/config/operator-config/v1alpha1/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference \u003e AccessControl",
    "content": "microgateway.airlock.com/v1alpha1 AccessControl specifies the options to perform access control with a Microgateway Engine container.\n​ Example Default apiVersion: microgateway.airlock.com/v1alpha1 kind: AccessControl metadata: name: access-control-example spec: policies: - authorization: authentication: oidc: oidcRelyingPartyRef: name: oidc-example identityPropagation: actions: - identityPropagationRef: name: identity-propagation-example onFailure: Pass apiVersion: microgateway.airlock.com/v1alpha1 kind: AccessControl metadata: name: default AccessControl Field Type Description Required Default Allowed Values metadata ObjectMeta Refer to Kubernetes API documentation for fields of metadata yes spec object Specifies how the Airlock Microgateway Engine performs access control. yes AccessControl.spec Field Type Description Required Default Allowed Values policies object[] Policies configures access control policies. yes AccessControl.spec.policies[] Field Type Description Required Default Allowed Values authorization object Authorization configures how requests are authorized. An empty object value {} disables authorization. yes identityPropagation object IdentityPropagation configures how the authenticated user’s identity is communicated to the protected application. no AccessControl.spec.policies[].authorization Field Type Description Required Default Allowed Values authentication object Authentication specifies that clients need to be authenticated with the provided method. no oidc{} AccessControl.spec.policies[].authorization.authentication Field Type Description Required Default Allowed Values oidc object OIDC configures client authentication using OpenID Connect. no AccessControl.spec.policies[].authorization.authentication.oidc Field Type Description Required Default Allowed Values oidcRelyingPartyRef object OIDCRelyingPartyRef configures how the Airlock Microgateway Engine interacts with the OpenID provider. yes AccessControl.spec.policies[].authorization.authentication.oidc.oidcRelyingPartyRef Field Type Description Required Default Allowed Values name string Name of the resource yes AccessControl.spec.policies[].identityPropagation Field Type Description Required Default Allowed Values actions object[] Actions specifies the propagation actions. yes onFailure enum OnFailure configures what should happen, if an identity propagation fails. Meaning of the possible values: Pass: The request should be forwarded to the upstream, without including the information from the failed identity propagations. yes Pass AccessControl.spec.policies[].identityPropagation.actions[] Field Type Description Required Default Allowed Values identityPropagationRef object IdentityPropagationRef selects an IdentityPropagation to apply. yes AccessControl.spec.policies[].identityPropagation.actions[].identityPropagationRef Field Type Description Required Default Allowed Values name string Name of the resource yes ",
    "description": "API version v1alpha1",
    "tags": null,
    "title": "AccessControl",
    "uri": "/crds/access-control/v1alpha1/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference \u003e ContentSecurity",
    "content": "microgateway.airlock.com/v1alpha1 ContentSecurity specifies the options to secure an upstream web application with a Microgateway Engine container.\n​ Example Default apiVersion: microgateway.airlock.com/v1alpha1 kind: ContentSecurity metadata: name: content-security-example spec: parserRef: name: parser-example limitsRef: name: limits-example headerRewritesRef: name: header-rewrites-example filter: denyRulesRef: name: deny-rules-example apiProtection: openAPIRef: name: open-api-example apiVersion: microgateway.airlock.com/v1alpha1 kind: ContentSecurity metadata: name: default spec: filter: {} apiProtection: {} ContentSecurity Field Type Description Required Default Allowed Values metadata ObjectMeta Refer to Kubernetes API documentation for fields of metadata yes spec object Specifies the options to secure an upstream web application with a Microgateway Engine container. no ContentSecurity.spec Field Type Description Required Default Allowed Values apiProtection object APIProtection defines the relevant configurations to protect APIs. If undefined, default settings are applied, designed to work with most upstream web application services. no filter object Filter defines the set of filters, e.g. Airlock Deny Rules, to be applied to incoming requests to protect against various attack patterns. If undefined, default settings are applied, designed to work with most upstream web application services. no headerRewritesRef object HeaderRewritesRef selects the relevant HeaderRewrites. If undefined, default settings are applied, designed to work with most upstream web application services. no limitsRef object LimitsRef selects the relevant Limits configuration resource. If undefined, default settings are applied, designed to work with most upstream web application services. no parserRef object ParserRef selects the relevant Parser configuration resource. If undefined, default settings are applied, designed to work with most upstream web application services. no ContentSecurity.spec.apiProtection Field Type Description Required Default Allowed Values openAPIRef object OpenAPIRef selects the relevant OpenAPI configuration resource. If undefined, default settings are applied, designed to work with most upstream web application services. no ContentSecurity.spec.apiProtection.openAPIRef Field Type Description Required Default Allowed Values name string Name of the resource yes ContentSecurity.spec.filter Field Type Description Required Default Allowed Values denyRulesRef object DenyRulesRef selects the relevant DenyRules configuration resource. If undefined, default settings are applied, designed to work with most upstream web application services. no ContentSecurity.spec.filter.denyRulesRef Field Type Description Required Default Allowed Values name string Name of the resource yes ContentSecurity.spec.headerRewritesRef Field Type Description Required Default Allowed Values name string Name of the resource yes ContentSecurity.spec.limitsRef Field Type Description Required Default Allowed Values name string Name of the resource yes ContentSecurity.spec.parserRef Field Type Description Required Default Allowed Values name string Name of the resource yes ",
    "description": "API version v1alpha1",
    "tags": null,
    "title": "ContentSecurity",
    "uri": "/crds/content-security/v1alpha1/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference \u003e DenyRules",
    "content": "microgateway.airlock.com/v1alpha1 DenyRules configures request filtering using Airlock built-in and custom deny rules.\nDeny rules establish a negative security model. They define prohibited patterns which, when a match is found in a request, lead to it being blocked from reaching the upstream web application.\nTo handle possible false positives, lower the security level or define fine-granular deny rule exceptions\nIf undefined, default settings are applied, designed to work with most upstream web application services.\n​ Example Default apiVersion: microgateway.airlock.com/v1alpha1 kind: DenyRules metadata: name: deny-rules-example spec: request: builtIn: settings: # Use the deny rules in security level 'Strict' level: Strict # Explicitly set the 'threatHandlingMode' to 'Block' threatHandlingMode: Block overrides: # Set the deny rule security level to 'Standard' for # the deny rule 'XSS' if it is applied to request parameters. - conditions: ruleKeys: - XSS types: - Parameter settings: level: Standard exceptions: # Define a deny rule exception for the deny rule 'SQL' # for the query parameter 'search' under the path '^/member/'. - blockedData: parameter: name: matcher: exact: search source: Query requestConditions: path: matcher: prefix: /member/ method: - GET ruleKeys: - SQL custom: rules: # Define a custom deny rule which blocks requests # containing a 'referer' header matching the regex '.*bad.tv'. - ruleKey: CM_REFERRER_BLOCK blockData: header: name: matcher: exact: referer value: matcher: regex: .*bad.tv apiVersion: microgateway.airlock.com/v1alpha1 kind: DenyRules metadata: name: default spec: request: builtIn: settings: level: Standard threatHandlingMode: Block custom: {} DenyRules Field Type Description Required Default Allowed Values metadata ObjectMeta Refer to Kubernetes API documentation for fields of metadata yes spec object Specification of the desired deny rules behavior. no DenyRules.spec Field Type Description Required Default Allowed Values request object Request configures deny rules for downstream requests. no DenyRules.spec.request Field Type Description Required Default Allowed Values builtIn object BuiltIn configures the built-in deny rules. no custom object Custom allows configuring additional deny rules. no DenyRules.spec.request.builtIn Field Type Description Required Default Allowed Values exceptions object[] Exceptions allows to define exceptions for specific requests and deny rules. no overrides object[] Overrides allows to override the builtIn settings for specific deny rules. no settings object Settings contains the keys which will be adjusted. no DenyRules.spec.request.builtIn.exceptions[] Field Type Description Required Default Allowed Values blockedData object BlockedData defines an exception based on the request data causing the block. no parameter{}, header{}, path{}, pathSegment{}, json{} requestConditions object RequestConditions defines an exception based on a property of a request without taking into consideration the reason why a request has been blocked. no ruleKeys DenyRuleKey[] RuleKeys restricts the exception to a set of deny rules. no ENCODING, EXPLOIT, HPP, HTML, IDOR, LDAP, NOSQL, OGNL, PHP, PROTOCOL, SANITY, SCANNING, SQL, TEMPLATE, UNIXCMD, WINCMD, XSS DenyRules.spec.request.builtIn.exceptions[].blockedData Field Type Description Required Default Allowed Values header object Header defines an exception based on a blocked header. Only one of parameter, header, path, pathSegment or json can be set. no json object JSON defines an exception based on a blocked JSON property. Only one of parameter, header, path, pathSegment or json can be set. no parameter object Parameter defines an exception based on a blocked parameter. Only one of parameter, header, path, pathSegment or json can be set. no path object Path defines an exception based on the blocked path. Only one of parameter, header, path, pathSegment or json can be set. no pathSegment object PathSegment defines an exception based on a blocked path segment. Only one of parameter, header, path, pathSegment or json can be set. no DenyRules.spec.request.builtIn.exceptions[].blockedData.header Field Type Description Required Default Allowed Values name object Name defines the name of a header. no value object Value defines the value of a header. no DenyRules.spec.request.builtIn.exceptions[].blockedData.header.name Field Type Description Required Default Allowed Values matcher object Matcher defines the way to match a string. In comparison to a normal StringMatcher, a value is always matched ignoring the case and can’t be inverted. yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.builtIn.exceptions[].blockedData.header.name.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.builtIn.exceptions[].blockedData.header.value Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.builtIn.exceptions[].blockedData.header.value.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.builtIn.exceptions[].blockedData.json Field Type Description Required Default Allowed Values jsonPath string JSONPath defines the JSONPath pattern to match the path within the JSON. Expressions in JSONPath i.e. ?(expr) are not supported. no key object Key defines the key of the JSON property. At most one of key and value can be set. no value object Value defines the value of the JSON property. At most one of key and value can be set. no DenyRules.spec.request.builtIn.exceptions[].blockedData.json.key Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.builtIn.exceptions[].blockedData.json.key.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.builtIn.exceptions[].blockedData.json.value Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.builtIn.exceptions[].blockedData.json.value.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.builtIn.exceptions[].blockedData.parameter Field Type Description Required Default Allowed Values name object Name defines the name of a parameter. no source enum Source defines the source of the parameter. no Any Query, Post, Any value object Value defines the value of a parameter. no DenyRules.spec.request.builtIn.exceptions[].blockedData.parameter.name Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.builtIn.exceptions[].blockedData.parameter.name.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.builtIn.exceptions[].blockedData.parameter.value Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.builtIn.exceptions[].blockedData.parameter.value.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.builtIn.exceptions[].blockedData.path Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.builtIn.exceptions[].blockedData.path.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.builtIn.exceptions[].blockedData.pathSegment Field Type Description Required Default Allowed Values segments object Segments defines the position of a segment within the path. no index{} value object Value defines the value of a path segment. no DenyRules.spec.request.builtIn.exceptions[].blockedData.pathSegment.segments Field Type Description Required Default Allowed Values index int Index specifies an exact path segment position by index (0-based). no [0, 9223372036854775807] DenyRules.spec.request.builtIn.exceptions[].blockedData.pathSegment.value Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.builtIn.exceptions[].blockedData.pathSegment.value.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.builtIn.exceptions[].requestConditions Field Type Description Required Default Allowed Values header object Header defines the matching headers of a request. no invert bool Invert indicates whether the request condition should be inverted. no false true, false mediaType object MediaType defines the matching media type from the content-type header of a request. no method enum[] Method defines the matching methods of a request. no GET, HEAD, POST, PUT, PATCH, DELETE, CONNECT, OPTIONS, TRACE path object Path defines the matching path of a request. no remoteIP object RemoteIP defines the matching remote IPs of a request. no DenyRules.spec.request.builtIn.exceptions[].requestConditions.header Field Type Description Required Default Allowed Values name object Name defines the name of a header. no value object Value defines the value of a header. no DenyRules.spec.request.builtIn.exceptions[].requestConditions.header.name Field Type Description Required Default Allowed Values matcher object Matcher defines the way to match a string. In comparison to a normal StringMatcher, a value is always matched ignoring the case and can’t be inverted. yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.builtIn.exceptions[].requestConditions.header.name.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.builtIn.exceptions[].requestConditions.header.value Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.builtIn.exceptions[].requestConditions.header.value.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.builtIn.exceptions[].requestConditions.mediaType Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.builtIn.exceptions[].requestConditions.mediaType.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.builtIn.exceptions[].requestConditions.path Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.builtIn.exceptions[].requestConditions.path.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.builtIn.exceptions[].requestConditions.remoteIP Field Type Description Required Default Allowed Values cidrRanges string[] CIDRRanges defines the IPv4 or IPv6 CIDR ranges, e.g. 196.148.3.128/26 or 2001:db8::/28. yes invert bool Invert indicates whether the match should be inverted. no false true, false DenyRules.spec.request.builtIn.overrides[] Field Type Description Required Default Allowed Values conditions object Conditions select which built-in deny rules’ settings will be adjusted. no settings object Settings override the corresponding properties for the selected rules. no DenyRules.spec.request.builtIn.overrides[].conditions Field Type Description Required Default Allowed Values ruleKeys DenyRuleKey[] RuleKeys is a list of built-in deny rule names. no ENCODING, EXPLOIT, HPP, HTML, IDOR, LDAP, NOSQL, OGNL, PHP, PROTOCOL, SANITY, SCANNING, SQL, TEMPLATE, UNIXCMD, WINCMD, XSS types enum[] Types defines the type of attributes the override should be applied on. If Types are defined without any RuleKeys the override is applied to all deny rules. no Header, Parameter, Path, PathSegment, JSON DenyRules.spec.request.builtIn.overrides[].settings Field Type Description Required Default Allowed Values level enum Level specifies the filter strength. no Unfiltered, Basic, Standard, Strict threatHandlingMode enum ThreatHandlingMode specifies how threats should be handled. no Block, LogOnly DenyRules.spec.request.builtIn.settings Field Type Description Required Default Allowed Values level enum Level represents a set of deny rules with different filter strengths. no Standard Unfiltered, Basic, Standard, Strict threatHandlingMode enum ThreatHandlingMode specifies how threats should be handled when a deny rule matches. no Block Block, LogOnly DenyRules.spec.request.custom Field Type Description Required Default Allowed Values rules object[] Rules defines list of additional deny rules. no DenyRules.spec.request.custom.rules[] Field Type Description Required Default Allowed Values blockData object BlockData specifies the request data which should cause a block. yes parameter{}, header{}, path{}, pathSegment{}, json{} requestConditions object RequestConditions defines additional request properties which must be matched in order for this rule to apply. no ruleKey string RuleKey defines a technical key for the deny rule. Must be unique. yes threatHandlingMode enum ThreatHandlingMode specifies how threats should be handled when a deny rule matches. no Block Block, LogOnly DenyRules.spec.request.custom.rules[].blockData Field Type Description Required Default Allowed Values header object Header specifies to block requests containing a matching header. Only one of parameter, header, path, pathSegment or json can be set. no json object JSON specifies to block requests containing a matching JSON property in the body. Only one of parameter, header, path, pathSegment or json can be set. no parameter object Parameter specifies to block requests containing a matching parameter. Only one of parameter, header, path, pathSegment or json can be set. no path object Path specifies to block requests with a matching path. Only one of parameter, header, path, pathSegment or json can be set. no pathSegment object PathSegment specifies to block requests containing a matching path segment. Only one of parameter, header, path, pathSegment or json can be set. no DenyRules.spec.request.custom.rules[].blockData.header Field Type Description Required Default Allowed Values name object Name defines the name of a header. no value object Value defines the value of a header. no DenyRules.spec.request.custom.rules[].blockData.header.name Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.custom.rules[].blockData.header.name.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.custom.rules[].blockData.header.value Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.custom.rules[].blockData.header.value.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.custom.rules[].blockData.json Field Type Description Required Default Allowed Values key object Key defines the key of a JSON object. no value object Value defines the value of a JSON object. no DenyRules.spec.request.custom.rules[].blockData.json.key Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.custom.rules[].blockData.json.key.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.custom.rules[].blockData.json.value Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.custom.rules[].blockData.json.value.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.custom.rules[].blockData.parameter Field Type Description Required Default Allowed Values name object Name defines the name of a parameter. no value object Value defines the value of a parameter. no DenyRules.spec.request.custom.rules[].blockData.parameter.name Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.custom.rules[].blockData.parameter.name.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.custom.rules[].blockData.parameter.value Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.custom.rules[].blockData.parameter.value.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.custom.rules[].blockData.path Field Type Description Required Default Allowed Values matcher object Matcher specifies which path to block. yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.custom.rules[].blockData.path.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.custom.rules[].blockData.pathSegment Field Type Description Required Default Allowed Values segments object Segments restricts which path segments are filtered by this rule. If not specified, all segments of a path are filtered. no index{} value object Value specifies which path segment values to block. yes DenyRules.spec.request.custom.rules[].blockData.pathSegment.segments Field Type Description Required Default Allowed Values index int Index restricts the rule to the path segment at this index (0-based). no [0, 9223372036854775807] DenyRules.spec.request.custom.rules[].blockData.pathSegment.value Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.custom.rules[].blockData.pathSegment.value.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.custom.rules[].requestConditions Field Type Description Required Default Allowed Values header object Header defines the matching headers of a request. no invert bool Invert indicates whether the request condition should be inverted. no false true, false mediaType object MediaType defines the matching media type from the content-type header of a request. no method enum[] Method defines the matching methods of a request. no GET, HEAD, POST, PUT, PATCH, DELETE, CONNECT, OPTIONS, TRACE path object Path defines the matching path of a request. no remoteIP object RemoteIP defines the matching remote IPs of a request. no DenyRules.spec.request.custom.rules[].requestConditions.header Field Type Description Required Default Allowed Values name object Name defines the name of a header. no value object Value defines the value of a header. no DenyRules.spec.request.custom.rules[].requestConditions.header.name Field Type Description Required Default Allowed Values matcher object Matcher defines the way to match a string. In comparison to a normal StringMatcher, a value is always matched ignoring the case and can’t be inverted. yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.custom.rules[].requestConditions.header.name.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.custom.rules[].requestConditions.header.value Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.custom.rules[].requestConditions.header.value.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.custom.rules[].requestConditions.mediaType Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.custom.rules[].requestConditions.mediaType.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.custom.rules[].requestConditions.path Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} DenyRules.spec.request.custom.rules[].requestConditions.path.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no DenyRules.spec.request.custom.rules[].requestConditions.remoteIP Field Type Description Required Default Allowed Values cidrRanges string[] CIDRRanges defines the IPv4 or IPv6 CIDR ranges, e.g. 196.148.3.128/26 or 2001:db8::/28. yes invert bool Invert indicates whether the match should be inverted. no false true, false Default Deny Rule Keys Key Name Description ENCODING Encoding and Conversion Exploits in Header and Parameter Value Prevents injection of special encoded characters, such as double URL encoded characters in header values. Prevents the Java MIN_VALUE floating point attack in header and parameter values on all security levels. EXPLOIT Known Exploits Protects against the exploitation of specific (e.g.,framework specific) bugs and vulnerabilities by preventing the injection of special payloads not covered by the other Deny Rules. For instance, prevents attacks targeting the Spring4Shell vulnerability. HPP HTTP Parameter Pollution Prevents HTTP parameter pollution by blocking nested parameters in parameter values on security level Strict. In an HTTP parameter pollution (HPP) attack, an attacker injects or supplies HTTP parameters in a way that “confuses” the recipient and which may be interpreted by an application in unexpected ways. This rule prevents nesting parameters using percent-encoding like in the example below where the query parameter some-param some-param=some-value%26nested-param%3Dnested-value can be decoded to some-param=some-value\u0026nested-param=nested-value and some technologies might accept the disguised nested parameter. Both client-side and server-side HPP attacks exist and some consequences are application errors, modification of internal state, or the bypassing of input validations and WAF filters. In some cases attackers try to disguise attack payloads in multiple parameter values, in order to avoid detection by a WAF. The application might concatenate the parts again, thereby triggering the attack. HTML HTML Injection in Path, Header and Parameter Value Prevents HTML injection through HTTP paths, header and parameter values. Similar to a Cross-Site Scripting (XSS) attack, a HTML injection attack injects HTML into a website, which is then loaded and executed by unsuspecting users visiting the compromised site. This way, an attacker can modify the page content and for example embed malicious links or try to phish users. HTML injection vulnerabilities occur when unsanitized user input is stored or reflected as part of the web page. This often happens on websites allowing users to upload posts or add comments. An unquoted context attack occurs when user input is directly interpreted as HTML. A quoted context attack occurs when user input is put within quotes. In the following example, a user can supply the url to an image, which is then displayed on the website: \u003cimg src=\"USER_INPUT\"\u003e An attacker can “break out” of the string and perform a HTML injection with the payload \"\u003e \u003ch1\u003eThis is a HTML injection\u003c/h1 This results in the combined HTML \u003cimg src=\"\"\u003e \u003ch1\u003eThis is a HTML injection\u003c/h1 and the injection is displayed on the vulnerable website. The security level Basic does not prevent any HTML injection. The security level Standard prevents injection of well-known HTML tags (e.g.,\u003cimg src=\"path\"\u003e) as well as injection of well-known HTML attribute names in a single or double quoted attribute value (e.g.,' href=\"url\"). The security level Strict prevents injection of any kind of HTML tags as well as injection of any kind of HTML attribute names in a single or double quoted attribute value. IDOR Insecure Direct Object Reference in Path and Parameter Values Prevents insecure direct object references and file inclusion for HTTP paths and parameter values. An insecure direct object reference (IDOR) is a publicly exposed identifier that can be used to directly access to internal objects and is not subject to access control. As an example, we use a well-known type of an IDOR exploit, the directory traversal attack. Consider a url where part of the page content is fetched from a file on the server using the relative path in the ‘file’ parameter, e.g. https://some-website.org/show-file-content?file=content.html In this example, the ‘file’ parameter is the direct object reference. Unless this parameter is validated or sanitized, an attacker could gain access to files, that are not supposed to be accessible via the url, by changing the value of the ‘file’ parameter. For instance to retrieve the /etc/passwd file an attacker could move from the directory where the website files are stored to the root directory of the server: https://some-website.org/show-file-content?file=../../etc/passwd For paths: The security level Basic and Standard prevents directory traversal and injection of certain critical files (e.g.,.htaccess). The security level Strict further prevents injection of file paths with critical suffixes (e.g.,.exe). For parameter values: The security level Basic prevents directory traversal and injection of certain critical files (e.g.,/etc/passwd). The security level Standard prevents injection of known top-level directory paths (e.g.,/etc/) and critical protocol schemes (e.g.,“php://”). The security level Strict further prevents injection of file paths with critical suffixes (e.g.,.exe) any absolute Windows and UNIX directory path, any protocol scheme or path in universal naming convention format. LDAP LDAP Injection in Header and Parameter Value Prevents LDAP(Lightweight Directory Access Protocol) query injection in header and parameter values. In an LDAP injection an attacker tries to leak or modify sensitive data represented in a LDAP data store. This is possible when an application accesses data using LDAP search filters containing unsanitized user input. Security level Standard prevents the injection of new logical operations NOT, AND, OR. The security level Strict further prevents injecting new comparison operations e.g.,’equal to’, or ‘greater than or equal to’. NOSQL NoSQL Injection in Header Value and Parameter Name and Value Prevents NoSQL injection in header values, parameter names and values on security level Standard and Strict. For a more detailed explanation of query injections, see the SQL description. As a simplified example of a NOSQL injection, consider an unsecure login form where users can input their username and password. The user input is passed to the MongoDB query db.users.find({username: \u003cUSER_INPUT.username\u003e, password: \u003cUSER_INPUT.password\u003e}) An attacker can enter the username admin and the password {$ne: \"\"} to construct the query db.users.find({username: admin, password: {$ne: \"\"}}) which will return the first document where username is admin and the password is non-empty. This way the attacker can bypass the login and enter the website without knowing the password. The security levels Standard and Strict prevent the injection of keywords, functions, and operators of common NoSQL databases (e.g.,MongoDB). In particular, they prevent injection attempts that are part of JSON objects or PHP arrays,. OGNL Object Graph Navigation Library (OGNL) injection (Apache Struts) Prevents OGNL injection on all security levels. Similar to other injection attacks, e.g.,SQL injection, in an OGNL injection attack, an attacker sends malicious requests containing OGNL expressions to a vulnerable application. If the application uses OGNL to handle unvalidated user input, the OGNL expressions in the request are interpreted, which may result in arbitrary code execution, data theft, or other security concerns. PHP PHP Injection in Header Value and Parameter Value Prevents PHP code injection in header and parameter values. Similar to other injection attacks, e.g.,SQL injection or UNIX command injection, a PHP code injection attack can occur when unsanitized user input is forwarded to a system that interprets PHP. In particular, by injecting PHP script tags (e.g.,\u003c?php ... ?\u003e) an attacker might be able to execute arbitrary PHP code on the server. All security levels prevent the injection of standard PHP script tags. Additionally, security level Standard and Strict prevent injection of shortened and legacy PHP script tags. PROTOCOL HTTP Protocol Integrity Prevents HTTP response splitting by blocking injection of an HTML response body or response header. HTTP response splitting can occur when user input from an HTTP request is returned in the HTTP response without being validated. As an example, imagine a website that allows users to set a cookie (using the set-cookie parameter), which is returned in the headers of the HTTP response: https://www.some-website.com/?set-cookie=something If an attacker can insert carriage return and line feed characters, they are able insert new headers, write a response body, or create a second malicious HTTP response entirely. Using HTTP response splitting an attacker may perform cross-site scripting, web cache poisoning, or similar attacks. SANITY Sanity of Header and Parameter Prevents injection of non-printable and special encoded characters, as well as invalid unicode and formats in header names and values. SCANNING Automated Scanning Prevents automated scanning with standard tools by blocking associated headers and parameters which are used to probe an application. Activated on all security levels. SQL SQL Injection (SQLi) in Header and Parameter Value Prevents SQL injection for header and parameter values. In an SQL injection attack, an attacker tries to execute malicious SQL queries in order to leak or corrupt sensitive data. This is possible when an application forwards unsafe and improperly sanitized user input to a database. As an example of a SQL injection attack one can imagine an online shop’s website. Users can input text into a search bar to find items in the inventory. The search bar forwards the user input to its inventory database with the following statement: SELECT * FROM inventory WHERE item_name = \"\u003cuser input\u003e\"; An attacker could exploit this using the attack payload \"; DROP TABLE inventory; -- which would result in the execution of the following two queries and thus the deletion of the inventory: SELECT * FROM inventory WHERE item_name = \"\"; DROP TABLE inventory; --\"; When user input is placed inside quotes like in the example above, we call that a quoted context. Otherwise, we talk about an unquoted context. In general, it is slightly harder to exploit the quoted context because an attack is interpreted as a simple string unless the attacker “breaks out” of the quotes. The security level Basic prevents injection of - input that tries to terminate a previous statement and adds new SQL statements (e.g.,; DROP TABLE) - set operations (e.g.,UNION SELECT) - SQL statements obfuscated as C-style comments which can be interpreted as regular SQL by MySQL and MariaDB in any context. The security level Standard further prevents injection of SQL sub queries and SQL expressions in quoted context (e.g.,' or 1=1--). The security level Strict further prevents SQLi in unquoted context (e.g.,1 or 1). TEMPLATE Template and Expression Language Injection Prevents template and expression language injections for various client-side and server-side templating engines on security levels Standard and Strict. Template injection is similar to other injection attacks. Template injection vulnerabilites can occur when unsanitized user input is evaluated as part of a template expression. As a simple example consider a website that greets the user with the username parameter provided in a request. \u003ch1\u003eHello \u003c?php echo $_GET['username']; ?\u003e\u003c/h1\u003e An attacker can provide a payload that uses special character (e.g.,{{...}}, ${...}, #{...}, and similar) so that a malicious expression is evaluated by the template engine and an attack is triggered. The security levels Standard and Strict prevent template injection attacks in both client-side frameworks (e.g.,Angular, React, Meteor, etc.) and server-side frameworks (e.g.,Apache Velocity, Java EL, ASP.NET Razor, etc) by recognizing a variety of special characters used in templates of common frameworks. UNIXCMD UNIX Command Injection in Header and Parameter Value Prevents UNIX command injections through HTTP header and parameter values. In an OS command injection attack, the attacker aims to execute arbitrary OS commands on vulnerable hosts. This is possible if an application forwards user-input to a system shell in an unsafe (unsanitized) manner. There are different flavors of command injection attacks, depending on the context where user input is fed to the shell. In a quoted context, the user input is placed inside quotes, usually intended as a parameter for another command. For example, an application on a UNIX system might feed user input to the ls command, like so: ls \"\u003csome user input\u003e\" This is called a quoted context attack, because the injection string is placed inside a quoted context. Consider the input \"; \u003csome command\u003e # which, if placed inside the context, becomes ls \"\"; \u003csome command\u003e #\" \u003csome command\u003e can now be replaced by any command of the attackers choice, and will be executed on the system. In unquoted contexts, the attackers input is directly interpreted as a command, without the need for a context breakout. The security level Basic prevents exploitation of the shellshock bug (also known as bashdoor). The security level Standard prevents injection of (what we consider) critical UNIX commands in quoted context (e.g.,\";cat /etc/password #). Security level Strict additionally blocks a wider range of obfuscated UNIX commands in quoted contexts and prevents command injection in unquoted context (e.g.,; cat /etc/password). WINCMD Windows Command Injection in Header and Parameter Value Prevents Windows command injections through HTTP header and parameter values. For a more detailed explanation of OS command injection, see UNIXCMD. Security level Standard provides protection against Windows command injection in a quoted context. The security level Strict extends this protection to unquoted contexts. XSS Cross-Site Scripting (XSS) in Path, Header and Parameter Value Prevents Cross-Site Scripting attacks for paths, header and parameter values. In a Cross-Site Scripting (XSS) attack, an attacker injects code (often JavaScript) into a website. This code is loaded and executed by unsuspecting users visiting the compromised site. An example is that of a Web Forum where a malicious user creates a post containing carefully designed text. When other users visit the forum, their browsers will interpret the text as JavaScript and execute it. Depending on the injected code, this can lead to session or credential stealing, or malware delivery to the victim’s machine. There are many forms of XSS attacks depending on the position of the injection in the context of the original webpage’s HTML: If the code is injected at a location where it is not directly interpreted as a JavaScript statement, the attack must include additional instructions to indicate that the code should be interpreted as JavaScript. Often, this is achieved using \u003cscript\u003e tags or HTML event handlers, e.g.,onload. In a so-called “quoted context attack” an attacker finds a way to inject directly into a context already interpreted as JavaScript, making the attack much easier to perform. This can happen, if, for example, user input is directly fed into a JavaScript variable: var f = \"\u003csome user input\u003e\" This is called a quoted context attack, because the injection string is placed inside a quoted context. For the attack to succeed, the attacker still needs to perform what is called a “context breakout” to do anything useful. An unquoted context attack occurs when user input is directly interpreted as plain javascript (not inside a variable assignment or similar). This attack is easier to perform and harder to detect than a quoted context attack. The security level Standard prevents injection of JavaScript code in quoted context. The security level Basic prevents injection of \u003cscript\u003e tags and known HTML event handlers. The security level Strict prevents injection of JavaScript code in unquoted context. ",
    "description": "API version v1alpha1",
    "tags": null,
    "title": "DenyRules",
    "uri": "/crds/deny-rules/v1alpha1/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference \u003e EnvoyCluster",
    "content": "microgateway.airlock.com/v1alpha1 EnvoyCluster is an additional Envoy Cluster resource which is added to those defined by the Airlock Microgateway.\n​ Example Default apiVersion: microgateway.airlock.com/v1alpha1 kind: EnvoyCluster metadata: name: envoy-cluster-example-1 spec: value: name: ext-authz connect_timeout: 1s type: LOGICAL_DNS load_assignment: cluster_name: ext-authz endpoints: - lb_endpoints: - endpoint: address: socket_address: address: opa.service.internal port_value: 8099 apiVersion: microgateway.airlock.com/v1alpha1 kind: EnvoyCluster metadata: name: default spec: {} EnvoyCluster Field Type Description Required Default Allowed Values metadata ObjectMeta Refer to Kubernetes API documentation for fields of metadata yes spec object Specification of the desired additional Envoy cluster. no EnvoyCluster.spec Field Type Description Required Default Allowed Values value unstructured Value defines the Envoy Cluster which is added to those configured by the Airlock Microgateway. no ",
    "description": "API version v1alpha1",
    "tags": null,
    "title": "EnvoyCluster",
    "uri": "/crds/envoy-cluster/v1alpha1/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference \u003e EnvoyConfiguration",
    "content": "microgateway.airlock.com/v1alpha1 EnvoyConfiguration is the Schema for the envoyconfigurations API Warning EnvoyConfiguration resources may contain sensitive information and thus RBAC permissions should be granted with care. Note This CRD is used for internal purposes. EnvoyConfiguration resources are not intended to be manually created, modified or deleted by the user.\nEnvoyConfiguration Field Type Description Required Default Allowed Values metadata ObjectMeta Refer to Kubernetes API documentation for fields of metadata yes spec object yes status object yes EnvoyConfiguration.spec Field Type Description Required Default Allowed Values envoyResources object EnvoyResources defines the desired state for each resource type. no nodeID string NodeID defines the ID of the envoy node yes EnvoyConfiguration.spec.envoyResources Field Type Description Required Default Allowed Values clusters unstructured[] no endpoints unstructured[] no extensions unstructured[] no listeners unstructured[] no routes unstructured[] no runtimes unstructured[] no scopedRoutes unstructured[] no secrets unstructured[] no EnvoyConfiguration.status Field Type Description Required Default Allowed Values conditions object[] no status string yes xds object yes EnvoyConfiguration.status.conditions[] Field Type Description Required Default Allowed Values lastTransitionTime string (timestamp) Last time the condition transitioned from one status to another. no rfc3339 timestamp message string A human-readable message indicating details about the transition. no reason string The reason for the condition’s last transition. no status enum Status of the condition, one of True, False, Unknown. yes True, False, Unknown type string Type of EnvoyConfiguration condition. yes EnvoyConfiguration.status.xds Field Type Description Required Default Allowed Values resourceTypes map[string]object ResourceTypes defines the sync statuses for each resource type. no version int Version defines the version of the underlying xDS snapshot. yes [-9223372036854775808, 9223372036854775807] EnvoyConfiguration.status.xds.resourceTypes[] Field Type Description Required Default Allowed Values errorMessage string ErrorMessage defines an optional message why the currently served resources of this resource type are rejected by the client. no resources map[string]object Resources defines the resources which are currently served for this resource type. yes status string Status defines the current sync status of this resource type. yes version string Version defines the version which is currently served for this resource type. yes EnvoyConfiguration.status.xds.resourceTypes[].resources[] Field Type Description Required Default Allowed Values version string Version defines the version which is currently served for this resource. yes ",
    "description": "API version v1alpha1",
    "tags": null,
    "title": "EnvoyConfiguration",
    "uri": "/crds/envoy-configuration/v1alpha1/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference \u003e EnvoyHTTPFilter",
    "content": "microgateway.airlock.com/v1alpha1 EnvoyHTTPFilter is an additional Envoy HTTP Filter resource which is added to those defined by the Airlock Microgateway.\n​ Example Default apiVersion: microgateway.airlock.com/v1alpha1 kind: EnvoyHTTPFilter metadata: name: envoy-http-filter-example-1 spec: value: name: envoy.filters.http.ext_authz typed_config: \"@type\": type.googleapis.com/envoy.extensions.filters.http.ext_authz.v3.ExtAuthz http_service: path_prefix: \"/auth/login\" server_uri: uri: http://opa.service.internal:8099 cluster: ext-authz timeout: 0.25s apiVersion: microgateway.airlock.com/v1alpha1 kind: EnvoyHTTPFilter metadata: name: default spec: {} EnvoyHTTPFilter Field Type Description Required Default Allowed Values metadata ObjectMeta Refer to Kubernetes API documentation for fields of metadata yes spec object Specification of the desired additional Envoy HTTP filter. no EnvoyHTTPFilter.spec Field Type Description Required Default Allowed Values value unstructured Value defines the HTTP filter which is added to those configured by the Airlock Microgateway. no ",
    "description": "API version v1alpha1",
    "tags": null,
    "title": "EnvoyHTTPFilter",
    "uri": "/crds/envoy-http-filter/v1alpha1/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference \u003e HeaderRewrites",
    "content": "microgateway.airlock.com/v1alpha1 HeaderRewrites is the Schema for the headerrewrites API\n​ Example Default apiVersion: microgateway.airlock.com/v1alpha1 kind: HeaderRewrites metadata: name: header-rewrites-example spec: request: allow: matchingHeaders: # Drop all request headers except \"X-CSRF-TOKEN\" and those in the built-in # standard header allow list (Accept, Cookie, etc.) to reduce the attack surface. builtIn: standardHeaders: true custom: - name: Allow X-CSRF-Token header headers: - name: matcher: exact: X-CSRF-TOKEN remove: # Remove the \"X-Forwarded-Host\" header and those in the built-in # alternative forwarded headers list from the request. builtIn: alternativeForwardedHeaders: true custom: - name: Remove X-Forwarded-Host headers: - name: matcher: exact: X-Forwarded-Host add: # Inject a custom header into the request. custom: - name: Add headers with TLS information of the downstream connection headers: - name: X-TLS-DOWNSTREAM-PEER-CERT value: \"%DOWNSTREAM_PEER_CERT%\" mode: OverwriteOrAdd response: allow: # Allow all response headers. allHeaders: {} remove: # Remove the headers in the built-in auth basic list from the response. builtIn: auth: basic: true add: # Inject a custom header into the response. custom: - name: Add application version as header headers: - name: X-APP-VERSION value: \"3.7.4\" mode: OverwriteOrAdd apiVersion: microgateway.airlock.com/v1alpha1 kind: HeaderRewrites metadata: name: default spec: settings: operationalMode: Production request: allow: matchingHeaders: builtIn: standardHeaders: true remove: builtIn: alternativeForwardedHeaders: true add: {} response: allow: allHeaders: {} remove: builtIn: informationLeakage: server: true application: true auth: basic: false ntlm: true negotiate: true permissiveCors: true add: builtIn: xFrameOptions: true hsts: true hstsPreload: false csp: true xContentTypeOptions: true referrerPolicy: true featurePolicy: false permissionsPolicy: true HeaderRewrites Field Type Description Required Default Allowed Values metadata ObjectMeta Refer to Kubernetes API documentation for fields of metadata yes spec object Specification of the desired header rewriting behavior. no HeaderRewrites.spec Field Type Description Required Default Allowed Values request object Request defines manipulations on upstream request headers. no response object Response defines manipulations on upstream response headers. no settings object Settings configures the HeaderRewrites filter. no HeaderRewrites.spec.request Field Type Description Required Default Allowed Values add object Add defines which request headers will be added before forwarding to the upstream. no allow object Allow defines which request headers will be forwarded to the upstream. This can either be allHeaders or matchingHeaders. Default: matchingHeaders: {…} no matchingHeaders{...} allHeaders{}, matchingHeaders{} remove object Remove defines which request headers will be removed before forwarding to the upstream. no HeaderRewrites.spec.request.add Field Type Description Required Default Allowed Values custom object[] Custom allows configuring additional upstream request headers. Add selected headers. no HeaderRewrites.spec.request.add.custom[] Field Type Description Required Default Allowed Values headers object[] Headers to add. yes mode enum Mode defines the header addition strategy. no AddIfAbsent AddIfAbsent, OverwriteOrAdd name string Name describing the configured operation. yes HeaderRewrites.spec.request.add.custom[].headers[] Field Type Description Required Default Allowed Values name string Name defines the name of a header. yes value string Value defines the value of a header. yes HeaderRewrites.spec.request.allow Field Type Description Required Default Allowed Values allHeaders object AllHeaders specifies that all request headers should be forwarded. no matchingHeaders object MatchingHeaders specifies which request headers should be forwarded. no HeaderRewrites.spec.request.allow.matchingHeaders Field Type Description Required Default Allowed Values builtIn object BuiltIn allows configuring a set of predefined upstream request headers. no custom object[] Custom allows configuring additional upstream request headers. no HeaderRewrites.spec.request.allow.matchingHeaders.builtIn Field Type Description Required Default Allowed Values standardHeaders bool StandardHeaders defines whether the request headers which are forwarded to the upstream will be restricted to a set of common request headers. Allows headers: Accept Accept-Charset Accept-Language Access-Control-Request-Headers Access-Control-Request-Method Authorization Cache-Control Content-Length Content-Type Connection (if value matches: Upgrade) Cookie DNT Host If-Match If-Modified-Since If-None-Match If-Range If-Unmodified-Since Last-Event-ID Origin Pragma Range Referer Sec-Metadata Sec-WebSocket-Extensions Sec-WebSocket-Key Sec-WebSocket-Protocol Sec-WebSocket-Version SOAPAction UA-CPU Upgrade (if value matches: websocket) Upgrade-Insecure-Requests User-Agent Via X-Correlation-ID X-Do-Not-Track X-Requested-With X-Request-ID X-Same-Domain X-WAP-Profile X-WAP-Profile-Diff no true true, false HeaderRewrites.spec.request.allow.matchingHeaders.custom[] Field Type Description Required Default Allowed Values headers object[] Headers to allow. yes name string Name describing the configured operation. Must be unique. yes HeaderRewrites.spec.request.allow.matchingHeaders.custom[].headers[] Field Type Description Required Default Allowed Values name object Name defines the name of a header. no value object Value defines the value of a header. no HeaderRewrites.spec.request.allow.matchingHeaders.custom[].headers[].name Field Type Description Required Default Allowed Values matcher object Matcher defines the way to match a string. In comparison to a normal StringMatcher, a value is always matched ignoring the case and can’t be inverted. yes exact{}, prefix{}, suffix{}, regex{}, contains{} HeaderRewrites.spec.request.allow.matchingHeaders.custom[].headers[].name.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no HeaderRewrites.spec.request.allow.matchingHeaders.custom[].headers[].value Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} HeaderRewrites.spec.request.allow.matchingHeaders.custom[].headers[].value.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no HeaderRewrites.spec.request.remove Field Type Description Required Default Allowed Values builtIn object BuiltIn allows configuring a set of predefined upstream request headers. no custom object[] Custom allows configuring additional upstream request headers. no HeaderRewrites.spec.request.remove.builtIn Field Type Description Required Default Allowed Values alternativeForwardedHeaders bool AlternativeForwardedHeaders removes downstream request headers which could potentially be abused to alter the upstream’s view of the remote connection. Removes headers: Front-End-Https no true true, false HeaderRewrites.spec.request.remove.custom[] Field Type Description Required Default Allowed Values headers object[] Headers to remove. yes name string Name describing the configured operation. Must be unique. yes HeaderRewrites.spec.request.remove.custom[].headers[] Field Type Description Required Default Allowed Values name object Name defines the name of a header. no value object Value defines the value of a header. no HeaderRewrites.spec.request.remove.custom[].headers[].name Field Type Description Required Default Allowed Values matcher object Matcher defines the way to match a string. In comparison to a normal StringMatcher, a value is always matched ignoring the case and can’t be inverted. yes exact{}, prefix{}, suffix{}, regex{}, contains{} HeaderRewrites.spec.request.remove.custom[].headers[].name.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no HeaderRewrites.spec.request.remove.custom[].headers[].value Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} HeaderRewrites.spec.request.remove.custom[].headers[].value.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no HeaderRewrites.spec.response Field Type Description Required Default Allowed Values add object Add defines which response headers will be added before forwarding to the downstream. no allow object Allow defines which response headers will be forwarded to the downstream. This can either be allHeaders or matchingHeaders. Default: allHeaders: {} no allHeaders{...} allHeaders{}, matchingHeaders{} remove object Remove defines which response headers will be removed before forwarding to the downstream. no HeaderRewrites.spec.response.add Field Type Description Required Default Allowed Values builtIn object BuiltIn allows configuring a set of predefined upstream response headers. no custom object[] Custom allows configuring additional upstream response headers. no HeaderRewrites.spec.response.add.builtIn Field Type Description Required Default Allowed Values csp bool CSP sets a content security policy which allows only same-origin requests except for images if the ‘Content-Security-Policy’ header is not set by the upstream. Adds missing headers: Content-Security-Policy: default-src 'self'; img-src * no true true, false featurePolicy bool FeaturePolicy sets a feature policy which prevents cross-origin use of several browser features if the ‘Feature-Policy’ header is not set by the upstream. Deprecated: Use permissionsPolicy instead. Adds missing headers: Feature-Policy: accelerometer 'self'; ambient-light-sensor 'self'; autoplay 'self'; camera 'self'; display-capture 'self'; document-domain 'self'; encrypted-media 'self'; fullscreen 'self'; geolocation 'self'; gyroscope 'self'; magnetometer 'self'; microphone 'self'; midi 'self'; payment 'self'; usb 'self'; xr-spatial-tracking 'self' no false true, false hsts bool HSTS enforces the use of HTTPS if the ‘Strict-Transport-Security’ header is not already set by the upstream. Adds missing headers: Strict-Transport-Security: max-age=16070400 no true true, false hstsPreload bool HSTSPreload enforces the use of HTTPS including for subdomains and enables HSTS preload. Sets headers: Strict-Transport-Security: max-age=31536000; includeSubDomains; preload no false true, false permissionsPolicy bool PermissionsPolicy sets a permissions policy which prevents cross-origin use of several browser features if the ‘Permissions-Policy’ header is not set by the upstream. Adds missing headers: Permissions-Policy: accelerometer=(self), ambient-light-sensor=(self), autoplay=(self), camera=(self), display-capture=(self), document-domain=(self), encrypted-media=(self), fullscreen=(self), geolocation=(self), gyroscope=(self), magnetometer=(self), microphone=(self), midi=(self), payment=(self), usb=(self), xr-spatial-tracking=(self) no true true, false referrerPolicy bool ReferrerPolicy ensures that no ‘Referer’ header is sent for cross-origin requests if the ‘Referrer-Policy’ header is not set by the upstream. Adds missing headers: Referrer-Policy: same-origin no true true, false xContentTypeOptions bool XContentTypeOptions sets ‘X-Content-Type-Options’ to ’nosniff’ if it is not set by the upstream. Adds missing headers: X-Content-Type-Options: nosniff no true true, false xFrameOptions bool XFrameOptions sets ‘X-Frame-Options’ to SAMEORIGIN if it is not set by the upstream. Adds missing headers: X-Frame-Options: SAMEORIGIN no true true, false HeaderRewrites.spec.response.add.custom[] Field Type Description Required Default Allowed Values headers object[] Headers to add. yes mode enum Mode defines the header addition strategy. no AddIfAbsent AddIfAbsent, OverwriteOrAdd name string Name describing the configured operation. yes HeaderRewrites.spec.response.add.custom[].headers[] Field Type Description Required Default Allowed Values name string Name defines the name of a header. yes value string Value defines the value of a header. yes HeaderRewrites.spec.response.allow Field Type Description Required Default Allowed Values allHeaders object AllHeaders specifies that all response headers should be forwarded. no matchingHeaders object MatchingHeaders specifies which response headers should be forwarded. no HeaderRewrites.spec.response.allow.matchingHeaders Field Type Description Required Default Allowed Values builtIn object BuiltIn allows configuring a set of predefined upstream response header. no custom object[] Custom allows configuring additional upstream response headers. no HeaderRewrites.spec.response.allow.matchingHeaders.builtIn Field Type Description Required Default Allowed Values standardHeaders bool StandardHeaders defines whether the response headers which are forwarded to the downstream will be restricted to a set of common response headers. Allows headers: Accept-Ranges Access-Control-Allow-Credentials Access-Control-Allow-Headers Access-Control-Allow-Methods Access-Control-Allow-Origin Access-Control-Expose-Headers Access-Control-Max-Age Allow Cache-Control Content-Disposition Content-Encoding Content-Language Content-Length Content-Location Content-MD5 Content-Range Content-Security-Policy Content-Type Date Etag Expires Feature-Policy Permissions-Policy Frame-Options Last-Modified Location Pragma Referrer-Policy Refresh Retry-After Sec-WebSocket-Accept Sec-WebSocket-Extensions Sec-WebSocket-Protocol Sec-WebSocket-Version Strict-Transport-Security Trailer Transfer-Encoding Vary WWW-Authenticate Warning X-Content-Security-Policy X-Content-Type-Options X-Frame-Options X-Permitted-Cross-Domain-Policies X-UA-Compatible X-WAP-Profile-Warning X-WebKit-CSP no false true, false HeaderRewrites.spec.response.allow.matchingHeaders.custom[] Field Type Description Required Default Allowed Values headers object[] Headers to allow. yes name string Name describing the configured operation. Must be unique. yes HeaderRewrites.spec.response.allow.matchingHeaders.custom[].headers[] Field Type Description Required Default Allowed Values name object Name defines the name of a header. no value object Value defines the value of a header. no HeaderRewrites.spec.response.allow.matchingHeaders.custom[].headers[].name Field Type Description Required Default Allowed Values matcher object Matcher defines the way to match a string. In comparison to a normal StringMatcher, a value is always matched ignoring the case and can’t be inverted. yes exact{}, prefix{}, suffix{}, regex{}, contains{} HeaderRewrites.spec.response.allow.matchingHeaders.custom[].headers[].name.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no HeaderRewrites.spec.response.allow.matchingHeaders.custom[].headers[].value Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} HeaderRewrites.spec.response.allow.matchingHeaders.custom[].headers[].value.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no HeaderRewrites.spec.response.remove Field Type Description Required Default Allowed Values builtIn object BuiltIn allows configuring a set of predefined upstream response headers. no custom object[] Custom allows configuring additional upstream response headers. no HeaderRewrites.spec.response.remove.builtIn Field Type Description Required Default Allowed Values auth object Auth defines the categories of headers concerning authentication. no informationLeakage object InformationLeakage defines the categories of headers concerning information leakage. no permissiveCors bool PermissiveCORS removes upstream response headers for CORS (Cross-Origin Resource Sharing) which have no restrictions and therefore reduce client-side security. Removes headers: Access-Control-Allow-Origin (if value matches: (?i:^[[:blank:]]*\\*[[:blank:]]*$)) no true true, false HeaderRewrites.spec.response.remove.builtIn.auth Field Type Description Required Default Allowed Values basic bool Basic removes upstream response headers that advise clients to authenticate with Basic Authentication. Removes headers: WWW-Authenticate (if value matches: (?i:^Basic.*)) no false true, false ntlm bool NTLM removes upstream response headers that advise clients to authenticate with NTLM. By default, these headers are removed, because NTLM pass-through is not supported. Removes headers: WWW-Authenticate (if value matches: (?i:^NTLM.*)) no true true, false negotiate bool Negotiate removes upstream response headers that advise clients to authenticate with Negotiate. Removes headers: WWW-Authenticate (if value matches: (?i:^Negotiate.*)) no true true, false HeaderRewrites.spec.response.remove.builtIn.informationLeakage Field Type Description Required Default Allowed Values application bool Application removes upstream response headers that leak information about the deployed software. Removes headers: X-AspNet-Version X-AspNetMvc-Version X-Generator X-Powered-By no true true, false server bool Server removes upstream response headers that leak information about the server. Removes headers: Age Link P3P Proxy-Authenticate Server Via no true true, false HeaderRewrites.spec.response.remove.custom[] Field Type Description Required Default Allowed Values headers object[] Headers to remove. yes name string Name describing the configured remove operation. Must be unique. yes HeaderRewrites.spec.response.remove.custom[].headers[] Field Type Description Required Default Allowed Values name object Name defines the name of a header. no value object Value defines the value of a header. no HeaderRewrites.spec.response.remove.custom[].headers[].name Field Type Description Required Default Allowed Values matcher object Matcher defines the way to match a string. In comparison to a normal StringMatcher, a value is always matched ignoring the case and can’t be inverted. yes exact{}, prefix{}, suffix{}, regex{}, contains{} HeaderRewrites.spec.response.remove.custom[].headers[].name.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no HeaderRewrites.spec.response.remove.custom[].headers[].value Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} HeaderRewrites.spec.response.remove.custom[].headers[].value.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no HeaderRewrites.spec.settings Field Type Description Required Default Allowed Values operationalMode enum OperationalMode defines the behavior of the filter. In integration mode more information is logged about the requests and responses. no Production Production, Integration ",
    "description": "API version v1alpha1",
    "tags": null,
    "title": "HeaderRewrites",
    "uri": "/crds/header-rewrites/v1alpha1/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference \u003e IdentityPropagation",
    "content": "microgateway.airlock.com/v1alpha1 IdentityPropagation specifies the desired identity propagation.\n​ Example Default apiVersion: microgateway.airlock.com/v1alpha1 kind: IdentityPropagation metadata: name: identity-propagation-example spec: header: name: X-USER-NAME value: source: oidc: idToken: claim: \"name\" apiVersion: microgateway.airlock.com/v1alpha1 kind: IdentityPropagation metadata: name: default IdentityPropagation Field Type Description Required Default Allowed Values metadata ObjectMeta Refer to Kubernetes API documentation for fields of metadata yes spec object Specification of the desired identity propagation. yes header{} IdentityPropagation.spec Field Type Description Required Default Allowed Values header object Header configures identity propagation via a request header. no IdentityPropagation.spec.header Field Type Description Required Default Allowed Values name string Name of the header to set. yes value object Value to propagate to the application. yes IdentityPropagation.spec.header.value Field Type Description Required Default Allowed Values source object Source from which to extract the value. yes metadata{}, oidc{} IdentityPropagation.spec.header.value.source Field Type Description Required Default Allowed Values metadata object Metadata specifies to extract a value from an Envoy dynamic filter metadata key. no oidc object OIDC specifies to extract a value from the result of an OpenID Connect flow. no IdentityPropagation.spec.header.value.source.metadata Field Type Description Required Default Allowed Values key string Key specifies the metadata key from which to load the value, e.g. some_payload.aud. yes namespace string Namespace specifies the metadata namespace within which the lookup should be performed, e.g. envoy.filters.http.jwt_authn. yes IdentityPropagation.spec.header.value.source.oidc Field Type Description Required Default Allowed Values idToken object IDToken specifies to extract the value from the OpenID Connect ID Token. yes IdentityPropagation.spec.header.value.source.oidc.idToken Field Type Description Required Default Allowed Values claim string Claim selects the JWT claim from which to extract the value. yes ",
    "description": "API version v1alpha1",
    "tags": null,
    "title": "IdentityPropagation",
    "uri": "/crds/identity-propagation/v1alpha1/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference \u003e Limits",
    "content": "microgateway.airlock.com/v1alpha1 Limits contains the configuration for limits.\n​ Example Default apiVersion: microgateway.airlock.com/v1alpha1 kind: Limits metadata: name: limits-example spec: settings: threatHandlingMode: Block request: limited: general: # Reduce the parsed body size to '10Ki' to increase security. bodySize: 10Ki pathLength: 1Ki parameter: count: 128 nameLength: 128 # Reduce the maximum length to '1Ki'. valueLength: 1Ki json: nestingDepth: 100 keyCount: 250 elementCount: 150000 keyLength: 128 valueLength: 8Ki exceptions: # Length exception for the JSON attribute $.logo when the path has prefix /project/ - length: json: jsonPath: \"$.logo\" requestConditions: path: matcher: prefix: /project/ # Length exception for the post parameter txtbdy - length: parameter: name: matcher: exact: txtbdy source: Post apiVersion: microgateway.airlock.com/v1alpha1 kind: Limits metadata: name: default spec: settings: threatHandlingMode: Block request: limited: general: bodySize: \"100Ki\" pathLength: \"1Ki\" parameter: count: 128 nameLength: \"128\" valueLength: \"8Ki\" json: nestingDepth: 100 keyCount: 250 elementCount: 10000 keyLength: \"128\" valueLength: \"8Ki\" Limits Field Type Description Required Default Allowed Values metadata ObjectMeta Refer to Kubernetes API documentation for fields of metadata yes spec object Specification of the desired limits behavior. no Limits.spec Field Type Description Required Default Allowed Values request object Request defines the limits for requests. no limited{...} unlimited{}, limited{} settings object Settings configures the limits filter. no Limits.spec.request Field Type Description Required Default Allowed Values limited object Limited enables limits on request scope. no unlimited object Unlimited disables all limits on request scope. no Limits.spec.request.limited Field Type Description Required Default Allowed Values exceptions object[] Exceptions defines limit exceptions. no general object General defines general request limits. no json object JSON defines the limits for JSON requests. no parameter object Parameter defines the limits for request parameters. no Limits.spec.request.limited.exceptions[] Field Type Description Required Default Allowed Values length object Length defines an exception for length limits based on the data element exceeding the limit. no parameter{}, json{} requestConditions object RequestConditions defines additional request properties which must be matched in order for this exception to apply. no Limits.spec.request.limited.exceptions[].length Field Type Description Required Default Allowed Values json object JSON defines a key and value length limit exception for a JSON property. no parameter object Parameter defines a name and value length limit exception for a parameter. no Limits.spec.request.limited.exceptions[].length.json Field Type Description Required Default Allowed Values jsonPath string JSONPath restricts the exception to JSON properties with a matching JSONPath. Expressions in JSONPath i.e. ?(expr) are not supported. yes Limits.spec.request.limited.exceptions[].length.parameter Field Type Description Required Default Allowed Values name object Name restricts the exception to parameters with a matching name. yes source enum Source restricts the exception to parameters of this kind. no Any Query, Post, Any Limits.spec.request.limited.exceptions[].length.parameter.name Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} Limits.spec.request.limited.exceptions[].length.parameter.name.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no Limits.spec.request.limited.exceptions[].requestConditions Field Type Description Required Default Allowed Values header object Header defines the matching headers of a request. no invert bool Invert indicates whether the request condition should be inverted. no false true, false mediaType object MediaType defines the matching media type from the content-type header of a request. no method enum[] Method defines the matching methods of a request. no GET, HEAD, POST, PUT, PATCH, DELETE, CONNECT, OPTIONS, TRACE path object Path defines the matching path of a request. no remoteIP object RemoteIP defines the matching remote IPs of a request. no Limits.spec.request.limited.exceptions[].requestConditions.header Field Type Description Required Default Allowed Values name object Name defines the name of a header. no value object Value defines the value of a header. no Limits.spec.request.limited.exceptions[].requestConditions.header.name Field Type Description Required Default Allowed Values matcher object Matcher defines the way to match a string. In comparison to a normal StringMatcher, a value is always matched ignoring the case and can’t be inverted. yes exact{}, prefix{}, suffix{}, regex{}, contains{} Limits.spec.request.limited.exceptions[].requestConditions.header.name.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no Limits.spec.request.limited.exceptions[].requestConditions.header.value Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} Limits.spec.request.limited.exceptions[].requestConditions.header.value.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no Limits.spec.request.limited.exceptions[].requestConditions.mediaType Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} Limits.spec.request.limited.exceptions[].requestConditions.mediaType.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no Limits.spec.request.limited.exceptions[].requestConditions.path Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} Limits.spec.request.limited.exceptions[].requestConditions.path.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no Limits.spec.request.limited.exceptions[].requestConditions.remoteIP Field Type Description Required Default Allowed Values cidrRanges string[] CIDRRanges defines the IPv4 or IPv6 CIDR ranges, e.g. 196.148.3.128/26 or 2001:db8::/28. yes invert bool Invert indicates whether the match should be inverted. no false true, false Limits.spec.request.limited.general Field Type Description Required Default Allowed Values bodySize Quantity BodySize limits the total size of the request body. It specifies the number of bytes (0 = unlimited). This limit is effective only for requests that are parsed (e.g. JSON data). File uploads are not affected by this limit. no 100Ki pathLength Quantity PathLength defines the maximum path length for requests. no 1Ki Limits.spec.request.limited.json Field Type Description Required Default Allowed Values elementCount uint64 ElementCount defines the maximum number of keys and array items in the whole JSON document (recursive). no 10000 [0, 18446744073709551615] keyCount uint64 KeyCount defines the maximum number of keys of a single JSON object (non-recursive). no 250 [0, 18446744073709551615] keyLength Quantity KeyLength defines the maximum length for JSON keys. no 128 nestingDepth uint64 NestingDepth defines the maximum depth of nesting for JSON objects and JSON arrays. no 100 [0, 18446744073709551615] valueLength Quantity ValueLength defines the maximum length for JSON values. no 8Ki Limits.spec.request.limited.parameter Field Type Description Required Default Allowed Values count uint64 Count defines the maximum number of request parameters. no 128 [0, 18446744073709551615] nameLength Quantity NameLength defines the maximum length for parameter names. no 128 valueLength Quantity ValueLength defines the maximum length for parameter values. no 8Ki Limits.spec.settings Field Type Description Required Default Allowed Values threatHandlingMode enum ThreatHandlingMode specifies how threats should be handled when a limit hits. no Block Block, LogOnly ",
    "description": "API version v1alpha1",
    "tags": null,
    "title": "Limits",
    "uri": "/crds/limits/v1alpha1/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference \u003e OIDCProvider",
    "content": "microgateway.airlock.com/v1alpha1 OIDCProvider specifies an OpenID Provider (OP).\nWarning The OIDC feature is currently in an experimental state.\nWe encourage you to try it out and give feedback, but be aware that we do not recommend using it in a production environment yet, as security has not yet been hardened.\nIn particular, the current implementation has the following limitations, which we intend to address in future Microgateway releases:\nThe state parameter is guessable. ID token and access token are stored in cookies and are thus sent to the accessing client. ​ Example Default apiVersion: microgateway.airlock.com/v1alpha1 kind: OIDCProvider metadata: name: oidc-provider-example spec: static: endpoints: authorization: uri: https://iam.airlock.com/authorize token: uri: https://iam.airlock.com/token apiVersion: microgateway.airlock.com/v1alpha1 kind: OIDCProvider metadata: name: default OIDCProvider Field Type Description Required Default Allowed Values metadata ObjectMeta Refer to Kubernetes API documentation for fields of metadata yes spec object Specification of an OpenID Provider. yes static{} OIDCProvider.spec Field Type Description Required Default Allowed Values static object Static configures an OpenID Provider by explicitly specifying all endpoints. no OIDCProvider.spec.static Field Type Description Required Default Allowed Values endpoints object Endpoints specifies the OpenID Provider endpoints. yes OIDCProvider.spec.static.endpoints Field Type Description Required Default Allowed Values authorization object Authorization specifies the endpoint to which the authorization request is sent. yes token object Token configures the endpoint from which the access, ID and refresh tokens are obtained. yes OIDCProvider.spec.static.endpoints.authorization Field Type Description Required Default Allowed Values uri string URI specifies the endpoint address. yes OIDCProvider.spec.static.endpoints.token Field Type Description Required Default Allowed Values tls object TLS defines TLS settings. no uri string URI specifies the endpoint address. yes OIDCProvider.spec.static.endpoints.token.tls Field Type Description Required Default Allowed Values certificateVerification object CertificateVerification specifies how the certificate presented by the server is verified. no publicCAs{...} disabled{}, publicCAs{}, custom{} ciphers string[] Ciphers defines a list of the supported TLS cipher suites. For details on cipher list refer to the envoy documentation on cipher_suites in common tls configuration. no protocol object Protocol defines the supported TLS protocol versions. no OIDCProvider.spec.static.endpoints.token.tls.certificateVerification Field Type Description Required Default Allowed Values custom object Custom explicitly specifies how the server certificate should be verified. Typical use cases include specifying a custom CA and SAN match when working with self-signed certificates or pinning a specific public key. no disabled object Disabled specifies to trust any certificate without verification. THIS IS INSECURE AND SHOULD ONLY BE USED FOR TESTING. no publicCAs object PublicCAs specifies to only accept certificates with a SAN matching “uri” and which are signed by a CA which is either directly or indirectly trusted by any of the root CA certificates shipped with the Airlock Microgateway Engine’s base image. no OIDCProvider.spec.static.endpoints.token.tls.certificateVerification.custom Field Type Description Required Default Allowed Values allowedSANs object[] AllowedSANs is a list of matchers to verify the Subject Alternative name. If specified, it will verify that the Subject Alternative Name of the presented certificate matches one of the specified matchers. The matching uses “any” semantics, that is to say, the SAN is verified if at least one matcher is matched. AllowedSANs requires trustedCA to be set. no crl object CRL defines the Certificate Revocation List (CRL) settings. no certificatePinning object CertificatePinning defines constraints the presented certificate must fulfill. If more than one constraint is configured only one must be satisfied. At least one of allowedSPKIs and allowedHashes must be set. no trustedCA object TrustedCA defines which CA certificates are trusted. no OIDCProvider.spec.static.endpoints.token.tls.certificateVerification.custom.allowedSANs[] Field Type Description Required Default Allowed Values matcher object Matcher defines the string matcher for the SAN value. yes exact{}, prefix{}, suffix{}, regex{}, contains{} sanType enum SanType defines the type of SAN matcher. yes DNS, Email, URI, IPAddress OIDCProvider.spec.static.endpoints.token.tls.certificateVerification.custom.allowedSANs[].matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no OIDCProvider.spec.static.endpoints.token.tls.certificateVerification.custom.crl Field Type Description Required Default Allowed Values lists object[] Lists defines the list of secretRefs containing Certificate Revocation Lists. no validationMode enum ValidationMode defines whether only the leaf certificate or also the CA certs should be checked. no VerifyChain VerifyLeafCertOnly, VerifyChain OIDCProvider.spec.static.endpoints.token.tls.certificateVerification.custom.crl.lists[] Field Type Description Required Default Allowed Values secretRef object SecretRef defines the reference to a secret containing one or more CRL’s (in PEM format) under the key ‘ca.crl’. yes OIDCProvider.spec.static.endpoints.token.tls.certificateVerification.custom.crl.lists[].secretRef Field Type Description Required Default Allowed Values name string Name of the resource yes OIDCProvider.spec.static.endpoints.token.tls.certificateVerification.custom.certificatePinning Field Type Description Required Default Allowed Values allowedHashes string[] AllowedHashes is a list of hex-encoded SHA-256 hashes. If specified, it will verify that the SHA-256 of the DER-encoded presented certificate matches one of the specified values. no allowedSPKIs string[] AllowedSPKIs is a list of base64-encoded SHA-256 hashes. If specified, it will verify that the SHA-256 of the DER-encoded Subject Public Key Information (SPKI) of the presented certificate matches one of the specified values. no OIDCProvider.spec.static.endpoints.token.tls.certificateVerification.custom.trustedCA Field Type Description Required Default Allowed Values certificates object[] Certificates defines the list of secretRefs containing trusted CA certificates. yes verificationDepth uint32 VerificationDepth specifies the hops in the certificate chain at which validation is performed. 1 means that either the leaf or the signing CA must be in the set of trusted certificates. no 1 [0, 4294967295] OIDCProvider.spec.static.endpoints.token.tls.certificateVerification.custom.trustedCA.certificates[] Field Type Description Required Default Allowed Values secretRef object SecretRef defines the reference to a secret containing one or more CA certificates under the key ‘ca.crt’. yes OIDCProvider.spec.static.endpoints.token.tls.certificateVerification.custom.trustedCA.certificates[].secretRef Field Type Description Required Default Allowed Values name string Name of the resource yes OIDCProvider.spec.static.endpoints.token.tls.protocol Field Type Description Required Default Allowed Values maximum enum Maximum supported TLS version. no TLSv1_0, TLSv1_1, TLSv1_2, TLSv1_3 minimum enum Minimum supported TLS version. no TLSv1_0, TLSv1_1, TLSv1_2, TLSv1_3 ",
    "description": "API version v1alpha1",
    "tags": null,
    "title": "OIDCProvider",
    "uri": "/crds/oidc-provider/v1alpha1/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference \u003e OIDCRelyingParty",
    "content": "microgateway.airlock.com/v1alpha1 OIDCRelyingParty specifies how the Airlock Microgateway Engine interacts with an OpenID Provider (OP).\nWarning The OIDC feature is currently in an experimental state.\nWe encourage you to try it out and give feedback, but be aware that we do not recommend using it in a production environment yet, as security has not yet been hardened.\nIn particular, the current implementation has the following limitations, which we intend to address in future Microgateway releases:\nThe state parameter is guessable. ID token and access token are stored in cookies and are thus sent to the accessing client. ​ Example Default apiVersion: microgateway.airlock.com/v1alpha1 kind: OIDCRelyingParty metadata: name: oidc-rp-example spec: oidcProviderRef: name: example-provider clientID: my-id credentials: clientSecret: method: BasicAuth secretRef: name: client-password pathMapping: logoutPath: matcher: exact: /logout redirectPath: matcher: exact: /callback redirectURI: \"%REQ(:x-forwarded-proto)%://%REQ(:authority)%/callback\" apiVersion: microgateway.airlock.com/v1alpha1 kind: OIDCRelyingParty metadata: name: default OIDCRelyingParty Field Type Description Required Default Allowed Values metadata ObjectMeta Refer to Kubernetes API documentation for fields of metadata yes spec object Specification of the OIDC Relying Party configuration. yes OIDCRelyingParty.spec Field Type Description Required Default Allowed Values clientID string ClientID specifies the OIDCRelyingParty “client_id”. yes credentials object Credentials used for client authentication on the back-channel with the authorization server. yes oidcProviderRef object OIDCProviderRef selects the OpenID Provider (OP) used to authenticate users. yes pathMapping object PathMapping configures the action matching. yes redirectURI string RedirectURI configures the “redirect_uri” parameter included in the authorization request. May contain envoy command operators, e.g. ‘%REQ(:x-forwarded-proto)%://%REQ(:authority)%/callback’. yes OIDCRelyingParty.spec.credentials Field Type Description Required Default Allowed Values clientSecret object ClientSecret authenticates with the client password issued by the OpenID Provider (OP). yes OIDCRelyingParty.spec.credentials.clientSecret Field Type Description Required Default Allowed Values method enum Method specifies in which format the client secret is sent with the authorization request. no BasicAuth BasicAuth, FormURLEncoded secretRef object SecretRef specifies the kubernetes secret containing the client password with key “client.secret”. yes OIDCRelyingParty.spec.credentials.clientSecret.secretRef Field Type Description Required Default Allowed Values name string Name of the resource yes OIDCRelyingParty.spec.oidcProviderRef Field Type Description Required Default Allowed Values name string Name of the resource yes OIDCRelyingParty.spec.pathMapping Field Type Description Required Default Allowed Values logoutPath object LogoutPath specifies which request paths should initiate a logout. yes redirectPath object RedirectPath specifies which request paths should be interpreted as a response from the authorization endpoint. yes OIDCRelyingParty.spec.pathMapping.logoutPath Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} OIDCRelyingParty.spec.pathMapping.logoutPath.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no OIDCRelyingParty.spec.pathMapping.redirectPath Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} OIDCRelyingParty.spec.pathMapping.redirectPath.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no ",
    "description": "API version v1alpha1",
    "tags": null,
    "title": "OIDCRelyingParty",
    "uri": "/crds/oidc-relying-party/v1alpha1/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference \u003e OpenAPI",
    "content": "microgateway.airlock.com/v1alpha1 OpenAPI contains the configuration for the OpenAPI specification.\n​ Example Default apiVersion: microgateway.airlock.com/v1alpha1 kind: OpenAPI metadata: name: open-api-example spec: settings: schema: source: configMapRef: name: openapi3-spec threatHandlingMode: Block logging: maxFailedSubvalidations: 10 validation: authentication: oAuth2: allowedParameters: builtIn: standardParameters: true custom: - param1 - param2 oidc: allowedParameters: builtIn: standardParameters: false custom: - param3 - param4 response: unsecured: { } apiVersion: microgateway.airlock.com/v1alpha1 kind: OpenAPI metadata: name: default OpenAPI Field Type Description Required Default Allowed Values metadata ObjectMeta Refer to Kubernetes API documentation for fields of metadata yes spec object Specification of the desired OpenAPI specification. yes OpenAPI.spec Field Type Description Required Default Allowed Values response object Response defines the validation behaviour for responses. no unsecured{...} secured{}, unsecured{} settings object Settings defines the settings to configure OpenAPI specification enforcement. yes OpenAPI.spec.response Field Type Description Required Default Allowed Values secured object Secured enables response checking. no unsecured object Unsecured disables response checking. no OpenAPI.spec.response.secured Field Type Description Required Default Allowed Values validation enum Validation defines the validation mode for responses. no Lax Lax, Strict OpenAPI.spec.settings Field Type Description Required Default Allowed Values logging object Logging specifies the access log behavior. no schema object Schema configures the OpenAPI specification. yes threatHandlingMode enum ThreatHandlingMode specifies how threats should be handled. no Block Block, LogOnly validation object Validation specifies the patterns for the validation behavior. no OpenAPI.spec.settings.logging Field Type Description Required Default Allowed Values maxFailedSubvalidations uint64 MaxFailedSubvalidations defines the maximum number of failed subvalidations being logged. no 10 [0, 18446744073709551615] OpenAPI.spec.settings.schema Field Type Description Required Default Allowed Values source object Source specifies the OpenAPI specification to be enforced. yes configMapRef{} OpenAPI.spec.settings.schema.source Field Type Description Required Default Allowed Values configMapRef object ConfigMapRef references the configmap by its name containing the well-known key ‘openapi.json’. no OpenAPI.spec.settings.schema.source.configMapRef Field Type Description Required Default Allowed Values name string Name of the resource yes OpenAPI.spec.settings.validation Field Type Description Required Default Allowed Values authentication object Authentication defines the settings for the authentication scheme. no OpenAPI.spec.settings.validation.authentication Field Type Description Required Default Allowed Values oAuth2 object OAuth2 specifies the OAuth2 parameters. no oidc object Oidc specifies the OIDC parameters. no OpenAPI.spec.settings.validation.authentication.oAuth2 Field Type Description Required Default Allowed Values allowedParameters object AllowedParameters specifies the allowed parameters for the authentication scheme. no OpenAPI.spec.settings.validation.authentication.oAuth2.allowedParameters Field Type Description Required Default Allowed Values builtIn object BuiltIn allows configuring a set of predefined allowed parameters. no custom string[] Custom allows configuring additional allowed parameters. no OpenAPI.spec.settings.validation.authentication.oAuth2.allowedParameters.builtIn Field Type Description Required Default Allowed Values standardParameters bool StandardParameters defines whether the allowed parameters should be expanded by the set of common parameters. Allows parameters: access_token code error error_description error_uri expires_in id_token scope state token_type no true true, false OpenAPI.spec.settings.validation.authentication.oidc Field Type Description Required Default Allowed Values allowedParameters object AllowedParameters specifies the allowed parameters for the authentication scheme. no OpenAPI.spec.settings.validation.authentication.oidc.allowedParameters Field Type Description Required Default Allowed Values builtIn object BuiltIn allows configuring a set of predefined allowed parameters. no custom string[] Custom allows configuring additional allowed parameters. no OpenAPI.spec.settings.validation.authentication.oidc.allowedParameters.builtIn Field Type Description Required Default Allowed Values standardParameters bool StandardParameters defines whether the allowed parameters should be expanded by the set of common parameters. Allows parameters: access_token code error error_description error_uri expires_in id_token scope state token_type no true true, false ",
    "description": "API version v1alpha1",
    "tags": null,
    "title": "OpenAPI",
    "uri": "/crds/open-api/v1alpha1/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference \u003e Parser",
    "content": "microgateway.airlock.com/v1alpha1 Parser contains the configuration for content parsers (default and custom).\n​ Example Default apiVersion: microgateway.airlock.com/v1alpha1 kind: Parser metadata: name: parser-example spec: request: # Set the content-type to 'application/json' if no content-type header is sent. defaultContentType: application/json parsers: json: enable: true mediaTypePattern: .*json.* form: enable: true mediaTypePattern: .*form-urlencoded.* multipart: enable: true mediaTypePattern: .*multipart.* custom: rules: # The POST request to '/company/contact.php' contains a JSON payload # but has an incorrect content-type header. # These requests should be treated as JSON. - requestConditions: method: - POST path: matcher: exact: /company/contact.php action: parse: json: {} # The request to '/support/upload.php' contains a binary payload # but has an incorrect content-type header 'application/json'. # These requests should not be parsed (security filters such as deny rules, # limits, ... should not be applied). - requestConditions: path: matcher: exact: /support/upload.php action: skip: {} apiVersion: microgateway.airlock.com/v1alpha1 kind: Parser metadata: name: default spec: request: parsers: json: enable: true mediaTypePattern: \".*json.*\" form: enable: true mediaTypePattern: \".*urlencoded.*\" multipart: enable: true mediaTypePattern: \".*multipart.*\" defaultContentType: \"application/x-www-form-urlencoded\" custom: {} Parser Field Type Description Required Default Allowed Values metadata ObjectMeta Refer to Kubernetes API documentation for fields of metadata yes spec object Specification of the desired parser behavior. no Parser.spec Field Type Description Required Default Allowed Values request object Request defines the parsing for downstream requests. no Parser.spec.request Field Type Description Required Default Allowed Values custom object Custom allows configuring additional rules for parser selection. no defaultContentType string DefaultContentType specifies the content-type header which should be injected into the request before parser selection if it is not already present and the request has a body. no application/x-www-form-urlencoded parsers object Parsers defines the configuration for the available content parsers. no Parser.spec.request.custom Field Type Description Required Default Allowed Values rules object[] Rules defines a custom set prepended before built-in rules of enabled request parsers. Disable all built-in parsers to overrule them completely. no Parser.spec.request.custom.rules[] Field Type Description Required Default Allowed Values action object Action specifies what should happen when a request condition matches. Only one of parse or skip can be set. yes parse{}, skip{} requestConditions object RequestConditions defines additional request properties which must be matched in order for this rule to apply. yes Parser.spec.request.custom.rules[].action Field Type Description Required Default Allowed Values parse object Parse activates the configured parser. no json{}, form{}, multipart{} skip object Skip disables any content parsing no Parser.spec.request.custom.rules[].action.parse Field Type Description Required Default Allowed Values form object Form activates the Form parser. no json object JSON activates the JSON parser. no multipart object Multipart activates the multipart parser. no Parser.spec.request.custom.rules[].requestConditions Field Type Description Required Default Allowed Values header object Header defines the matching headers of a request. no invert bool Invert indicates whether the request condition should be inverted. no false true, false mediaType object MediaType defines the matching media type from the content-type header of a request. no method enum[] Method defines the matching methods of a request. no GET, HEAD, POST, PUT, PATCH, DELETE, CONNECT, OPTIONS, TRACE path object Path defines the matching path of a request. no remoteIP object RemoteIP defines the matching remote IPs of a request. no Parser.spec.request.custom.rules[].requestConditions.header Field Type Description Required Default Allowed Values name object Name defines the name of a header. no value object Value defines the value of a header. no Parser.spec.request.custom.rules[].requestConditions.header.name Field Type Description Required Default Allowed Values matcher object Matcher defines the way to match a string. In comparison to a normal StringMatcher, a value is always matched ignoring the case and can’t be inverted. yes exact{}, prefix{}, suffix{}, regex{}, contains{} Parser.spec.request.custom.rules[].requestConditions.header.name.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no Parser.spec.request.custom.rules[].requestConditions.header.value Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} Parser.spec.request.custom.rules[].requestConditions.header.value.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no Parser.spec.request.custom.rules[].requestConditions.mediaType Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} Parser.spec.request.custom.rules[].requestConditions.mediaType.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no Parser.spec.request.custom.rules[].requestConditions.path Field Type Description Required Default Allowed Values matcher object yes exact{}, prefix{}, suffix{}, regex{}, contains{} Parser.spec.request.custom.rules[].requestConditions.path.matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no Parser.spec.request.custom.rules[].requestConditions.remoteIP Field Type Description Required Default Allowed Values cidrRanges string[] CIDRRanges defines the IPv4 or IPv6 CIDR ranges, e.g. 196.148.3.128/26 or 2001:db8::/28. yes invert bool Invert indicates whether the match should be inverted. no false true, false Parser.spec.request.parsers Field Type Description Required Default Allowed Values form object Form defines the configuration for the form parser. no json object JSON defines the configuration for the JSON parser. no multipart object Multipart defines the configuration for the multipart parser. no Parser.spec.request.parsers.form Field Type Description Required Default Allowed Values enable bool Enable defines whether form payloads are inspected. no true true, false mediaTypePattern string MediaTypePattern is a regex specifying the media types for which the request body should be treated as form arguments. no .*urlencoded.* Parser.spec.request.parsers.json Field Type Description Required Default Allowed Values enable bool Enable defines whether json payloads are inspected. no true true, false mediaTypePattern string MediaTypePattern is a regex specifying the media types for which the request body should be treated as JSON. no .*json.* Parser.spec.request.parsers.multipart Field Type Description Required Default Allowed Values enable bool Enable defines whether multipart payloads are inspected. no true true, false mediaTypePattern string MediaTypePattern is a regex specifying the media types for which the request body should be treated as a multipart payload. no .*multipart.* ",
    "description": "API version v1alpha1",
    "tags": null,
    "title": "Parser",
    "uri": "/crds/parser/v1alpha1/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference \u003e SidecarGateway",
    "content": "microgateway.airlock.com/v1alpha1 SidecarGateway contains the configuration how to configure the Airlock Microgateway Engine when used as Sidecar Container within the Pod of an application.\n​ Example Default apiVersion: microgateway.airlock.com/v1alpha1 kind: SidecarGateway metadata: name: sidecar-gateway-example spec: podSelector: matchLabels: # podSelector which matches the example app to protect. app: example-app applications: - containerPort: 8443 routes: # Do not apply any Airlock Microgateway filters # to '/metrics' - pathPrefix: /metrics unsecured: {} - pathPrefix: / secured: accessControlRef: name: access-control-example contentSecurityRef: name: content-security-example downstream: # Configure 'remoteIP' extraction. remoteIP: xff: numTrustedHops: 1 restrictions: http: # Set max Header length to '80Ki' headersLength: 80Ki protocol: # Enable auto mode for http1/http2. auto: {} tls: # Enable TLS for downstream connections on port '8443' enable: true # Use the server certificate from the kubernetes TLS secret 'example-tls-secret' secretRef: name: example-tls-secret protocol: # Require TLS version 1.3 minimum: TLSv1_3 clientCertificate: # Do not require any client certificate ignored: {} xfcc: AlwaysForwardOnly upstream: tls: # Enable TLS for upstream connection on port '8443' enable: true protocol: # Require TLS version 1.2 or higher minimum: TLSv1_2 envoyHTTPFilterRefs: prepend: - name: envoy-http-filter-example-1 telemetryRef: name: telemetry-example envoyClusterRefs: - name: envoy-cluster-example-1 apiVersion: microgateway.airlock.com/v1alpha1 kind: SidecarGateway metadata: name: default SidecarGateway Field Type Description Required Default Allowed Values metadata ObjectMeta Refer to Kubernetes API documentation for fields of metadata yes spec object Specification of the desired sidecar gateway behavior. no status object Most recently observed status of the SidecarGateway which is populated by the system. This data is read-only and may not be up to date. yes SidecarGateway.spec Field Type Description Required Default Allowed Values applications object[] Applications defines applications which run on different ports. yes envoyClusterRefs object[] EnvoyClusterRefs selects the relevant EnvoyClusters. no podSelector object PodSelector defines to which Pods the configuration will be applied to. no SidecarGateway.spec.applications[] Field Type Description Required Default Allowed Values containerPort uint32 ContainerPort refers to the container port. This must be a valid port number, 0 \u003c x \u003c 65536. no 8080 [1, 65535] downstream object Downstream defines the downstream configuration for this application no envoyHTTPFilterRefs object EnvoyHTTPFilterRefs selects the relevant EnvoyHTTPFilters. no routes object[] Routes defines the security configurations for different paths. The first matching route (from top to bottom) applies. no telemetryRef object TelemetryRef selects the relevant Telemetry configuration resource. If undefined, default settings are applied, designed to work with most upstream web application services. no upstream object Upstream defines the upstream configuration for this application no SidecarGateway.spec.applications[].downstream Field Type Description Required Default Allowed Values protocol object Protocol defines the exposed HTTP protocol version. At most one of http1, http2 and auto can be set. Default: auto: {} no auto{...} http1{}, http2{}, auto{} remoteIP object RemoteIP defines how the remote IP of a client is propagated. Default: xff: {…} no xff{...} connectionIP{}, customHeader{}, xff{} requestNormalizations object RequestNormalizations defines a set of normalization actions which are applied to the request before route matching. no restrictions object Restrictions defines restrictions for downstream. no tls object TLS defines the TLS settings. no timeouts object Timeouts defines timeouts for downstream no SidecarGateway.spec.applications[].downstream.protocol Field Type Description Required Default Allowed Values auto object Auto specifies that the protocol should be inferred. no http1 object HTTP1 specifies that the client is assumed to speak HTTP/1.1. no http2 object HTTP2 specifies that the client is assumed to speak HTTP/2. no SidecarGateway.spec.applications[].downstream.protocol.auto Field Type Description Required Default Allowed Values http2 object HTTP2 specifies the settings for when HTTP/2 is inferred. no SidecarGateway.spec.applications[].downstream.protocol.auto.http2 Field Type Description Required Default Allowed Values allowConnect bool Allows proxying Websocket and other upgrades over H2 connect. no false true, false SidecarGateway.spec.applications[].downstream.protocol.http2 Field Type Description Required Default Allowed Values allowConnect bool Allows proxying Websocket and other upgrades over H2 connect. no false true, false SidecarGateway.spec.applications[].downstream.remoteIP Field Type Description Required Default Allowed Values connectionIP object ConnectionIP configures to use the source IP address of the direct downstream connection. no customHeader object CustomHeader specifies to use a custom header for remote IP extraction. no xff object XFF configures to use the standard ‘X-Forwarded-For’ header for IP extraction. no SidecarGateway.spec.applications[].downstream.remoteIP.customHeader Field Type Description Required Default Allowed Values headerName string HeaderName specifies the name of the custom header containing the remote IP. yes required bool Required specifies if the custom header is required. If true and not available the request will be rejected with 403. no true true, false SidecarGateway.spec.applications[].downstream.remoteIP.xff Field Type Description Required Default Allowed Values numTrustedHops uint32 NumTrustedHops specifies to extract the client’s originating IP from the nth rightmost entry in the X-Forwarded-For header. With the default value of 1, the IP is extracted from the rightmost entry. no 1 [1, 4294967295] SidecarGateway.spec.applications[].downstream.requestNormalizations Field Type Description Required Default Allowed Values mergeSlashes bool MergeSlashes ensures that adjacent slashes in the path are merged into one. no true true, false normalizePath bool NormalizePath ensures normalization according to RFC 3986 without case normalization. no true true, false SidecarGateway.spec.applications[].downstream.restrictions Field Type Description Required Default Allowed Values http object HTTP defines limits for the HTTP protocol. no SidecarGateway.spec.applications[].downstream.restrictions.http Field Type Description Required Default Allowed Values headersLength Quantity HeadersLength defines maximum size of all request headers combined. Requests that exceed this limit will receive a 431 response. no 60Ki SidecarGateway.spec.applications[].downstream.tls Field Type Description Required Default Allowed Values ciphers string[] Ciphers defines a list of the supported TLS cipher suites. For details on cipher list refer to the envoy documentation on cipher_suites in common tls configuration. no clientCertificate object ClientCertificate defines the TLS settings for verification of client certificates. At most one of ignored, optional and required can be set. Default: ignored: {} no ignored{...} ignored{}, optional{}, required{} enable bool Enable defines if the downstream connection is encrypted. no false true, false protocol object Protocol defines the supported TLS protocol versions. no secretRef object SecretRef defines the reference to the TLS server certificate (secret of type kubernetes.io/tls). no xfcc enum XFCC defines the handling of X-Forwarded-Client-Cert header. Meaning of the possible values: Sanitize: Do not send the XFCC header to the next hop. This is the default value. ForwardOnly: When the client connection is mTLS (Mutual TLS), forward the XFCC header in the request. AppendAndForward: When the client connection is mTLS, append the client certificate information to the request’s XFCC header and forward it. SanitizeAndSet: When the client connection is mTLS, reset the XFCC header with the client certificate information and send it to the next hop. AlwaysForwardOnly: Always forward the XFCC header in the request, regardless of whether the client connection is mTLS. Note: When forwarding the XFCC header in the request you might have to adjust the header length restrictions (See sidecargateway.spec.applications.downstream.restrictions.http) no Sanitize, ForwardOnly, AppendAndForward, SanitizeAndSet, AlwaysForwardOnly SidecarGateway.spec.applications[].downstream.tls.clientCertificate Field Type Description Required Default Allowed Values ignored object Ignored disables verification of the client certificate. no optional object Optional enables verification of the client certificate if one is presented. In this mode only trustedCA and crl settings can be configured since certificatePinning and allowedSANs require a client certificate. no required object Required contains settings for client certificate verification. A client must present a valid certificate. At least one of trustedCA and certificatePinning must be set. no SidecarGateway.spec.applications[].downstream.tls.clientCertificate.optional Field Type Description Required Default Allowed Values crl object CRL defines the Certificate Revocation List (CRL) settings. no trustedCA object TrustedCA defines which CA certificates are trusted. yes SidecarGateway.spec.applications[].downstream.tls.clientCertificate.optional.crl Field Type Description Required Default Allowed Values lists object[] Lists defines the list of secretRefs containing Certificate Revocation Lists. no validationMode enum ValidationMode defines whether only the leaf certificate or also the CA certs should be checked. no VerifyChain VerifyLeafCertOnly, VerifyChain SidecarGateway.spec.applications[].downstream.tls.clientCertificate.optional.crl.lists[] Field Type Description Required Default Allowed Values secretRef object SecretRef defines the reference to a secret containing one or more CRL’s (in PEM format) under the key ‘ca.crl’. yes SidecarGateway.spec.applications[].downstream.tls.clientCertificate.optional.crl.lists[].secretRef Field Type Description Required Default Allowed Values name string Name of the resource yes SidecarGateway.spec.applications[].downstream.tls.clientCertificate.optional.trustedCA Field Type Description Required Default Allowed Values certificates object[] Certificates defines the list of secretRefs containing trusted CA certificates. yes verificationDepth uint32 VerificationDepth specifies the hops in the certificate chain at which validation is performed. 1 means that either the leaf or the signing CA must be in the set of trusted certificates. no 1 [0, 4294967295] SidecarGateway.spec.applications[].downstream.tls.clientCertificate.optional.trustedCA.certificates[] Field Type Description Required Default Allowed Values secretRef object SecretRef defines the reference to a secret containing one or more CA certificates under the key ‘ca.crt’. yes SidecarGateway.spec.applications[].downstream.tls.clientCertificate.optional.trustedCA.certificates[].secretRef Field Type Description Required Default Allowed Values name string Name of the resource yes SidecarGateway.spec.applications[].downstream.tls.clientCertificate.required Field Type Description Required Default Allowed Values allowedSANs object[] AllowedSANs is a list of matchers to verify the Subject Alternative name. If specified, it will verify that the Subject Alternative Name of the presented certificate matches one of the specified matchers. The matching uses “any” semantics, that is to say, the SAN is verified if at least one matcher is matched. AllowedSANs requires trustedCA to be set. no crl object CRL defines the Certificate Revocation List (CRL) settings. no certificatePinning object CertificatePinning defines the constraints a client certificate must fulfill. If more than one constraint is configured only one must be satisfied. At least one of allowedSPKIs and allowedHashes must be set. no trustedCA object TrustedCA defines which CA certificates are trusted. no SidecarGateway.spec.applications[].downstream.tls.clientCertificate.required.allowedSANs[] Field Type Description Required Default Allowed Values matcher object Matcher defines the string matcher for the SAN value. yes exact{}, prefix{}, suffix{}, regex{}, contains{} sanType enum SanType defines the type of SAN matcher. yes DNS, Email, URI, IPAddress SidecarGateway.spec.applications[].downstream.tls.clientCertificate.required.allowedSANs[].matcher Field Type Description Required Default Allowed Values contains string Contains defines a substring match on the substring specified here. Empty contains match is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no exact string Exact defines an explicit match on the string specified here. Only one of exact, prefix, suffix, regex or contains can be set. no ignoreCase bool IgnoreCase indicates whether the matching should be case-insensitive. In case of a regex match, the regex gets wrapped with a group (?i:...). no false true, false prefix string Prefix defines a prefix match on the prefix specified here. Empty prefix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no regex string Regex defines a regex match on the regular expression specified here. Google’s RE2 regex engine is used. The regex matches only single-line by default, even with “.*”. To match a multi-line string prepend (?s) to your regex. Only one of exact, prefix, suffix, regex or contains can be set. no suffix string Suffix defines a suffix match on the suffix specified here. Empty suffix is not allowed, please use regex instead. Only one of exact, prefix, suffix, regex or contains can be set. no SidecarGateway.spec.applications[].downstream.tls.clientCertificate.required.crl Field Type Description Required Default Allowed Values lists object[] Lists defines the list of secretRefs containing Certificate Revocation Lists. no validationMode enum ValidationMode defines whether only the leaf certificate or also the CA certs should be checked. no VerifyChain VerifyLeafCertOnly, VerifyChain SidecarGateway.spec.applications[].downstream.tls.clientCertificate.required.crl.lists[] Field Type Description Required Default Allowed Values secretRef object SecretRef defines the reference to a secret containing one or more CRL’s (in PEM format) under the key ‘ca.crl’. yes SidecarGateway.spec.applications[].downstream.tls.clientCertificate.required.crl.lists[].secretRef Field Type Description Required Default Allowed Values name string Name of the resource yes SidecarGateway.spec.applications[].downstream.tls.clientCertificate.required.certificatePinning Field Type Description Required Default Allowed Values allowedHashes string[] AllowedHashes is a list of hex-encoded SHA-256 hashes. If specified, it will verify that the SHA-256 of the DER-encoded presented certificate matches one of the specified values. no allowedSPKIs string[] AllowedSPKIs is a list of base64-encoded SHA-256 hashes. If specified, it will verify that the SHA-256 of the DER-encoded Subject Public Key Information (SPKI) of the presented certificate matches one of the specified values. no SidecarGateway.spec.applications[].downstream.tls.clientCertificate.required.trustedCA Field Type Description Required Default Allowed Values certificates object[] Certificates defines the list of secretRefs containing trusted CA certificates. yes verificationDepth uint32 VerificationDepth specifies the hops in the certificate chain at which validation is performed. 1 means that either the leaf or the signing CA must be in the set of trusted certificates. no 1 [0, 4294967295] SidecarGateway.spec.applications[].downstream.tls.clientCertificate.required.trustedCA.certificates[] Field Type Description Required Default Allowed Values secretRef object SecretRef defines the reference to a secret containing one or more CA certificates under the key ‘ca.crt’. yes SidecarGateway.spec.applications[].downstream.tls.clientCertificate.required.trustedCA.certificates[].secretRef Field Type Description Required Default Allowed Values name string Name of the resource yes SidecarGateway.spec.applications[].downstream.tls.protocol Field Type Description Required Default Allowed Values maximum enum Maximum supported TLS version. no TLSv1_0, TLSv1_1, TLSv1_2, TLSv1_3 minimum enum Minimum supported TLS version. no TLSv1_0, TLSv1_1, TLSv1_2, TLSv1_3 SidecarGateway.spec.applications[].downstream.tls.secretRef Field Type Description Required Default Allowed Values name string Name of the resource yes SidecarGateway.spec.applications[].downstream.timeouts Field Type Description Required Default Allowed Values http object HTTP defines the settings for HTTP timeouts. no SidecarGateway.spec.applications[].downstream.timeouts.http Field Type Description Required Default Allowed Values idle string (duration) Idle defines the settings for the idle timeout when no data is sent or received. A value of 0 will completely disable the timeout. Default: 5m no 5m See link maxDuration string (duration) MaxDuration defines the total duration for a HTTP request/response stream. A value of 0 will completely disable the timeout. Default: 5m no 5m See link requestHeaders string (duration) RequestHeaders defines the duration before all request headers must be received. A value of 0 will completely disable the timeout. Default: 10s no 10s See link SidecarGateway.spec.applications[].envoyHTTPFilterRefs Field Type Description Required Default Allowed Values prepend object[] Prepend selects the relevant EnvoyHTTPFilters which are added before those configured by the Airlock Microgateway. no SidecarGateway.spec.applications[].envoyHTTPFilterRefs.prepend[] Field Type Description Required Default Allowed Values name string Name of the resource yes SidecarGateway.spec.applications[].routes[] Field Type Description Required Default Allowed Values pathPrefix string PathPrefix defines the path prefix used during route selection. no / secured object Secured enables WAF processing for this route. no unsecured object Unsecured disables all WAF functionality and therefore protection for this route. WARNING: Using this setting when the application is exposed to untrusted downstream traffic is highly discouraged. no SidecarGateway.spec.applications[].routes[].secured Field Type Description Required Default Allowed Values accessControlRef object AccessControlRef selects the relevant AccessControl configuration resource. If undefined, Airlock Microgateway does not perform any access control. no contentSecurityRef object ContentSecurityRef selects the relevant ContentSecurity configuration resource. If undefined, default settings are applied, designed to work with most upstream web application services. no SidecarGateway.spec.applications[].routes[].secured.accessControlRef Field Type Description Required Default Allowed Values name string Name of the resource yes SidecarGateway.spec.applications[].routes[].secured.contentSecurityRef Field Type Description Required Default Allowed Values name string Name of the resource yes SidecarGateway.spec.applications[].telemetryRef Field Type Description Required Default Allowed Values name string Name of the resource yes SidecarGateway.spec.applications[].upstream Field Type Description Required Default Allowed Values protocol object Protocol defines HTTP protocol version used to communicate with the upstream. At most one of http1, http2 and auto can be set. Default: auto: {} no auto{...} http1{}, http2{}, auto{} tls object TLS defines the TLS settings. no timeouts object Timeouts defines the timeout settings. no SidecarGateway.spec.applications[].upstream.protocol Field Type Description Required Default Allowed Values auto object Auto specifies to use the protocol negotiated via TLS ALPN (if supported) or HTTP/1.1 as fallback. no http1 object HTTP1 specifies to use HTTP/1.1. no http2 object HTTP2 specifies to use HTTP/2. no SidecarGateway.spec.applications[].upstream.protocol.auto Field Type Description Required Default Allowed Values http2 object HTTP2 specifies the settings for when HTTP/2 is inferred. no SidecarGateway.spec.applications[].upstream.protocol.auto.http2 Field Type Description Required Default Allowed Values allowConnect bool Allows proxying Websocket and other upgrades over H2 connect. no false true, false SidecarGateway.spec.applications[].upstream.protocol.http2 Field Type Description Required Default Allowed Values allowConnect bool Allows proxying Websocket and other upgrades over H2 connect. no false true, false SidecarGateway.spec.applications[].upstream.tls Field Type Description Required Default Allowed Values ciphers string[] Ciphers defines a list of the supported TLS cipher suites. For details on cipher list refer to the envoy documentation on cipher_suites in common tls configuration. no enable bool Enable defines if the upstream connection is encrypted. no false true, false protocol object Protocol defines the supported TLS protocol versions. no SidecarGateway.spec.applications[].upstream.tls.protocol Field Type Description Required Default Allowed Values maximum enum Maximum supported TLS version. no TLSv1_0, TLSv1_1, TLSv1_2, TLSv1_3 minimum enum Minimum supported TLS version. no TLSv1_0, TLSv1_1, TLSv1_2, TLSv1_3 SidecarGateway.spec.applications[].upstream.timeouts Field Type Description Required Default Allowed Values http object HTTP defines the settings for HTTP timeouts. no SidecarGateway.spec.applications[].upstream.timeouts.http Field Type Description Required Default Allowed Values idle string (duration) Timeout defines the settings for http timeouts. If this setting is not specified, the value of applications[].downstream.timeouts.http.idle is inherited. A value of 0 will completely disable the timeout. no See link maxDuration string (duration) MaxDuration defines the total duration for a HTTP request/response stream. Default: 15s no 15s See link SidecarGateway.spec.envoyClusterRefs[] Field Type Description Required Default Allowed Values name string Name of the resource yes SidecarGateway.spec.podSelector Field Type Description Required Default Allowed Values matchLabels map[string]string MatchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels. no SidecarGateway.status Field Type Description Required Default Allowed Values conditions object[] no pods object[] no status string yes SidecarGateway.status.conditions[] Field Type Description Required Default Allowed Values lastTransitionTime string (timestamp) Last time the condition transitioned from one status to another. no rfc3339 timestamp message string A human-readable message indicating details about the transition. no reason string The reason for the condition’s last transition. no status enum Status of the condition, one of True, False, Unknown. yes True, False, Unknown type string Type of SidecarGateway condition. yes SidecarGateway.status.pods[] Field Type Description Required Default Allowed Values envoyConfig string EnvoyConfig indicates the name of the EnvoyConfig CR which references the SidecarGateway. no name string Name indicates the name of the Pod which references the SidecarGateway. yes ",
    "description": "API version v1alpha1",
    "tags": null,
    "title": "SidecarGateway",
    "uri": "/crds/sidecar-gateway/v1alpha1/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference \u003e Telemetry",
    "content": "microgateway.airlock.com/v1alpha1 Telemetry contains the configuration for telemetry (logging, metrics \u0026 tracing).\n​ Example Default apiVersion: microgateway.airlock.com/v1alpha1 kind: Telemetry metadata: name: telemetry-example spec: logging: accessLog: format: json: \"@timestamp\": \"%START_TIME(%Y-%m-%dT%T.%3f%z)%\" ecs: version: \"8.5\" log: logger: \"access\" level: \"info\" event: kind: \"event\" category: [\"web\"] type: \"%EVENT_TYPE%\" module: \"envoy\" dataset: \"envoy.access\" outcome: \"success\" start: \"%START_TIME(%Y-%m-%dT%T.%3f%z)%\" end: \"%END_TIME(%Y-%m-%dT%T.%3f%z)%\" duration: \"%DURATION_IN_NANOSECONDS%\" airlock: authentication: \"%AUTHENTICATION%\" deny_rules: \"%DENY_RULES%\" encoding: \"%ENCODING%\" header_rewrites: \"%HEADER_REWRITES%\" http: request: accept_language: \"%REQ(ACCEPT-LANGUAGE):100%\" response: redirect_url: \"%RESP(LOCATION):1000%\" log_correlation: \"%LOG_CORRELATION%\" parser: \"%PARSER%\" response: details: \"%RESPONSE_CODE_DETAILS%\" flags: \"%RESPONSE_FLAGS%\" upstream: destination: ip: \"%UPSTREAM_REMOTE_ADDRESS_WITHOUT_PORT%\" port: \"%UPSTREAM_REMOTE_PORT%\" http: version: \"%UPSTREAM_HTTP_VERSION%\" limits: \"%LIMITS%\" destination: ip: \"%DOWNSTREAM_LOCAL_ADDRESS_WITHOUT_PORT%\" port: \"%DOWNSTREAM_LOCAL_PORT%\" http: request: body: bytes: \"%BYTES_RECEIVED%\" bytes: \"%REQUEST_HEADERS_AND_BODY_BYTES%\" id: \"%STREAM_ID%\" method: \"%REQ(:METHOD):100%\" mime_type: \"%REQ_MIME_TYPE:500%\" referrer: \"%REQ(REFERER):1000%\" response: body: bytes: \"%BYTES_SENT%\" bytes: \"%RESPONSE_HEADERS_AND_BODY_BYTES%\" mime_type: \"%RESP_MIME_TYPE:500%\" status_code: \"%RESPONSE_CODE%\" version: \"%HTTP_VERSION%\" network: forwarded_ip: \"%DOWNSTREAM_REMOTE_ADDRESS_WITHOUT_PORT%\" observer: product: \"Airlock Microgateway\" type: \"waap\" vendor: \"Ergon Informatik AG\" version: \"%ENVIRONMENT(ENGINE_VERSION)%\" source: ip: \"%DOWNSTREAM_DIRECT_REMOTE_ADDRESS_WITHOUT_PORT%\" port: \"%DOWNSTREAM_DIRECT_REMOTE_PORT%\" url: domain: \"%HTTP_HOST:500%\" path: \"%REQ_WITHOUT_QUERY(:PATH):1000%\" query: \"%REQ_QUERY(:PATH):1000%\" user_agent: original: \"%REQ(USER-AGENT):500%\" # Additional log keys under 'custom'. custom: downstream: # Log TLS attributes of the downstream connection. tls: protocol: \"%DOWNSTREAM_TLS_VERSION%\" cipher: \"%DOWNSTREAM_TLS_CIPHER%\" session_id: \"%DOWNSTREAM_TLS_SESSION_ID%\" # Log the direct remote ip address and port. direct_remote_address: ip: \"%DOWNSTREAM_DIRECT_REMOTE_ADDRESS_WITHOUT_PORT%\" port: \"%DOWNSTREAM_DIRECT_REMOTE_PORT%\" http: request: # Log the request header 'Cookie'. cookie: \"%REQ(cookie):500%\" # Log the request header 'X-Request-ID'. x_request_id: \"%REQ(X-Request-ID):500%\" apiVersion: microgateway.airlock.com/v1alpha1 kind: Telemetry metadata: name: default spec: logging: accessLog: format: json: \"@timestamp\": \"%START_TIME(%Y-%m-%dT%T.%3f%z)%\" ecs: version: \"8.5\" log: logger: \"access\" level: \"info\" event: kind: \"event\" category: [ \"web\" ] type: \"%EVENT_TYPE%\" module: \"envoy\" dataset: \"envoy.access\" outcome: \"success\" start: \"%START_TIME(%Y-%m-%dT%T.%3f%z)%\" end: \"%END_TIME(%Y-%m-%dT%T.%3f%z)%\" duration: \"%DURATION_IN_NANOSECONDS%\" airlock: authentication: \"%AUTHENTICATION%\" deny_rules: \"%DENY_RULES%\" encoding: \"%ENCODING%\" header_rewrites: \"%HEADER_REWRITES%\" http: request: accept_language: \"%REQ(ACCEPT-LANGUAGE):100%\" response: redirect_url: \"%RESP(LOCATION):1000%\" log_correlation: \"%LOG_CORRELATION%\" openapi: \"%OPENAPI%\" parser: \"%PARSER%\" response: details: \"%RESPONSE_CODE_DETAILS%\" flags: \"%RESPONSE_FLAGS%\" upstream: destination: ip: \"%UPSTREAM_REMOTE_ADDRESS_WITHOUT_PORT%\" port: \"%UPSTREAM_REMOTE_PORT%\" http: version: \"%UPSTREAM_HTTP_VERSION%\" limits: \"%LIMITS%\" destination: ip: \"%DOWNSTREAM_LOCAL_ADDRESS_WITHOUT_PORT%\" port: \"%DOWNSTREAM_LOCAL_PORT%\" http: request: body: bytes: \"%BYTES_RECEIVED%\" bytes: \"%REQUEST_HEADERS_AND_BODY_BYTES%\" id: \"%STREAM_ID%\" method: \"%REQ(:METHOD):100%\" mime_type: \"%REQ_MIME_TYPE:500%\" referrer: \"%REQ(REFERER):1000%\" response: body: bytes: \"%BYTES_SENT%\" bytes: \"%RESPONSE_HEADERS_AND_BODY_BYTES%\" mime_type: \"%RESP_MIME_TYPE:500%\" status_code: \"%RESPONSE_CODE%\" version: \"%HTTP_VERSION%\" network: forwarded_ip: \"%DOWNSTREAM_REMOTE_ADDRESS_WITHOUT_PORT%\" observer: product: \"Airlock Microgateway\" type: \"waap\" vendor: \"Ergon Informatik AG\" version: \"%ENVIRONMENT(ENGINE_VERSION)%\" source: ip: \"%DOWNSTREAM_DIRECT_REMOTE_ADDRESS_WITHOUT_PORT%\" port: \"%DOWNSTREAM_DIRECT_REMOTE_PORT%\" url: domain: \"%HTTP_HOST:500%\" path: \"%REQ_WITHOUT_QUERY(:PATH):1000%\" query: \"%REQ_QUERY(:PATH):1000%\" user_agent: original: \"%REQ(USER-AGENT):500%\" correlation: request: alterRequestID: true allowDownstreamRequestID: true Telemetry Field Type Description Required Default Allowed Values metadata ObjectMeta Refer to Kubernetes API documentation for fields of metadata yes spec object Specification of the desired telemetry behavior. no Telemetry.spec Field Type Description Required Default Allowed Values correlation object Correlation defines the correlation aspects of Telemetry. no logging object Logging defines the logging aspects of Telemetry. no Telemetry.spec.correlation Field Type Description Required Default Allowed Values request object Request defines the request related correlation settings of Telemetry. no Telemetry.spec.correlation.request Field Type Description Required Default Allowed Values allowDownstreamRequestID bool AllowDownstreamRequestID defines whether trace sampling will consider a provided x-request-id. no true true, false alterRequestID bool AlterRequestID defines whether to alter the UUID to reflect the trace sampling decision. If disabled no modification to the UUID will be performed, this may break tracing in the upstream. no true true, false Telemetry.spec.logging Field Type Description Required Default Allowed Values accessLog object AccessLog defines the access log settings of Telemetry. no Telemetry.spec.logging.accessLog Field Type Description Required Default Allowed Values format object Format defines the Access Log format of the sidecar. no Telemetry.spec.logging.accessLog.format Field Type Description Required Default Allowed Values json unstructured JSON defines the Access Log format as JSON. no ",
    "description": "API version v1alpha1",
    "tags": null,
    "title": "Telemetry",
    "uri": "/crds/telemetry/v1alpha1/index.html"
  },
  {
    "breadcrumb": "",
    "content": " Configuration ReferenceReference documentation for configuration files\nCRD ReferenceReference documentation for custom resource definitions\n",
    "description": "API reference documentation",
    "tags": null,
    "title": "API Reference",
    "uri": "/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference",
    "content": "",
    "description": "API Documentation for AccessControl",
    "tags": null,
    "title": "AccessControl",
    "uri": "/crds/access-control/index.html"
  },
  {
    "breadcrumb": "API Reference",
    "content": "",
    "description": "",
    "tags": null,
    "title": "Categories",
    "uri": "/categories/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference",
    "content": "",
    "description": "API Documentation for ContentSecurity",
    "tags": null,
    "title": "ContentSecurity",
    "uri": "/crds/content-security/index.html"
  },
  {
    "breadcrumb": "API Reference",
    "content": "Reference documentation for custom resource definitions\nAccessControlAPI Documentation for AccessControl\nContentSecurityAPI Documentation for ContentSecurity\nDenyRulesAPI Documentation for DenyRules\nEnvoyClusterAPI Documentation for EnvoyCluster\nEnvoyConfigurationAPI Documentation for EnvoyConfiguration\nEnvoyHTTPFilterAPI Documentation for EnvoyHTTPFilter\nHeaderRewritesAPI Documentation for HeaderRewrites\nIdentityPropagationAPI Documentation for IdentityPropagation\nLimitsAPI Documentation for Limits\nOIDCProviderAPI Documentation for OIDCProvider\nOIDCRelyingPartyAPI Documentation for OIDCRelyingParty\nOpenAPIAPI Documentation for OpenAPI\nParserAPI Documentation for Parser\nSidecarGatewayAPI Documentation for SidecarGateway\nTelemetryAPI Documentation for Telemetry\n",
    "description": "Reference documentation for custom resource definitions",
    "tags": null,
    "title": "CRD Reference",
    "uri": "/crds/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference",
    "content": "",
    "description": "API Documentation for DenyRules",
    "tags": null,
    "title": "DenyRules",
    "uri": "/crds/deny-rules/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference",
    "content": "",
    "description": "API Documentation for EnvoyCluster",
    "tags": null,
    "title": "EnvoyCluster",
    "uri": "/crds/envoy-cluster/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference",
    "content": "",
    "description": "API Documentation for EnvoyConfiguration",
    "tags": null,
    "title": "EnvoyConfiguration",
    "uri": "/crds/envoy-configuration/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference",
    "content": "",
    "description": "API Documentation for EnvoyHTTPFilter",
    "tags": null,
    "title": "EnvoyHTTPFilter",
    "uri": "/crds/envoy-http-filter/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference",
    "content": "",
    "description": "API Documentation for HeaderRewrites",
    "tags": null,
    "title": "HeaderRewrites",
    "uri": "/crds/header-rewrites/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference",
    "content": "",
    "description": "API Documentation for IdentityPropagation",
    "tags": null,
    "title": "IdentityPropagation",
    "uri": "/crds/identity-propagation/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference",
    "content": "",
    "description": "API Documentation for Limits",
    "tags": null,
    "title": "Limits",
    "uri": "/crds/limits/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference",
    "content": "",
    "description": "API Documentation for OIDCProvider",
    "tags": null,
    "title": "OIDCProvider",
    "uri": "/crds/oidc-provider/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference",
    "content": "",
    "description": "API Documentation for OIDCRelyingParty",
    "tags": null,
    "title": "OIDCRelyingParty",
    "uri": "/crds/oidc-relying-party/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference",
    "content": "",
    "description": "API Documentation for OpenAPI",
    "tags": null,
    "title": "OpenAPI",
    "uri": "/crds/open-api/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e Configuration Reference",
    "content": "",
    "description": "API Documentation for OperatorConfig",
    "tags": null,
    "title": "OperatorConfig",
    "uri": "/config/operator-config/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference",
    "content": "",
    "description": "API Documentation for Parser",
    "tags": null,
    "title": "Parser",
    "uri": "/crds/parser/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference",
    "content": "",
    "description": "API Documentation for SidecarGateway",
    "tags": null,
    "title": "SidecarGateway",
    "uri": "/crds/sidecar-gateway/index.html"
  },
  {
    "breadcrumb": "API Reference",
    "content": "",
    "description": "",
    "tags": null,
    "title": "Tags",
    "uri": "/tags/index.html"
  },
  {
    "breadcrumb": "API Reference \u003e CRD Reference",
    "content": "",
    "description": "API Documentation for Telemetry",
    "tags": null,
    "title": "Telemetry",
    "uri": "/crds/telemetry/index.html"
  }
]
