var m_1652373435165Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Kubernetes cluster without a service mesh<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1652373435165\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Kubernetes cluster without a service mesh<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1652373435165_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1652373435165_N1000F1652788695004\">This article shows the architecture of a web application deployed in a Kubernetes cluster and protected by Airlock Microgateway. This example illustrates the setup if no service mesh is used. This is the most simple functional setup \u2013 with <i class=\"italics\">Airlock Microgateway<\/i> injected which secures a single <i class=\"italics\">Web application<\/i> container. The setup shows two namespaces, one for the <i class=\"italics\">Microgateway Operator<\/i> Pod and a second one with the <i class=\"italics\">Web application<\/i> Pod.<\/p><p class=\"par\" id=\"1652373435165_N1001D\">The \u200BMicrogateway Operator\u200B container injects the \u200BMicrogateway Engine\u200B Container into web application Pods labeled with <code class=\"codeinline\">sidecar.microgateway.airlock.com\/inject: \"true\"<\/code>.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The <i class=\"italics\">Operator<\/i> configures the <i class=\"italics\">Engine<\/i> based on Custom Resources that contain the Engine configuration.<\/li><li class=\"enum-element\">The <i class=\"italics\">Microgateway CNI plugin<\/i> of the Node configures the network routing between <i class=\"italics\">Engine<\/i> and <i class=\"italics\">Web application<\/i> container.<\/li><\/ul><figure class=\"media\"><div class=\"media-theme\" id=\"1652373435165_N1000F\"><img alt=\"Kubernetes resources without service mesh\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/03_Media\/Vector_drawings\/Microgateway\/13551.Kubernetes_resources_without_service_mesh.theme\/1.8.10\/en-us.13551.Kubernetes_resources_without_service_mesh_original.svg\" style=\"width:1024px;height:587.5852372583479px;border:0;\"\/><\/div><\/figure><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1652373435165_N100521661955619775\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Traffic handling<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 Alpha\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">A <i class=\"italics\">Web client<\/i> wants to access the <i class=\"italics\">Web application<\/i>. The request is sent to the <i class=\"italics\">Ingress controller<\/i> of the <i class=\"italics\">Kubernetes cluster<\/i>.<\/li><li class=\"enum-element\">The <i class=\"italics\">Ingress controller<\/i> accepts the traffic from outside the cluster and forwards it to the <i class=\"italics\">Web application<\/i> Service.<\/li><li class=\"enum-element\">The <i class=\"italics\">Web application<\/i> Service forwards the traffic to the <i class=\"italics\">Web application<\/i> Pod. <br\/>In this Pod, all traffic is routed through the <i class=\"italics\">Microgateway Engine<\/i> container and subsequently to the <i class=\"italics\">Web application<\/i> container as configured by the <i class=\"italics\">Microgateway CNI plugin<\/i>.<\/li><li class=\"enum-element\">The <i class=\"italics\">Microgateway Engine<\/i> container writes logs to <code class=\"codeinline\">\/dev\/stdout<\/code>. A logging service can collect and visualize these logs in a graphical reporting solution.<\/li><li class=\"enum-element\">The <i class=\"italics\">Prometheus<\/i> Pod scrapes metrics from the <i class=\"italics\">Microgateway Engine<\/i> containers that can be visualized, e.g., using Grafana.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1652373435165_N100A7\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration handling<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">The <i class=\"italics\">Microgateway Operator<\/i> reads its configuration from the <i class=\"italics\">Microgateway Operator Configuration<\/i> at startup and watches for events such as Pod <code class=\"codeinline\">create<\/code>, <code class=\"codeinline\">update<\/code> or <code class=\"codeinline\">delete<\/code>.<\/li><li class=\"step\">When a <i class=\"italics\">Web application Pod<\/i> is created with a <code class=\"codeinline\">sidecar.microgateway.airlock.com\/inject<\/code> label, two things happen:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"> The <i class=\"italics\">Microgateway Operator<\/i> injects the <i class=\"italics\">Microgateway Engine<\/i> container.<\/li><li class=\"enum-element\">The <i class=\"italics\">Microgateway CNI plugin<\/i> configures the routing within the <i class=\"italics\">Web application Pod<\/i> so that all traffic is led through the <i class=\"italics\">Microgateway Engine<\/i>.<\/li><li class=\"enum-element\">The <i class=\"italics\">Microgateway Network Validator<\/i> performs a quick sanity check of the network routing configured by the <i class=\"italics\">Microgateway CNI plugin<\/i>.<\/li><\/ul><li class=\"step\">The CustomResource <i class=\"italics\">SidecarGateway<\/i> includes a <code class=\"codeinline\">podSelector<\/code> that selects the group of Pods to which the configuration applies.<\/li><li class=\"step\">The CustomResource <i class=\"italics\">SidecarGateway<\/i> refers to other resources that should be applied.<\/li><li class=\"step\">The <i class=\"italics\">Microgateway Operator<\/i> reads the involved configuration and sends it to the <i class=\"italics\">Microgateway Engine<\/i>.<\/li><li class=\"step\">The <i class=\"italics\">Microgateway Operator<\/i> watches the <i class=\"italics\">Microgateway Engine<\/i> configuration resources. If these resources have been altered, the <i class=\"italics\">Microgateway Operator<\/i> updates the <i class=\"italics\">Microgateway Engine<\/i> with the new configuration.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1652373435165_N1014C\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1660804708664.html\">Kubernetes<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1658483168033.html\">OpenShift<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';