var m_1659429981695Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Completion, validation and tooltips in Visual Studio Code<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1659429981695\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Completion, validation and tooltips in Visual Studio Code<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1659429981695_N10006\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1659429981695_N10007\">Visual Studio Code (VS Code) supports auto-completion, validation, error highlighting and tooltips for Kubernetes through the <i class=\"italics\">Visual Studio Code Kubernetes Tools<\/i> extension. This extension uses <code class=\"codeinline\">kubectl<\/code> to interact with your Kubernetes cluster without leaving VS Code.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1659429981695_N10013\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">VS Code is installed.<\/li><li class=\"enum-element\">Kubernetes cluster with the Airlock Microgateway CRDs deployed.<\/li><li class=\"enum-element\"><code class=\"codeinline\">kubectl<\/code> is installed.<\/li><li class=\"enum-element\">A valid <code class=\"codeinline\">kubeconfig<\/code> to interact with your Kubernetes cluster.<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The <code class=\"codeinline\">kubeconfig<\/code> must fulfill the following requirements:<\/li><li class=\"enum-element\">Allows to access the Kubernetes cluster where the Airlock Microgateway CRDs are deployed.<\/li><li class=\"enum-element\">The <code class=\"codeinline\">current-context<\/code> is set to this Kubernetes cluster.<\/li><\/ul><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1659429981695_N10035\">The default <code class=\"codeinline\">kubeconfig<\/code> is located in <code class=\"codeinline\">~\/.kube\/config<\/code>. For further information consult the Kubernetes manual: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/kubernetes.io\/docs\/concepts\/configuration\/organize-cluster-access-kubeconfig\/\" target=\"_blank\">(Kubernetes) Kubeconfig<\/a><\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1659429981695_N10028\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">How to install the Kubernetes extension in VS Code<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Start Visual Studio Code.<\/li><li class=\"step\">Open the extensions search tree with <span class=\"inverted\">Ctrl<\/span>+<span class=\"inverted\">Shift<\/span>+<span class=\"inverted\">X<\/span> and search for <i class=\"italics\">Kubernetes<\/i>. <\/li><li class=\"step\">Install the VS Code extension <i class=\"italics\">Kubernetes Tools<\/i>. See also the list of included features in the extension description.<\/li><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1659429981695_N1004B\">The display name is <i class=\"italics\">Kubernetes<\/i> and the full extension name is displayed in the <span class=\"dialog\">Details<\/span> tab.<\/p><\/div><\/div><\/div><\/div><\/div><li class=\"step result\">The Kubernetes icon appears in the left icon bar.<\/li><li class=\"step\">Restart Visual Studio Code to reload the extension.<\/li><li class=\"step result\">With a click on the Kubernetes icon, a Kubernetes section with a list of reachable clusters appears.<\/li><\/ol><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1659429981695_N10036\">Use <span class=\"inverted\">Ctrl<\/span>+<span class=\"inverted\">Shift<\/span>+<span class=\"inverted\">P<\/span> to open the command palette. Start typing <i class=\"italics\">Kubernetes<\/i> will show all available Kubernetes-related commands such as <i class=\"italics\">Kubernetes: Apply<\/i> which calls <code class=\"codeinline\">kubectl apply<\/code> remotely.<\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1659429981695_N1005B\">YAML support is based on the Red Hat YAML language extension that is automatically installed as a dependency of the Kubernetes tools extension. VS Code Visual Studio code validates only the CustomResources with the OpenAPI schema specification within the CRD. This means, that it\'s only a syntactical validation but when applying the code, the semantic validation could still fail.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1659429981695_N10097\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Visual Studio Code Desktop configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1659429981695_N1009A\">The VS Code for the web configuration is relevant to have autocompletion, validation, error highlighting and tooltips for the CRDs.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Start VS Code on your desktop.<\/li><li class=\"step\">Use <span class=\"inverted\">Ctrl<\/span>+<span class=\"inverted\">Shift<\/span>+<span class=\"inverted\">P<\/span> to open the command palette. Start typing <i class=\"italics\">Preferences<\/i> and select <i class=\"italics\">Preferences: Open User Settings (JSON)<\/i>.<\/li><li class=\"step\">Adjust <code class=\"codeinline\">settings.json<\/code> to your needs. We used the following configuration:<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonShow\" href=\"#\"><span class=\"showMore\">Show more<\/span><span class=\"showLess\">Show less<\/span><\/a><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div character-limit=\"200\" class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100B3\">{ \r\n  \"workbench.colorTheme\": \"Visual Studio Dark\", \r\n  \"workbench.iconTheme\": \"vscode-great-icons\", \r\n  \"editor.formatOnSave\": true, \r\n  \"editor.formatOnPaste\": true, \r\n  \"editor.tabSize\": 2, \r\n  \"[yaml]\": { \r\n    \"editor.insertSpaces\": true, \r\n    \"editor.tabSize\": 2, \r\n    \"editor.autoIndent\": \"keep\", \r\n    \"editor.wordBasedSuggestions\": false \r\n  }, \r\n  \"yaml.format.enable\": true, \r\n  \"yaml.format.singleQuote\": false, \r\n  \"yaml.format.bracketSpacing\": true, \r\n  \"yaml.format.proseWrap\": \"preserve\", \r\n  \"yaml.format.printWidth\": 80, \r\n  \"yaml.validate\": true, \r\n  \"yaml.hover\": true, \r\n  \"yaml.completion\": true, \r\n  \"yaml.disableAdditionalProperties\": true, \r\n  \"yaml.maxItemsComputed\": 5000, \r\n  \"yaml.trace.server\": \"off\", \r\n  \"diffEditor.ignoreTrimWhitespace\": false, \r\n  \"vs-kubernetes\": { \r\n    \"vs-kubernetes.crd-code-completion\": \"enabled\", \r\n    \"vs-kubernetes.namespace\": \"\", \r\n    \"vs-kubernetes.kubectl-path\": \"\", \r\n    \"vs-kubernetes.helm-path\": \"\", \r\n    \"vs-kubernetes.kubectlVersioning\": \"user-provided\", \r\n    \"vs-kubernetes.outputFormat\": \"yaml\", \r\n    \"vs-kubernetes.kubeconfig\": \"\", \r\n    \"vs-kubernetes.knownKubeconfigs\": [], \r\n    \"vs-kubernetes.autoCleanupOnDebugTerminate\": false, \r\n    \"vs-kubernetes.nodejs-autodetect-remote-root\": true, \r\n    \"vs-kubernetes.nodejs-remote-root\": \"\", \r\n    \"vs-kubernetes.nodejs-debug-port\": 9229, \r\n    \"vs-kubernetes.dotnet-vsdbg-path\": \"~\/vsdbg\/vsdbg\", \r\n    \"vs-kubernetes.local-tunnel-debug-provider\": \"\", \r\n    \"imageBuildTool\": \"Docker\" \r\n  }, \r\n  \"telemetry.telemetryLevel\": \"off\", \r\n  \"redhat.telemetry.enabled\": false \r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><\/ol><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1659429981695_N100C7\">The <code class=\"codeinline\">vs-kubernetes<\/code> settings belong to the Kubernetes plugin mentioned on this page and must fit your setup. In addition, the setting <code class=\"codeinline\">editor.wordBasedSuggestions<\/code> should be switched to <code class=\"codeinline\">false<\/code> otherwise wrong suggestions are made.<\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100CF\">...\r\n   \"[yaml]\": { \r\n    ...\r\n    \"editor.wordBasedSuggestions\": false \r\n  }, \r\n... <\/pre><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1659429981695_N100D1\">Ensure that the mentioned settings are configured the way we did. For a simple test, you can also use our configuration.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1659429981695_N10009\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Automatic validation example with Visual Studio Code<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1659429981695_N100B0\">After configuring Visual Studio Code as described, completion, validation and tooltip is available while typing.<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1659429981695_N1000B\"><img alt=\"Microgateway-Visul-Studio-Code-CRD-completion-validation-tooltip\" class=\"media-theme-img-tag apng\" src=\"..\/media\/03_Media\/Screen_recordings\/Microgateway\/Microgateway-Visul-Studio-Code-CRD-completion-validation-tooltip.theme\/1.1\/en-us.Microgateway-Visul-Studio-Code-CRD-completion-validation-tooltip_original.apng\" style=\"width:;height:;border:0;\"\/><\/div><\/figure><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1659429981695_N1008F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">External links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/code.visualstudio.com\/docs\/azure\/kubernetes\" target=\"_blank\">VS Code MS Kubernetes plugin<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/code.visualstudio.com\/docs\/editor\/intellisense\" target=\"_blank\">VS Code IntelliSense documentation<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/marketplace.visualstudio.com\/items?itemName=redhat.vscode-yaml\" target=\"_blank\">Red Hat VS Code YAML syntax plugin<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';