var m_1659942661105Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Configuration<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1659942661105\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Configuration<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1659942661105_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1659942661105_N1000C\">Within the Kubernetes cluster, the <i class=\"italics\">Microgateway Operator<\/i> container injects and operates the Airlock Microgateway containers in the <i class=\"italics\">Web application<\/i> Pod. This section shows how these pieces are connected together and what exactly is modified and done by the <i class=\"italics\">Microgateway Operator<\/i>. It also covers the network configuration task of the Microgateway CNI plugin, which configures the network routing through <i class=\"italics\">Microgateway Engine<\/i> sidecars within <i class=\"italics\">Web application<\/i> Pods.<\/p><p class=\"par\" id=\"1659942661105_N1000F1652788695004\">The following example illustrates the setup when no service mesh is used. The setup shows two namespaces, one for the <span class=\"dialog\">Microgateway Operator<\/span> Pod and a second one with the <i class=\"italics\">Web application<\/i> Pod.<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1659942661105_N10010\"><img alt=\"Airlock Microgateway configuration concept\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/03_Media\/Vector_drawings\/Microgateway\/13554.Airlock_Microgateway_configuration_concept.theme\/1.17\/en-us.13554.Airlock_Microgateway_configuration_concept_original.svg\" style=\"width:1024px;height:741.0737833594977px;border:0;\"\/><\/div><\/figure><ol class=\"enum-enum-instruction container-enum enum-standard Alpha\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Initial Microgateway Operator configuration<\/strong><\/li><li class=\"enum-element\">The <i class=\"italics\">Microgateway Operator<\/i> reads its configuration from the <i class=\"italics\">Microgateway Operator Configuration<\/i> at startup. The configuration contains settings like the templates used to inject the Microgateway containers. <\/li><li class=\"enum-element\">The <i class=\"italics\">Microgateway Operator<\/i> watches for events such as Pod <i class=\"italics\">create<\/i>, <i class=\"italics\">update<\/i> , or <i class=\"italics\">delete<\/i>.<\/li><\/ol><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Steps to secure a <i class=\"italics\">Web application<\/i> Pod in the Namespace X:<\/strong><\/li><li class=\"step\">Create a Custom Resource <code class=\"codeinline\">ContentSecurity<\/code> in the namespace of the Web application with the required references to additional CRs such as <code class=\"codeinline\">DenyRules<\/code>.<\/li><li class=\"step\">Create a second Custom Resource of the kind <code class=\"codeinline\">SidecarGateway<\/code> in the Web application\'s namespace and refer to the Custom Resource <code class=\"codeinline\">ContentSecurity<\/code> created previously.<\/li><li class=\"step\">Configure the container port in the Custom Resource <code class=\"codeinline\">SidecarGateway<\/code> , which should be protected. Ensure that it is the same port as in the Pod specification.<\/li><li class=\"step\">Configure the <code class=\"codeinline\">podSelector<\/code> to match the <i class=\"italics\">Web application<\/i> Pods, which should be protected in the Custom Resource <code class=\"codeinline\">SidecarGateway<\/code>. Ensure that it corresponds to the labels in the Pod specification.<\/li><li class=\"step\">Label the <i class=\"italics\">Web application<\/i> Pod with <code class=\"codeinline\">sidecar.microgateway.airlock.com\/inject: \"true\"<\/code>.<\/li><li class=\"step\">The <i class=\"italics\">Microgateway Operator<\/i> and the <i class=\"italics\">Microgateway CNI plugin<\/i> are triggered by the creation of the Pod with the sidecar label previously.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The <i class=\"italics\">Operator<\/i>:<\/li><li class=\"enum-element\">Injects the sidecar container <i class=\"italics\">Microgateway Engine<\/i> with the bootstrap configuration. The exact content is retrieved from the <i class=\"italics\">Operator ConfigMap<\/i>.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The <i class=\"italics\">Microgateway CNI plugin<\/i>:<\/li><li class=\"enum-element\">Configures the network inside the <i class=\"italics\">Web application Pod<\/i>, so that all traffic is routed through the <i class=\"italics\">Microgateway Engine<\/i> sidecar.<\/li><\/ul><li class=\"step result\">The <i class=\"italics\">Microgateway Engine<\/i> subscribes to the configuration from the <i class=\"italics\">Microgateway Operator<\/i>. The <i class=\"italics\">Microgateway Operator<\/i> generates the configuration based on the Custom Resources such as <code class=\"codeinline\">SidecarGateway<\/code> and the referenced resources.<\/li><\/ol><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The example describes the most simple setup. Although not outlined explicitly, the following things are possible:<\/li><li class=\"enum-element\">Create a Kubernetes Deployment, StatefulSet, or DaemonSet and annotate the Pod with Microgateway annotations in <code class=\"codeinline\">spec.template.metadata.annotations<\/code> and set the <code class=\"codeinline\">inject<\/code> label.<\/li><li class=\"enum-element\">Configure other Microgateway annotations described in this manual.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1565679354540_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Chapter content<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"generate-box generate-Contents\"><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1659429981428.html\" style=\"margin-left:0px\">8.1. Microgateway Operator<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1693917394386.html\" style=\"margin-left:0px\">8.2. Microgateway CNI<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1659942661125.html\" style=\"margin-left:0px\">8.3. Microgateway Engine<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1659430054289.html\" style=\"margin-left:0px\">8.4. Labels and annotations for Airlock Microgateway<\/a><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';