var m_1662450995418Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Kubernetes cluster with an Istio service mesh<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1662450995418\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Kubernetes cluster with an Istio service mesh<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1662450995418_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1662450995418_N1000F1652788695004\">This article shows the architecture of a small Istio service mesh with only one Airlock Microgateway-protected web application deployed in a Kubernetes cluster. <i class=\"italics\">Istiod<\/i> converts the high-level routing rules into Envoy-specific configurations of the Envoy proxies that are deployed as sidecars. These Envoy sidecars are injected into each Pod forming the <i class=\"italics\">Istio data plane<\/i>. <br\/>However, in Airlock Microgateway, the <i class=\"italics\">Microgateway Operator<\/i> Pod is not a typical manageable web application but a technical component that manages the Microgateway functionality. Hence, the <i class=\"italics\">Microgateway Operator<\/i> does not need to be maintained by the <i class=\"italics\">Istio control plane<\/i>.<\/p><p class=\"par\" id=\"1662450995418_N100111663066193101\"> The simple example shows a setup with a service mesh of a single web application, the <i class=\"italics\">Microgateway Operator<\/i> and the <i class=\"italics\">Istiod Container<\/i> in a single Node. In the <i class=\"italics\">Web application Pod<\/i> the <i class=\"italics\">Microgateway Engine<\/i> and the <i class=\"italics\">Istio-proxy<\/i>\/<i class=\"italics\">Istio-init<\/i> are injected as sidecars.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Namespaces in our example:<\/strong><\/li><li class=\"enum-element\"><code class=\"codeinline\">istio-system<\/code> working as the Istio control plane. <\/li><li class=\"enum-element\"><code class=\"codeinline\">airlock-microgateway-system<\/code> with the Microgateway Operator Pod, which is not part of the service mesh (no Istio proxy sidecar).<\/li><li class=\"enum-element\"><code class=\"codeinline\">application<\/code> with a web application secured by Airlock Microgateway and part of the service mesh (with Istio proxy sidecar).<\/li><li class=\"enum-element\"><code class=\"codeinline\">kube-system<\/code> used for system processes, i.e., to install a Microgateway CNI plugin in Airlock Microgateway Nodes. This Namespace is not part of the Istio service mesh.<\/li><\/ul><p class=\"par\" id=\"1662450995418_N1003D1652795368276\">Within the Kubernetes cluster, the <i class=\"italics\">Microgateway Operator<\/i> Container is responsible for injecting and configuring the Airlock Microgateway Containers, i.e., the <i class=\"italics\">Microgateway Engine<\/i> in the <i class=\"italics\">Web application Pods<\/i>. For operating Airlock Microgateway in an Istio setup, the sidecar injection is triggered by a <code class=\"codeinline\"> sidecar.microgateway.airlock.com\/serviceMesh: \"istio\"<\/code> annotation, which must be added to the Pod definition.<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1662450995418_N1000F\"><img alt=\"Kubernetes resources with Istio service mesh\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/03_Media\/Vector_drawings\/Microgateway\/13552.Kubernetes_resources_with_Istio_service_mesh.theme\/1.15\/en-us.13552.Kubernetes_resources_with_Istio_service_mesh_original.svg\" style=\"width:1024px;height:627.6392657621708px;border:0;\"\/><\/div><\/figure><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662450995418_N100521661955619775\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Traffic handling<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 Alpha\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">A <i class=\"italics\">Web client<\/i> wants to access the <i class=\"italics\">Web application<\/i>. The request is sent to the <i class=\"italics\">Istio Ingress controller<\/i> of the <i class=\"italics\">Kubernetes cluster<\/i>.<\/li><li class=\"enum-element\">The <i class=\"italics\">Istio Ingress controller<\/i> accepts the traffic from outside the cluster and forwards it to the <i class=\"italics\">Web application<\/i> Service.<\/li><li class=\"enum-element\">The <i class=\"italics\">Web application<\/i> Service forwards the traffic to the <i class=\"italics\">Web application Pod<\/i>.<br\/>The traffic routing configuration inside the <i class=\"italics\">Web Application Pod<\/i> is as follows:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><i class=\"italics\">Istiod<\/i> injects the <i class=\"italics\">istio-init Container<\/i>, which reconfigures the Pod\'s network to route all traffic to the <i class=\"italics\">Istio proxy<\/i>.<br\/>(Istio can also be operated with a CNI plugin instead of the istio-init container.)<\/li><li class=\"enum-element\">The <i class=\"italics\">Microgateway CNI plugin<\/i> reconfigures the Pod\'s network behind the <i class=\"italics\">istio proxy<\/i> to route the traffic from the <i class=\"italics\">istio proxy<\/i> to the <i class=\"italics\">Microgateway Engine<\/i> Container and finally to the <i class=\"italics\">web application<\/i>.<\/li><\/ul><li class=\"enum-element\">The <i class=\"italics\">Microgateway Engine<\/i> Container writes logs to <code class=\"codeinline\">\/dev\/stdout<\/code>. A logging service can collect and visualize these logs in a graphical reporting solution.<\/li><li class=\"enum-element\">The <i class=\"italics\">Prometheus<\/i> Pod scrapes metrics from the <i class=\"italics\">Microgateway Engine<\/i> Containers that can be visualized e.g., using Grafana.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662450995418_N100A7\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Microgateway configuration handling (grey numbering)<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">The <i class=\"italics\">Microgateway Operator<\/i> reads its configuration from the <i class=\"italics\">Microgateway Operator Configuration<\/i> at startup and watches for events such as Pod <code class=\"codeinline\">create<\/code>, <code class=\"codeinline\">update<\/code> or <code class=\"codeinline\">delete<\/code>.<\/li><li class=\"step\">When a <i class=\"italics\">Web application Pod<\/i> is created with a <code class=\"codeinline\">sidecar.microgateway.airlock.com\/inject<\/code> label, two things happen:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"> The <i class=\"italics\">Microgateway Operator<\/i> injects the <i class=\"italics\">Microgateway Engine<\/i> container.<\/li><li class=\"enum-element\">The <i class=\"italics\">Microgateway CNI plugin<\/i> configures the routing within the <i class=\"italics\">Web application Pod<\/i> so that all traffic is led through the <i class=\"italics\">Microgateway Engine<\/i>.<\/li><li class=\"enum-element\">The <i class=\"italics\">Microgateway Network Validator<\/i> performs a quick sanity check of the network routing configured by the <i class=\"italics\">Microgateway CNI plugin<\/i>.<\/li><\/ul><li class=\"step\">The CustomResource <i class=\"italics\">SidecarGateway<\/i> includes a <code class=\"codeinline\">podSelector<\/code> that selects the group of Pods to which the configuration applies.<\/li><li class=\"step\">The CustomResource <i class=\"italics\">SidecarGateway<\/i> refers to other resources that should be applied.<\/li><li class=\"step\">The <i class=\"italics\">Microgateway Operator<\/i> reads the involved configuration and sends it to the <i class=\"italics\">Microgateway Engine<\/i>.<\/li><li class=\"step\">The <i class=\"italics\">Microgateway Operator<\/i> watches the <i class=\"italics\">Microgateway Engine<\/i> configuration resources. If these resources have been altered, the <i class=\"italics\">Microgateway Operator<\/i> sends an update to the <i class=\"italics\">Microgateway Engine<\/i> with the new configuration.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662450995418_N10123\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Istio service mesh (pink numbering)<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">The <i class=\"italics\">Istiod<\/i> provides service discovery, configuration and certificate management for the injected Istio proxy sidecars. The <i class=\"italics\">Istiod<\/i> contains <i class=\"italics\">Pilot<\/i>, <i class=\"italics\">Citadel <\/i>and <i class=\"italics\">Galley <\/i>components that form the <i class=\"italics\">Istio control plane<\/i>.<\/li><li class=\"step\">The <i class=\"italics\">Istio proxy<\/i> sidecars transparently route the traffic from and to the Microgateway Engine. These proxy sidecars are part of the <i class=\"italics\">Istio data plane<\/i>.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662450995418_N1014C\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1662655602942.html\">Istio<\/a><\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">External links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/istio.io\/latest\/docs\/ops\/deployment\/architecture\/\" target=\"_blank\">Istio architecture<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';