var m_1662655596918Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Inspect the Envoy configuration<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1662655596918\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Inspect the Envoy configuration<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655596918_N100081663067503147\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1662655596918_N10028\">The <span class=\"dialog\">Microgateway Engine<\/span> is built on the basis of the Envoy proxy and enriched with Airlock-specific features. For complex problems, it may therefore be useful to also investigate the underlying Envoy configuration.<\/p><p class=\"par\" id=\"1662655596918_N10010\">To simplify this task we have created a CustomResource <code class=\"codeinline\">EnvoyConfiguration<\/code> which contains the Envoy configuration.<\/p><p class=\"par\" id=\"1662655596918_N1000D\">The following example shows the output of such a CustomResource and explains its components.<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1001F\">kubectl describe envoyconfigurations.microgateway.airlock.com &lt;webapp&gt;<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1662655596918_N100211700483908718\"><strong class=\"emphasis\">Example output:<\/strong><\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1001C\">Name:         webapp-84b785f954-r49wt  \r\nNamespace:    default  \r\nLabels:       &lt;none&gt;  \r\nAnnotations:  &lt;none&gt;  \r\nAPI Version:  microgateway.airlock.com\/v1alpha1  \r\nKind:         EnvoyConfiguration  \r\nMetadata:  \r\n  ... \r\n  ... \r\n  ... \r\nSpec:  \r\n  Envoy Resources:  \r\n    Clusters:  \r\n      Connect Timeout:    5s  \r\n      Dns Lookup Family:  V4_ONLY  \r\n      Load Assignment:  \r\n        Cluster Name:  upstream_8080  \r\n        Endpoints:  \r\n          Lb Endpoints:  \r\n            Endpoint:  \r\n              Address:  \r\n                Socket Address:  \r\n                  Address:     127.0.0.1  \r\n                  Port Value:  8080  \r\n      Name:                    upstream_8080  \r\n      Type:                    LOGICAL_DNS  \r\n    Listeners:  \r\n      Address:  \r\n        Socket Address:  \r\n          Address:     0.0.0.0  \r\n          Port Value:  13378  \r\n      Filter Chains:  \r\n        Filter Chain Match:  \r\n          Destination Port:  8080  \r\n        Filters:  \r\n          Name:  envoy.filters.network.http_connection_manager  \r\n          Typed Config:  \r\n            @type:  type.googleapis.com\/envoy.extensions.filters.network.http_connection_manager.v3.HttpConnectionManager  \r\n            Access Log:  \r\n              Name:  access_loggers.stdout  \r\n  ...\r\n  ...\r\n  ... \r\nStatus:  \r\n  Conditions:  \r\n    Last Transition Time:  2022-09-13T14:10:58Z  \r\n    Status:                True  \r\n    Type:                  EnvoyXdsSynchronized  \r\n    Last Transition Time:  2022-09-13T14:10:58Z  \r\n    Status:                True  \r\n    Type:                  EnvoyXdsAccepted  \r\n  Status:                  Active  \r\n  Xds:  \r\n    Resource Types:  \r\n      type.googleapis.com\/envoy.config.cluster.v3.Cluster:  \r\n        Resources:  \r\n          upstream_8080:  \r\n            Version:  934ffd2b1b111d6c402096234e119d8d4b026b315ec5a3d8baa52d4931c31aa7  \r\n        Status:       Accepted  \r\n        Version:      3  \r\n      type.googleapis.com\/envoy.config.listener.v3.Listener:  \r\n        Resources:  \r\n          engine_listener:  \r\n            Version:  dba378690d5e204c9d3f1f839821910f40ea5b06e0e1842d8180d78767d032f1  \r\n        Status:       Accepted  \r\n        Version:      3  \r\nEvents:               &lt;none&gt;<\/pre><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><code class=\"codeinline\">Spec.Envoy Resources<\/code> \u2013 Contains the Envoy configuration.<\/li><li class=\"enum-element\"><code class=\"codeinline\">Status.Conditions<\/code>\u200B\u2013 Shows whether the configuration is synchronized\/active on Airlock Engine.<\/li><li class=\"enum-element\"><code class=\"codeinline\">Status.Xds<\/code> \u2013 Shows the different Envoy resources and their status.<\/li><\/ul><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1662655596918_N10032\">The CustomResource <code class=\"codeinline\">EnvoyConfiguration<\/code> is not intended to be created or changed manually. This resource is composed out of the other Airlock Microgateway CustomResources and will be overwritten by the <span class=\"dialog\">Airlock Microgateway Operator<\/span>.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';