var m_1662655604270Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>How to establish security controls<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1662655604270\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">How to establish security controls<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655604270_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1662655604270_N10013\">From an organizational point of view, a perimeter-based security model is easy to establish and maintain: a dedicated team is responsible for security controls. It is the team\'s duty to maintain the configuration, oversee the activities and take all required actions to operate the security devices.<\/p><p class=\"par\" id=\"1662655604270_N1000F1663839685226\">With <i class=\"italics\">DevSecOps<\/i> or <i class=\"italics\">Zero-Trust<\/i>, such a model is difficult or impossible to maintain. Either there is no longer a classic perimeter, or delaying updates to security controls results in obstacles to the rollout of new product versions due to the speed of the project.<\/p><p class=\"par\" id=\"1662655604270_N100121663840343937\">DevSecOps aims to integrate security into every stage of the software development lifecycle, package the software with security controls, and roll them out. Security no longer is an obstacle but a first-class citizen enabling quick but secure deployments.<\/p><p class=\"par\" id=\"1662655604270_N10015\">While this sounds good in general, it also means that responsibilities must be handed over to the software developers as they must implement security controls early. This goes against the old adage that security must be handled by trained personnel only. However, there are undeniable advantages to involving the application developers in implementing security rules: they have in-depth knowledge about the application and easily understand the most problematic areas. Your existing, dedicated security team becomes the guardian of the overall level of security in accordance with compliance requirements. This dedicated team prescribes the guidelines and oversees what security controls are in place. Ideally, your operating platform automatically enforces adherence to these rules.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><ol xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard Alpha\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">With DevSecOps, two types of teams are required:<\/strong><\/li><li class=\"enum-element\">A dedicated <i class=\"italics\">security team<\/i> that is responsible for<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">security controls.<\/li><li class=\"enum-element\">training of project team members.<\/li><li class=\"enum-element\">oversight of what security controls are in place.<\/li><li class=\"enum-element\">maintaining and implementing the newest security features of Airlock Microgateway.<\/li><\/ul><li class=\"enum-element\">Trained <i class=\"italics\">project teams<\/i> that can implement security controls to secure web applications into every stage of the development lifecycle.<\/li><\/ol><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655604270_N1000F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Company-wide \u2013 Overview of security controls<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1662655604270_N10012\">The tasks listed here must be addressed and defined company-wide by the dedicated security team.<\/p><p class=\"par\" id=\"1662655604270_N10017\">Enabling project teams to secure web applications by creating templates and guidelines and educating the project team members is required. It is also required to ensure that insecure setups from the development stages are not moved unintentionally into production. <br\/>Besides that, templates also have a lifecycle \u2013 new security features may become available in newer Airlock Microgateway versions or security assessments change over time and influence the templates\' contents.<\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table-BoldHeaderAndColumn table-BoldHeaderAndColumn table- table-block-description table-\" id=\"1662655604270_N10019\"><col style=\"width:33%;\"\/><col style=\"width:33%;\"\/><col style=\"width:34%;\"\/><thead class=\"thead-BoldHeaderAndColumn\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstrow table-cell-firstrow-BoldHeaderAndColumn table-header table-header-horizontal table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N10037\">Task<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-firstrow table-cell-firstrow-BoldHeaderAndColumn table-header table-header-horizontal table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N1003D1663837648206\">Detail description<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-firstrow table-cell-firstrow-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-header table-header-horizontal table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N100431663837648206\">Remark<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody-BoldHeaderAndColumn\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-header table-header-vertical table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\" rowspan=\"2\"><div><p class=\"par\" id=\"1662655604270_N1004C\">Enforce Policies<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421864871.html\">Empower your counterpart<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421866273.html\">Enforce policies<\/a><\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N10056\">Tools like <i class=\"italics\">Kyverno<\/i>, <i class=\"italics\">Open Policy Agent Gatekeeper<\/i> or <i class=\"italics\">Kubewarden<\/i> allow definition of policies to prohibit deployment of any insecure configuration.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1660804709650.html\">System architecture<\/a><\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N1005F\">Operate an Airlock Gateway in front of the Kubernetes cluster and ensure baseline security.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-header table-header-vertical table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N10067\">Assess the active configuration<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421864871.html\">Empower your counterpart<\/a><\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N1007B\">Apply specialist knowledge to recognize insecure or operationally challenging configurations.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-header table-header-vertical table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N1008B1663848962092\">Monitor and analyze<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1674151136380.html\">Monitor and analyze<\/a><\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N100931663848962092\">Create reports for stakeholders.<\/p><p class=\"par\" id=\"1662655604270_N10120\">Issue alerts to responsible personnel upon suspicious activities.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-lastrow table-cell-lastrow-BoldHeaderAndColumn table-header table-header-vertical table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N1009F\">Establish GitOps principles<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-lastrow table-cell-lastrow-BoldHeaderAndColumn table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1672991882983.html\">Establish GitOps principles<\/a><\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-lastrow table-cell-lastrow-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N100A7\">Although this is not mandatory, it is highly recommended. GitOps help track the changes and ensure review of the active configuration before it is deployed to production.<\/p><\/div><\/td><\/tr><\/tbody><\/table><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655604270_N1015B1669734722034\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Company-wide \u2013 Software development team empowerment<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1662655604270_N100D5\">DevSecOps aims to integrate security into every stage of the software development lifecycle. Software development team members must understand security risks and configure security controls (unlike in a classic security perimeter solution). These tasks require empowerment by the security team.<\/p><p class=\"par\" id=\"1662655604270_N10163\"><strong class=\"emphasis\">The security team accomplishes the following tasks :<\/strong><\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table-BoldHeaderAndColumn table-BoldHeaderAndColumn table- table-block-description table-\" id=\"1662655604270_N10093\"><col style=\"width:33%;\"\/><col style=\"width:33%;\"\/><col style=\"width:34%;\"\/><thead class=\"thead-BoldHeaderAndColumn\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstrow table-cell-firstrow-BoldHeaderAndColumn table-header table-header-horizontal table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N100C8\">Task<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-firstrow table-cell-firstrow-BoldHeaderAndColumn table-header table-header-horizontal table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N100CE\">Detail description<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-firstrow table-cell-firstrow-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-header table-header-horizontal table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N100D4\">Remark<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody-BoldHeaderAndColumn\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-header table-header-vertical table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N100DF\">Education and guidelines<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421864871.html\">Empower your counterpart<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1672991886300.html\">Education and guidelines<\/a><\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Educate the project team about security risks and how security controls should be implemented. <\/li><li class=\"enum-element\">Create corresponding guidelines that help configure Airlock Microgateway.<\/li><\/ul><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-header table-header-vertical table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N100F3\">Blueprints<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421864969.html\">Blueprints<\/a><\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Create and maintain architecture blueprints. <\/li><li class=\"enum-element\">Define which component is responsible to implement specific security mechanisms, the web application or a dedicated security solution like Airlock Microgateway.<\/li><\/ul><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-lastrow table-cell-lastrow-BoldHeaderAndColumn table-header table-header-vertical table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N10103\">Configuration templates<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-lastrow table-cell-lastrow-BoldHeaderAndColumn table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421864871.html\">Empower your counterpart<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421864983.html\">Templates<\/a><\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-lastrow table-cell-lastrow-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-col-odd-BoldHeaderAndColumn\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Create configuration templates for different scenarios - from base settings as a starting point to full-blown configuration for specific use cases.<\/li><\/ul><\/div><\/td><\/tr><\/tbody><\/table><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1662655604270_N10122\">It is hard to correctly implement such blueprints and templates without experience. We recommend to establish channels and processes for project members to ask for guidance and consultancy to assist them in their daily business.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655604270_N102331669734722034\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Company-wide \u2013 Define staging<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1662655604270_N10140\">It is best practice to deploy web applications in stages.<br\/>Starting in the <i class=\"italics\">Development<\/i> stage, where new versions of the web application are developed, also perform integration with Airlock Microgateway and testing. Later stages, such as the <i class=\"italics\">Integration<\/i> environment, expand on the number of integrated components and focus on ever broader aspects for testing, until you reach <i class=\"italics\">Production<\/i>.<br\/>Next to stage-specific settings it is important to define the relevant policies.<\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table-BoldHeaderAndColumn table-BoldHeaderAndColumn table- table-block-description table-\" id=\"1662655604270_N10142\"><col style=\"width:33%;\"\/><col style=\"width:33%;\"\/><col style=\"width:34%;\"\/><thead class=\"thead-BoldHeaderAndColumn\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstrow table-cell-firstrow-BoldHeaderAndColumn table-header table-header-horizontal table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N10158\">Task<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-firstrow table-cell-firstrow-BoldHeaderAndColumn table-header table-header-horizontal table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N1015D\">Detail description<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-firstrow table-cell-firstrow-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-header table-header-horizontal table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N10162\">Remark<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody-BoldHeaderAndColumn\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-header table-header-vertical table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N10168\">Define the stages<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1675772877774.html\">Staging<\/a><\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N10170\">The most crucial step is to define the stages, their purpose and the process of moving newer versions from one stage to another.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-lastrow table-cell-lastrow-BoldHeaderAndColumn table-header table-header-vertical table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N10176\">Stage-specific settings<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-lastrow table-cell-lastrow-BoldHeaderAndColumn table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1675772877774.html#1675772877774_N10013\">Stage-specific settings<\/a><\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-lastrow table-cell-lastrow-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N1017E\">Define the stage-specific settings such as FQDNs, ports, paths, log level, or policies that should be adhered to.<\/p><\/div><\/td><\/tr><\/tbody><\/table><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655604270_N10052\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Project scope \u2013 DevSecOps<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1662655604270_N10055\">The company-wide framework frees project teams from repetitious definition of common security guidelines, instead allowing them to focus on their project plans knowing that the basics have been taken care of.<br\/>The different project phases are illustrated in the graphic below and show that security is part of each phase.<\/p><table border=\"0\" cellspacing=\"0\" class=\"table-NoBorder table table-Nolines table-Nolines table- table-block-description table-\" id=\"1662655604270_N102BD\"><col style=\"width:100%;\"\/><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-firstrow table-cell-firstrow-Nolines table-cell-lastrow table-cell-lastrow-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-col-odd-Nolines\"><div><figure class=\"media\"><div class=\"media-theme\" id=\"1662655604270_N1023A\"><img alt=\"DEV_SEC_OPS\" class=\"media-theme-img-tag svg\" src=\"..\/media\/03_Media\/Vector_drawings\/Microgateway\/13546.DEV_SEC_OPS.theme\/1.4\/en-us.13546.DEV_SEC_OPS_original.svg\" style=\"width:;height:375.76065px;border:0;\"\/><\/div><\/figure><\/div><\/td><\/tr><\/tbody><\/table><table border=\"0\" cellspacing=\"0\" class=\"table table table-BoldHeaderAndColumn table-BoldHeaderAndColumn table- table-block-description table-\" id=\"1662655604270_N10209\"><col style=\"width:33%;\"\/><col style=\"width:33%;\"\/><col style=\"width:34%;\"\/><thead class=\"thead-BoldHeaderAndColumn\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstrow table-cell-firstrow-BoldHeaderAndColumn table-header table-header-horizontal table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N1021F\">Phase<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-firstrow table-cell-firstrow-BoldHeaderAndColumn table-header table-header-horizontal table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N1022D1664202353357\">Detail description<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-firstrow table-cell-firstrow-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-header table-header-horizontal table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N102331664202353357\">Remark<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody-BoldHeaderAndColumn\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-header table-header-vertical table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N1022B\"><i class=\"italics\">Plan<\/i><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421864969.html\">Blueprints<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1675772877774.html\">Staging<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1672991882983.html\">Establish GitOps principles<\/a><\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N10344\">Company-wide blueprints are used as a start for the project and stages are defined, including their differences and purpose of use. Finally, GitOps principles are established.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-header table-header-vertical table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N10237\"><i class=\"italics\">Code<\/i><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1672991886300.html\">Education and guidelines<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421864983.html\">Templates<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1674151136380.html\">Monitor and analyze<\/a><\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N1037C\">Education, guidelines and templates are used to make use of Airlock Microgateway from the beginning. Analyzing the web application and deducing its requirements helps to improve the Airlock Microgateway configuration.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-header table-header-vertical table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N10243\"><i class=\"italics\">Build<\/i><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N103A1\">\u2013<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N1038F\">The new application version is bundled together with the Airlock Microgateway configuration.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-header table-header-vertical table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N1024F\"><i class=\"italics\">Test<\/i><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N103DD\">\u2013<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N103A2\">The application is deployed and tested together with Airlock Microgateway.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-header table-header-vertical table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N1025B\"><i class=\"italics\">Release<\/i><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N103F5\">\u2013<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-header table-header-vertical table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N10267\"><i class=\"italics\">Deploy<\/i><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N1040A\">\u2013<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N103DE\">The new application version is deployed together with Airlock Microgateway.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-header table-header-vertical table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N10273\"><i class=\"italics\">Operate<\/i><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421866273.html\">Enforce policies<\/a><\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-even table-cell-even-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-innerrow table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N104021678267401570\">The active policies prevent undesired settings from being deployed.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-firstcolumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-firstcolumn-BoldHeaderAndColumn table-cell-lastrow table-cell-lastrow-BoldHeaderAndColumn table-header table-header-vertical table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N1027F\"><i class=\"italics\">Monitor<\/i><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-lastrow table-cell-lastrow-BoldHeaderAndColumn table-cell-innercol table-cell-col-even-BoldHeaderAndColumn\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1674151136380.html\">Monitor and analyze<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421866273.html\">Enforce policies<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421864857.html\">Assess the active configuration<\/a><\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeaderAndColumn table-cell-odd table-cell-odd-BoldHeaderAndColumn table-cell-lastrow table-cell-lastrow-BoldHeaderAndColumn table-cell-lastcolumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-lastcolumn-BoldHeaderAndColumn table-cell-col-odd-BoldHeaderAndColumn\"><div><p class=\"par\" id=\"1662655604270_N10444\">Observe the active deployment and initiate appropriate actions if abnormal activities occur.<\/p><\/div><\/td><\/tr><\/tbody><\/table><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1662655604270_N10462\">In this phase, the above-mentioned communication channel between DevSecOps and security teams is essential to incorporate feedback, for example on exceptions and update requirements.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655604270_N104B4\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Shift left and shield right in DevSecOps<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1662655604270_N104B7\"><strong class=\"emphasis\">Shift left<\/strong> is the practice of integrating security, quality and performance in an earlier stage of the development lifecycle. Traditionally, security testing and validation activities are performed at the end of the development cycle, after the application has been built.<br\/>However, this approach can result in security vulnerabilities being discovered late, making them more expensive and time-consuming to fix. By <i class=\"italics\">shifting left<\/i>, security testing, integration of security solutions and validation activities are part of the development process at an earlier stage, such as during code development, code review, and automated testing. <br\/>This approach enables developers to identify and fix security issues earlier in the development cycle. It effectively reduces the risk of security vulnerabilities being introduced into the final product or postponing the going life because of known security issues.<\/p><p class=\"par\" id=\"1662655604270_N104C4\"><strong class=\"emphasis\">Shield right<\/strong> is the practice of ongoing monitoring and protection of applications and systems after they have been deployed to production. While <i class=\"italics\">shift left<\/i> focuses on integrating security into the development process from the very beginning, <i class=\"italics\">shield right<\/i> describes the ongoing efforts to protect the application or system in production from attacks and vulnerabilities.<br\/>To achieve <i class=\"italics\">shield right<\/i>, organizations may use a variety of tools and techniques. This includes security information and event management (SIEM) tools, intrusion detection and prevention systems, <i class=\"italics\">Web Application and API Protection<\/i> (WAAP) and<i class=\"italics\"> Identity and Access Management<\/i> (IAM) with 2FA for strong authentication as well as incident response plans.<br\/>The goal is to create a comprehensive and adaptive security posture to detect and respond to threats in real-time. <\/p><p class=\"par\" id=\"1662655604270_N104AE\"><strong class=\"emphasis\">Shift left and Shield right complement each other<\/strong> to provide comprehensive application protection at all stages of the software development lifecycle. <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Microgateway<\/span> can help to close the gap between the two initiatives: It allows to integrate runtime protection already at development or build time.<\/p><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';