var m_1667549240920Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>CR DenyRules<\/title><meta content=\"CRD DenyRules, black lists, blacklist\" name=\"keywords\"\/><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1667549240920\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">CR DenyRules<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1667549240920_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1667549240920_N1000A\">Airlock Microgateway has built-in deny rules to block malicious requests to upstream web applications. This deny rule set is constantly evolving and updated to respond to the latest threats. <br\/>Each deny rule is identified by a <i class=\"italics\">deny rule key<\/i> that can be referenced for configuration purposes. Each <code class=\"codeinline\">ruleKey<\/code> refers to different attack types such as SQL injection, XSS, TEMPLATE injection, etc. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The CRD DenyRules allows configuring the following in the CR:<\/strong><\/li><li class=\"enum-element\">The security <code class=\"codeinline\">level<\/code> of the applied deny rules.<\/li><li class=\"enum-element\">The <code class=\"codeinline\">threatHandlingMode<\/code> (i.e., <code class=\"codeinline\">Block<\/code> or <code class=\"codeinline\">LogOnly<\/code>) can be configured globally and on the <code class=\"codeinline\">ruleKey<\/code> level.<\/li><li class=\"enum-element\"><i class=\"italics\">Deny rule overrides<\/i> to change settings (e.g. security level or threat handling mode) of specific deny rules.<\/li><li class=\"enum-element\"><i class=\"italics\">Deny rule exceptions<\/i> for requests that match one or more deny rules but should not be blocked. Exceptions can be configured and fine-tuned to reduce the number of false positives using <code class=\"codeinline\">blockedData<\/code> and\/or <code class=\"codeinline\">requestConditions<\/code> based on various characteristics.<\/li><li class=\"enum-element\">The definition of <i class=\"italics\">custom deny rules<\/i>.<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1689952158025_N10154\">This CR needs to be referenced in the <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1659430054462.html\">CR ContentSecurity<\/a>.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1667549240920_N1003E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Example configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1667549240920_N10009\">For the default and an example configuration including custom rules, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"api\/crds\/deny-rules\/\" target=\"_blank\">CR Deny Rules reference documentation<\/a>.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The example covers:<\/strong><\/li><li class=\"enum-element\"><code class=\"codeinline\">spec.request.builtIn.settings<\/code> \u2013 global deny rule settings.<\/li><li class=\"enum-element\"><code class=\"codeinline\">spec.request.builtIn.override<\/code> \u2013 deny rule override, to override the global deny rule settings for some deny rules.<\/li><li class=\"enum-element\"><code class=\"codeinline\">spec.request.builtIn.exceptions<\/code> \u2013 deny rule exceptions.<\/li><li class=\"enum-element\"><code class=\"codeinline\">spec.custom.rules<\/code> \u2013 custom deny rule definition.<\/li><\/ul><p class=\"par\" id=\"1667549240920_N10093\">In addition to the <i class=\"italics\">API Reference<\/i> documentation, this article adds helpful background information for the available configuration options.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1667549240920_N100551669888588273\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Security levels<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1667549240920_N10058\">Different security levels can be configured on <i class=\"italics\">global<\/i> and <i class=\"italics\">deny rule<\/i> levels. This makes it possible to configure the balanced processing of requests with a high level of security and a low number of false positives simultaneously.<\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table-BoldHeader table-BoldHeader table- table-block-description table-\" id=\"1667549240920_N10063\"><col style=\"width:10%;\"\/><col style=\"width:90%;\"\/><thead class=\"thead-BoldHeader\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-header table-header-horizontal table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1667549240920_N1007B1669888843328\">Global level<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-header table-header-horizontal table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1667549240920_N100801669888843328\">Explanation<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody-BoldHeader\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1667549240920_N10075\"><code class=\"codeinline\">Unfiltered<\/code><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1667549240920_N1007B\">In level <code class=\"codeinline\">Unfiltered<\/code>, no deny rules are applied. This means, no requests will be blocked.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1667549240920_N10084\"><code class=\"codeinline\">Basic<\/code><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1667549240920_N10055\">Deny rules in level <code class=\"codeinline\">Basic<\/code> focus on a low false-positive rate, simplifying the integration of applications. Note, however, that certain attack variants may not be covered. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard first last\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Indications for using the level <code class=\"codeinline\">Basic<\/code>:<\/li><li class=\"enum-element\">Level <code class=\"codeinline\">Standard<\/code> requires too many exceptions.<\/li><li class=\"enum-element\">The upstream application access is protected by authentication.<\/li><\/ul><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1667549240920_N100AF\"><code class=\"codeinline\">Standard<\/code><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1667549240920_N10065\">Level <code class=\"codeinline\">Standard<\/code> is the default setting. It provides strong filters and a low false-positive rate. Exceptions may be required for input fields containing syntactical elements similar to JavaScript or SQL. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard first last\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Indications for using the level <code class=\"codeinline\">Standard<\/code>:<\/li><li class=\"enum-element\">The application is complex or dynamic.<\/li><li class=\"enum-element\">The application uses many input fields with unrestricted input values, e.g., free texts or comments.<\/li><li class=\"enum-element\">Application access is protected by upstream authentication.<\/li><li class=\"enum-element\">Level <code class=\"codeinline\">Strict<\/code> requires too many exceptions.<\/li><\/ul><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1667549240920_N100B9\"><code class=\"codeinline\">Strict<\/code><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1667549240920_N10079\">Level <code class=\"codeinline\">Strict<\/code> focuses on blocking many potential attack variants. This level is recommended for very sensitive applications and typically requires some integration effort.  <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard first last\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Indications for using level <code class=\"codeinline\">Strict<\/code>:<\/li><li class=\"enum-element\">Login and critical pages are exposed directly to the Internet without upstream authentication.<\/li><li class=\"enum-element\">The application is rather simple.<\/li><li class=\"enum-element\">Application data is very sensitive (high risk).<\/li><li class=\"enum-element\">Low code quality of an application.<\/li><\/ul><\/div><\/td><\/tr><\/tbody><\/table><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1667549240920_N1012A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Override global settings for specific deny rules<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1667549240920_N10126\">For fine-tuning, i.e., to reduce the number of false positives, the security level or the threat handling mode for individual deny rules may be configured differently from the global settings. To do so, configure non-global security levels for deny rules using the <code class=\"codeinline\">ruleKeys<\/code> or the <code class=\"codeinline\">types<\/code> element.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1667549240920_N10148\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Deny rule exceptions<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1667549240920_N10193\">Deny rule exceptions can be defined for different data elements.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Data element types for exceptions:<\/strong><\/li><li class=\"enum-element\"><code class=\"codeinline\">blockedData<\/code> for exceptions on blocked data elements, e.g., for blocked <i class=\"italics\">parameters<\/i>, <i class=\"italics\">headers<\/i> or <i class=\"italics\">JSON data<\/i>.<br\/>Note that <code class=\"codeinline\">blockedData<\/code> only allows requests if the string triggering the false positive was in the configured <i class=\"italics\">parameter<\/i>, <i class=\"italics\">header<\/i> or <i class=\"italics\">JSON data<\/i>.<\/li><li class=\"enum-element\"><code class=\"codeinline\">requestConditions<\/code>, to create exceptions for general characteristics of blocked requests, e.g. request path or originating remote IP.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Possible deny rule configuration options<\/strong><\/li><li class=\"enum-element\">Define a deny rule exception only with <code class=\"codeinline\">blockedData<\/code>:<\/li><p class=\"par\" id=\"1667549240920_N101C1\">This way, the configured exception is applied unconditionally to all paths, HTTP methods, remote IP addresses, ...<\/p><li class=\"enum-element\">Define a deny rule exception with <code class=\"codeinline\">blockedData<\/code> and <code class=\"codeinline\">requestConditions<\/code>:<\/li><p class=\"par\" id=\"1667549240920_N101CB\">This is the <strong class=\"emphasis\">recommended configuration<\/strong>, as it only applies the exceptions to requests that matches the <code class=\"codeinline\">requestConditions<\/code>.<\/p><li class=\"enum-element\">Define a deny rule exception only with <code class=\"codeinline\">requestConditions<\/code>:<\/li><p class=\"par\" id=\"1667549240920_N101D5\">This configuration should be chosen carefully, as deny rule checks are not applied at all to requests which matches the <code class=\"codeinline\">requestConditions<\/code>.<\/p><\/ul><p class=\"par\" id=\"1667549240920_N101BA\">Note that exceptions will only reduce blocks if the configured exception <i class=\"italics\">covers all data elements that trigger deny rules<\/i>. <\/p><p class=\"par\" id=\"1667549240920_N101C2\">For example, if an exception is configured to unblock <code class=\"codeinline\">search<\/code> parameters, a request containing a <code class=\"codeinline\">search<\/code> and a <code class=\"codeinline\">language<\/code> parameter could still be blocked if the <code class=\"codeinline\">language<\/code> parameter triggers a deny rule. The same mechanism applies to other blocked data elements such as <i class=\"italics\">parameters<\/i>, <i class=\"italics\">headers<\/i> or <i class=\"italics\">JSON data<\/i>.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1667549240920_N10028\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Deny rule exceptions for JSON content<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1667549240920_N10230\">Body data of requests with content-type header <code class=\"codeinline\">application\/json<\/code> are parsed as JSON content and might cause false positives. Deny rule exceptions can be defined for <i class=\"italics\">JSON keys<\/i> or <i class=\"italics\">values<\/i> based on the access log information. Additionally, exceptions can be restricted to a defined JSONPath. In the JSONPath expressions, wildcards (<code class=\"codeinline\">*<\/code>) can be used, like in this <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/goessner.net\/articles\/JsonPath\/\" target=\"_blank\">JSONPath syntax reference<\/a>.<\/p><p class=\"par\" id=\"1667549240920_N10012\"><strong class=\"emphasis\">Example:<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10018\">{ \r\n  \"books\": [ \r\n    { \r\n      \"title\": \"DevSecOps Starters Guide\", \r\n      \"author\": \"Joe Bloggs\", \r\n      \"stars\": 723 \r\n    }, \r\n    { \r\n      \"title\": \"JSONPath for Geeks\", \r\n      \"author\": \"Jane Smith\", \r\n      \"stars\": 27 \r\n    } \r\n  ] \r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1667549240920_N1002B1670589503872\">This JSON example contains 6 key-value pairs (aka leaves), 3 pairs for each book. The values of the JSON leaves can be filtered with the corresponding JSONPath from the following table.<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1001F\">JSONPath          | Value \r\n------------------|---------------------------- \r\n$.books[0].title  | \"DevSecOps Starters Guide\", \r\n$.books[0].author | \"Joe Bloggs\", \r\n$.books[0].stars  | 723 \r\n$.books[1].title  | \"JSONPath for Geeks\", \r\n$.books[1].author | \"Jane Smith\", \r\n$.books[1].stars  | 27<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Additional JSONPath examples:<\/li><li class=\"enum-element\"><code class=\"codeinline\">$..author<\/code> \u2013 matches every leaf of the key <strong class=\"emphasis\">author<\/strong> (<i class=\"italics\">Joe Bloggs<\/i> and <i class=\"italics\">Jane Smith<\/i>) in every book.<\/li><li class=\"enum-element\"><code class=\"codeinline\">$.books[*].author<\/code> \u2013 matches every leaf of the key <code class=\"codeinline\">author<\/code> in all <code class=\"codeinline\">books<\/code>.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1667549240920_N1023B\">For instance, an exception for <i class=\"italics\">all books<\/i> of <i class=\"italics\">authors named Joe<\/i> can be configured as follows.<\/p><p class=\"par\" id=\"1667549240920_N10240\"><strong class=\"emphasis\">Example:<\/strong><\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10033\">apiVersion: microgateway.airlock.com\/v1alpha1\r\nkind: DenyRules\r\nmetadata:\r\n  name: my-webapp\r\n spec: \r\n  request: \r\n    builtIn:\r\n      exceptions: \r\n        - blockedData: \r\n            json: \r\n              jsonPath: $.books[*].author \r\n              value: \r\n                matcher: \r\n                  contains: Joe<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning important compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">For deny rule exceptions, operators <code class=\"codeinline\">[]<\/code> with expressions and script expressions are not supported. For example, <code class=\"codeinline\">$..book[?(@.age)].title<\/code> does <strong class=\"emphasis\">NOT<\/strong> work as JSONPath expression.<\/li><li class=\"enum-element\">The JSONPath expression must always match a leaf. For example, <code class=\"codeinline\">$.books[*]<\/code> does not contain a leaf and will not work, whereas <code class=\"codeinline\">$.books[*].author<\/code> does.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1667549240920_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Custom deny rules<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1667549240920_N101A21676473241547\"><i class=\"italics\">Custom deny rules<\/i> can be configured to complement the <i class=\"italics\">built-in deny rules<\/i>. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Difference to built-in deny rules:<\/strong><\/li><li class=\"enum-element\"> Custom rules can be added in the <i class=\"italics\">CR DenyRules<\/i>. <\/li><li class=\"enum-element\"> Security levels and exceptions cannot be applied to custom deny rules.<\/li><\/ul><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1667549240920_N1002C\">If one of the configured rules matches a request, the <code class=\"codeinline\">ruleKey<\/code> is included in the corresponding access log message. Therefore, we recommend using short, descriptive denominations for rule keys.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1667549240920_N10209\">Note that the <code class=\"codeinline\">ruleKey<\/code> must be a unique denomination and match <code class=\"codeinline\">^[A-Z][A-Z0-9_]*$<\/code>, e.g.  <code class=\"codeinline\">ruleKey: MY_CUSTOM_KEY_01<\/code>. <\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1667549240920_N1002E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">API Reference:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"api\/crds\/deny-rules\/\" target=\"_blank\">CR Deny Rules reference documentation<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"api\/crds\/content-security\/\" target=\"_blank\">CR Content Security reference documentation<\/a><\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1702376369898.html\">Reducing false-positive blocks<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1674151144160.html\">Default access log field reference<\/a><\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">External links:<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/goessner.net\/articles\/JsonPath\/\" target=\"_blank\">JSONPath syntax reference<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';