var m_1668421864857Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Assess the active configuration<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1668421864857\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Assess the active configuration<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421864857_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1668421864857_N1000B\">There are a number of reasons why it could be interesting to assess the active Microgateway configurations.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Reasons for assessing the configuration:<\/strong><\/li><li class=\"enum-element\">Current attack vector (e.g. Log4Shell).<\/li><li class=\"enum-element\">Mistake in older template or guideline.<\/li><li class=\"enum-element\">Feedback from operations to adjust a setting.<\/li><li class=\"enum-element\">Before preventing a certain setting with a new policy.<\/li><li class=\"enum-element\">Get an overview of used features before upgrading.<\/li><li class=\"enum-element\">After upgrading to enable certain settings.<\/li><li class=\"enum-element\">...<\/li><\/ul><p class=\"par\" id=\"1668421864857_N1001A1669380655999\">No matter the motivation, the aim is to find all configurations with a certain setting enabled, disabled, or not used at all. By identifying the affected configurations, further actions can be initiated.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1668421864857_N10017\">Critical security settings should be enforced with policies. It is not recommended to assess active configuration to check policy compliance solely.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421864857_N10019\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Tooling<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1668421864857_N1001C\">The Microgateway configuration is defined as Kubernetes resources that could be assessed in different ways. The most obvious ones are mentioned as follows.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">How to assess active configuration:<\/strong><\/li><li class=\"enum-element\">With the power of <code class=\"codeinline\">kubectl<\/code>.<\/li><li class=\"enum-element\">With the power of <code class=\"codeinline\">kubectl<\/code> combined with <code class=\"codeinline\">jq<\/code>.<\/li><li class=\"enum-element\">Configure policies in audit mode.<\/li><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1668421864857_N1004A\">Policy tools can usually create policies in audit mode. Violating configurations will not be prevented from being deployed but it is possible to get a report of those configurations. Additionally, policies can also be enabled for background scanning, so old Kubernetes resources would be evaluated too. To follow this approach, consider <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421866273.html\">Enforce policies<\/a> but set the mode to <code class=\"codeinline\">audit<\/code>. For further information read the manual of the corresponding tool.<\/p><\/div><\/div><\/div><\/div><\/div><li class=\"enum-element\">Investigate the Kubernetes resources directly in Git.<\/li><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1668421864857_N1006A\">If a GitOps process is in place, that would be an additional possibility.<\/p><\/div><\/div><\/div><\/div><\/div><\/ul><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1671126687512_N1000D\"><strong class=\"emphasis\">General tips for working with CRs<\/strong><\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">CLI:<\/li><li class=\"enum-element\">Use <code class=\"codeinline\">kubectl explain &lt;replace with CRD name&gt; --recursive<\/code> to list all available options and the YAML structure.<\/li><li class=\"enum-element\">Check the CRD description texts with <code class=\"codeinline\">kubectl explain &lt;replace with CRD name and path&gt;<\/code> of the available options for more details.<\/li><\/ul><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">API Reference documentation:<\/li><li class=\"enum-element\">Click on the link to open the CR-related documentation in a new browser tab or window: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"api\/crds\/index.html\" target=\"_blank\">CRD Reference documentation<\/a>.  See also the API Reference documentation links at the end article.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421864857_N10020\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Examples<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1668421864857_N10075\">The examples show how to assess the Kubernetes resources using <code class=\"codeinline\">kubectl<\/code>. This way it is possible to get an overview of deployed resources and their settings. With<code class=\"codeinline\">jq<\/code> even more sophisticated queries are possible.<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10026\"># List status of SidecarGateways\r\nkubectl get sidecargateways.microgateway.airlock.com -o=custom-columns=\'NAME:{.metadata.name},STATUS:{.status.status}\' --sort-by=.metadata.name<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10086\"># List used native Envoy HTTP filters\r\nkubectl get envoyhttpfilters.microgateway.airlock.com -o=custom-columns=\'NAME:{.metadata.name},ENVOY_FILTER:{.spec.value.typed_config.\\@type}\' --sort-by=.metadata.name<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1008C\"># List DenyRules and the configured level and threatHandlingMode.\r\nkubectl get denyrules.microgateway.airlock.com -o=custom-columns=\'NAME:{.metadata.name},LEVEL:{.spec.request.builtIn.settings.level},THREAT_HANDLING_MODE:{.spec.request.builtIn.settings.threatHandlingMode}\' --sort-by=.metadata.name<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10093\"># List the DenyRules with level \"Standard\"\r\nkubectl get denyrules.microgateway.airlock.com -o=json | jq \'.items[] | select(.spec.request.builtIn.settings.level == \"Standard\") | [ .metadata.name, .spec.request.builtIn.settings.level ] | @csv\'<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1672991879137_N1000D\">The different log types, such as access or application logs, can be printed using the <code class=\"codeinline\">kubectl logs<\/code> as mixed output. You may filter the printed logs according to your needs for better orientation.<\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Use <code class=\"codeinline\">kubectl logs &lt;POD&gt; -c airlock-microgateway-engine<\/code> to print the logs for the engine container in a pod. For more options, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/jamesdefabia.github.io\/docs\/user-guide\/kubectl\/kubectl_logs\/\" target=\"_blank\">kubectl logs reference<\/a>.<\/li><li class=\"enum-element\">Use <code class=\"codeinline\">grep &lt;query&gt;<\/code> to filter the log-message output according to your requirements.<\/li><li class=\"enum-element\">With the jq-JSON processor (or equivalent) installed, you may pipe the logs output to the processor for better formatting and readability. See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/stedolan.github.io\/jq\/\" target=\"_blank\">JQ<\/a> for further information.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421864857_N1008F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">External links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/kubernetes.io\/docs\/reference\/kubectl\/jsonpath\/\" target=\"_blank\">(Kubernetes) JSONPath<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/stedolan.github.io\/jq\/\" target=\"_blank\">jq-JSON processor<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421866273.html\">Enforce policies<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';