var m_1668421864871Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Empower your counterpart<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1668421864871\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Empower your counterpart<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421864871_N10008\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1668421864871_N1000B\">The main aim of <i class=\"italics\">DevSecOps<\/i> is to integrate security into every stage of the software development lifecycle. While this sounds good in general, it also means that responsibilities must be handed over to the software developers. It is still the security team\'s duty to take care of the organization\'s security but the settings are made by other teams as well. Shared responsibility is in place!<br\/>What needs to be done from an organizational perspective to minimize the effort for the developers to integrate a web application and, at the same time, ensure that certain security controls are configured is outlined here. <\/p><p class=\"par\" id=\"1668421864871_N10014\">This article gives an overview of common tasks while subchapters explain a specific topic.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421864871_N100131668694373266\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Where to start?<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1668421864871_N100161668694373266\">One of the first things that must be accomplished is to define the high-level architecture as described in <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1660804709650.html\">System architecture<\/a>. Each architecture has its benefits and directly influences how policies can be enforced, how blueprints look like and what should be part of a Microgateway configuration template. <\/p><p class=\"par\" id=\"1668421864871_N10025\">Afterward, <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421864969.html\">Blueprints<\/a> should be created. They describe what a web application can expect from the upfront security components. E.g. that the traffic is filtered, the users are authenticated and their identity is propagated in a JWT.<\/p><p class=\"par\" id=\"1668421864871_N10036\">Knowing what the architecture looks like, you can start identifying security settings.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421864871_N1003E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Identify security settings<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1668421864871_N100411668697216316\">The objective of identifying security settings is to later apply the required measurements and ensure that particular settings are enabled in production.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Possible sources for security settings:<\/strong><\/li><li class=\"enum-element\">Regulatory compliance.<\/li><li class=\"enum-element\">The Company\'s desired security risk level that is also reflected in the blueprint.<\/li><li class=\"enum-element\">Current attack vectors (e.g. Log4Shell, ...).<\/li><li class=\"enum-element\">Feedback from pen tests.<\/li><li class=\"enum-element\">The functionality of the security components.<\/li><\/ul><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1668421864871_N10054\">It might be obvious that these sources change over time and must be re-evaluated as well as some of them might be optional while others are mandatory.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1668421864871_N1005C\">By going through the settings Airlock Microgateway provides, candidates for configuration templates can be identified.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Sources for Airlock Microgateway settings:<\/strong><\/li><li class=\"enum-element\">Consider the Airlock Microgateway manual.<\/li><li class=\"enum-element\">Go through the Airlock Microgateway <code class=\"codeinline\">CustomResourceDefinition<\/code> with <code class=\"codeinline\">kubectl explain<\/code>.<\/li><\/ul><p class=\"par\" id=\"1668421864871_N1005E\">Depending if a certain security setting is mandatory or not it should be part of a policy and enforced or in a template and facultative.<\/p><table border=\"0\" cellspacing=\"0\" class=\"table-NoBorder table table-Nolines table-Nolines table- table-block-description table-\" id=\"1668421864871_N1007D1692701687886\"><col style=\"width:50%;\"\/><col style=\"width:50%;\"\/><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-firstrow table-cell-firstrow-Nolines table-cell-lastrow table-cell-lastrow-Nolines table-cell-col-odd-Nolines\"><div><ul class=\"enum-enum-instruction container-enum enum-standard standard first last\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Possible settings to disallow by policies:<\/strong><\/li><li class=\"enum-element\">deny rules in log-only mode,<\/li><li class=\"enum-element\">allow rules in log-only mode,<\/li><li class=\"enum-element\">injecting HSTS header is disabled,<\/li><li class=\"enum-element\">limits are set too high,<\/li><li class=\"enum-element\">...<\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstrow table-cell-firstrow-Nolines table-cell-lastrow table-cell-lastrow-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-col-even-Nolines\"><div><ul class=\"enum-enum-instruction container-enum enum-standard standard first last\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Possible settings to recommend, but not disallowed:<\/strong><\/li><li class=\"enum-element\">only allow standard HTTP request headers,<\/li><li class=\"enum-element\">default allow-rule to restrict unused HTTP methods,<\/li><li class=\"enum-element\">inject CSP header,<\/li><li class=\"enum-element\">...<\/li><\/ul><\/div><\/td><\/tr><\/tbody><\/table><p class=\"par\" id=\"1668421864871_N10085\">After identifying the settings that should be configured, either mandatory or optional, the required actions could take place. <\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421864871_N100AE\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Lifecycle<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1668421864871_N100B1\">As mentioned in <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1668421864871.html#1668421864871_N1003E\">Identify security settings<\/a>, the settings might change over time and must be re-evaluated.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Therefore, it is crucial to do the following:<\/li><li class=\"enum-element\">Identify the team responsible for maintaining the templates, policies and guidelines and communicate that.<\/li><li class=\"enum-element\">Oversee the active configurations, which violate policies or do not follow guidelines.<\/li><li class=\"enum-element\">Incorporate new findings from development or operation into new versions of these resources (templates, policies, guidelines).<\/li><li class=\"enum-element\">Re-evaluate if the policies differ in context (e.g. development stage vs. production).<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1668421864871_N100CB\">Enabling your counterpart with templates reduces the time to integrate a web application. Policies ensure that unwanted settings are not staged accidentally to production. Nevertheless, do not forget to educate your counterparts to use these resources accordingly.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1668421864871_N100CD\">Templates, policies, guidelines and education already help ensure that only the desired configuration is staged for production. In order to establish a config review, it could make sense to establish a GitOps process. This way, mistakes that might be difficult to identify by tools can be mitigated by humans.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1565679354540_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Chapter content<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"generate-box generate-Contents\"><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1668421864969.html\" style=\"margin-left:0px\">4.1.1. Blueprints<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1668421864983.html\" style=\"margin-left:0px\">4.1.2. Templates<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1668421866273.html\" style=\"margin-left:0px\">4.1.3. Enforce policies<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1668421864857.html\" style=\"margin-left:0px\">4.1.4. Assess the active configuration<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1674151136380.html\" style=\"margin-left:0px\">4.1.5. Monitor and analyze<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1672991886300.html\" style=\"margin-left:0px\">4.1.6. Education and guidelines<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1672991882983.html\" style=\"margin-left:0px\">4.1.7. Establish GitOps principles<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1675772877774.html\" style=\"margin-left:0px\">4.1.8. Staging<\/a><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';