var m_1668421864983Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Templates<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1668421864983\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Templates<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421864983_N100081669734141984\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1668421864983_N1000B\">To reduce integration overhead and standardize secure configurations of the Airlock Microgateway across web applications we recommend defining configuration templates. Typically the <i class=\"italics\">security team<\/i> is still responsible for the company\'s security which is why they should create and maintain the templates.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">From an organizational point of view, it is highly suggested to do the following:<\/strong><\/li><li class=\"enum-element\">Define the responsible team to maintain the templates.<\/li><li class=\"enum-element\">Ensure that the templates are aligned with the guidelines.<\/li><li class=\"enum-element\">Ensure that the templates do not contain prohibited settings.<\/li><li class=\"enum-element\">The project teams know how who to contact in case they have issues with the templates.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">From a technical point of view, the templates could contain settings like this:<\/strong><\/li><li class=\"enum-element\">Organization-specific security defaults which differ from the Airlock Microgateway defaults:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Custom allow rules<\/li><li class=\"enum-element\">Custom deny rules<\/li><li class=\"enum-element\">Security headers<\/li><li class=\"enum-element\">...<\/li><\/ul><li class=\"enum-element\">Settings that can be reused because of architectural decisions:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Send certain HTTP headers to the upstream service<\/li><li class=\"enum-element\">Exclude certain paths or ports from being filtered (e.g. metrics or probes endpoints)<\/li><li class=\"enum-element\">Send all requests to Open Policy Agent through ext_authz<\/li><li class=\"enum-element\">...<\/li><\/ul><li class=\"enum-element\">...<\/li><\/ul><p class=\"par\" id=\"1668421864983_N100141669722889950\">This allows easier integration and would be a good starting point for the project teams.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1668421864983_N1003A\">Templates have their lifecycle. This is because suggested settings change over time or new features become available in Microgateway. Therefore, it is highly recommended to put the templates under version control and include a label containing the version. This way it is possible to see which web applications still use the old templates and update them.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421864983_N10058\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Tooling<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1668421864983_N1005B1669734599909\">There are different tools available to work with templates.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Some ideas are:<\/strong><\/li><li class=\"enum-element\">Copy the templates files and modify them (no real templating).<\/li><li class=\"enum-element\">Use <code class=\"codeinline\">kustomize<\/code> to use the template files and patch the desired settings.<\/li><li class=\"enum-element\">Use <code class=\"codeinline\">yq<\/code> and generate the new Kubernetes manifest files.<\/li><li class=\"enum-element\">Create a <code class=\"codeinline\">helm<\/code> chart for the templates.<\/li><li class=\"enum-element\">Templating Kubernetes resources with code (Java, Go, Python, Node.js, C#).<\/li><\/ul><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1668421864983_N1007D\">The following website describes very well different options for templating and might be a help for making a decision: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/learnk8s.io\/templating-yaml-with-code\" target=\"_blank\">Templating YAML in Kubernetes with real code<\/a><\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1668421864983_N1007A1669814118646\">From our point of view, <code class=\"codeinline\">kustomize<\/code> is the easiest way to do templating and has a low entry barrier. This is why the example illustrates how such a solution could look with <code class=\"codeinline\">kustomize<\/code>.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1671126687512_N1000D\"><strong class=\"emphasis\">General tips for working with CRs<\/strong><\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">CLI:<\/li><li class=\"enum-element\">Use <code class=\"codeinline\">kubectl explain &lt;replace with CRD name&gt; --recursive<\/code> to list all available options and the YAML structure.<\/li><li class=\"enum-element\">Check the CRD description texts with <code class=\"codeinline\">kubectl explain &lt;replace with CRD name and path&gt;<\/code> of the available options for more details.<\/li><\/ul><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">API Reference documentation:<\/li><li class=\"enum-element\">Click on the link to open the CR-related documentation in a new browser tab or window: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"api\/crds\/index.html\" target=\"_blank\">CRD Reference documentation<\/a>.  See also the API Reference documentation links at the end article.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421864983_N1005A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Example<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1668421864983_N10085\">We made a configuration example available on GitHub which can be used as a starting point for templating with <code class=\"codeinline\">kustomize<\/code>. See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/github.com\/airlock\/microgateway\/tree\/main\/examples\" target=\"_blank\">(Github) Airlock Microgateway - Examples<\/a> in the folder <code class=\"codeinline\">configurations\/templating<\/code>.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1668421864983_N100CD\">The example templates contains information on the <i class=\"italics\">project owner<\/i>, <i class=\"italics\">project contact<\/i> and the <i class=\"italics\">template version<\/i>. This allows you to search for old template versions still in productive use and get in contact with the responsible <i class=\"italics\">project team<\/i> if required.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421864983_N1008F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">External links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/github.com\/airlock\/microgateway\/tree\/main\/examples\" target=\"_blank\">https:\/\/github.com\/airlock\/microgateway\/tree\/main\/examples<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/kubernetes.io\/docs\/tasks\/manage-kubernetes-objects\/kustomization\/\" target=\"_blank\">(Kubernetes) Kustomize<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/mikefarah.gitbook.io\/yq\/\" target=\"_blank\">YQ<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/learnk8s.io\/templating-yaml-with-code\" target=\"_blank\">Templating YAML in Kubernetes with real code<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/github.com\/learnk8s\/templating-kubernetes\" target=\"_blank\">(Github) Templating Kubernetes<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';