var m_1672991882983Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Establish GitOps principles<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1672991882983\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Establish GitOps principles<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1672991882983_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1672991882983_N1000A\">DevOps aims to reunite development and operations teams and automate the process of bringing new software versions into the production environment. To achieve that, automation frameworks support a way to describe what and how a software component should be deployed. This could be achieved either in an imperative or declarative manner. In DevOps, these ways are called paradigms.<\/p><p class=\"par\" id=\"1672991882983_N1000C\">With imperative practise (e.g. <code class=\"codeinline\">kubectl create deployment nginx --image=nginx<\/code>, <code class=\"codeinline\">kubectl expose deployment nginx --port=80 --target-port=8000<\/code>, ... ), the order of the commands is relevant. In case a previous step has not been executed, the command fails. <\/p><p class=\"par\" id=\"1672991882983_N100161673861670354\">The declarative way does not rely on previous configuration steps and is lesser error-prone. A file contains the desired state and e.g. Kubernetes ensures that the actual state is adjusted to the desired state. This is also why it is best practice to store the manifests files for Kubernetes resources to deploy or redeploy them. This way it is guaranteed whenever and wherever the same manifest files are applied that the same resources are created and the application is running as the last time. <\/p><p class=\"par\" id=\"1672991882983_N10019\"><strong class=\"emphasis\">The big question is:<\/strong> where to store these Kubernetes manifest files?<\/p><p class=\"par\" id=\"1672991882983_N10010\">Typically these Kubernetes manifest files could change based on the functionality of the application which will be deployed. For example, if the application is extended with probes endpoints, the corresponding Kubernetes manifest file should be adjusted to use them. Since the manifest files are bound tight to the software it does make sense to store them in the same version control system. Nowadays, this is usually Git.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1672991882983_N10013\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">What is GitOps?<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1672991882983_N10016\">GitOps is an operational framework that takes DevOps best practices for application development such as version control, collaboration, compliance and CI\/CD tooling, and applies them to infrastructure automation.<\/p><p class=\"par\" id=\"1672991882983_N10018\">While the software development life cycle has been automated, infrastructure has remained a largely manual process that requires specialized teams. With the target to have more frequent and smaller releases, it has become a demand in today\'s infrastructure to automate the deployment task as well.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1672991882983_N1001A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Benefits<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><strong class=\"emphasis\">Developer friendly experience<\/strong><\/li><p class=\"par\" id=\"1672991882983_N10026\">It helps developers to use the tool they are familiar with to maintain resources within Kubernetes.<\/p><li class=\"enum-element\"><strong class=\"emphasis\">Reliable<\/strong><\/li><p class=\"par\" id=\"1672991882983_N1002D\">Because the software version and the Kubernetes manifest files which also contain the configuration are bundled together, it is easily possible to roll back to a stable version without headache.<\/p><li class=\"enum-element\"><strong class=\"emphasis\">Rapid deployment<\/strong><\/li><p class=\"par\" id=\"1672991882983_N10031\">New software versions can be deployed rapidly into other stages (e.g. Integration, Production, ...)<\/p><li class=\"enum-element\"><strong class=\"emphasis\">Self declarative documentation<\/strong><\/li><p class=\"par\" id=\"1672991882983_N10035\">Since the Kubernetes manifest files describe in a declarative manner what should be deployed, a certain version can be checked out from Git and analyzed which software version is used with which configuration.<\/p><li class=\"enum-element\"><strong class=\"emphasis\">Security and Compliance<\/strong><\/li><p class=\"par\" id=\"1672991882983_N10039\">GitOps helps companies to stay secure and compliant. Access can be restricted and the manifest files are under version control. This makes auditing much easier.<\/p><\/ul><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1672991882983_N10046\">This way the security control mechanism of Airlock Microgateway is also under version control and can be audited.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1672991882983_N1004A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">GitOps pipeline<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1672991882983_N1004F\">A GitOps pipeline looks like this:<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1672991882983_N10053\"><img alt=\"GitOps pipeline\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/03_Media\/Vector_drawings\/Microgateway\/13547.GitOps_pipeline.theme\/1.2\/en-us.13547.GitOps_pipeline_original.svg\" style=\"width:;height:329px;border:0;\"\/><\/div><\/figure><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">A user changes the application code and pushes it to the Git repository.<\/li><li class=\"step\">A new container is built and tested and pushed into a container registry in a CI\/CD pipeline.<\/li><li class=\"step\">A Pull request is created for the Git repository containing the Kubernetes manifest files.<\/li><li class=\"step\">Someone verifies the Pull request. In case everything is fine, the Pull request is merged.<\/li><li class=\"step\">A GitOps tool detects the changes and ensures that the new desired is deployed.<\/li><\/ol><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1672991882983_N100731673434901898\">Most important, GitOps is all about making sure that Git is the source of truth at least for the desired state.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1672991882983_N10070\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">GitOps tools<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1672991882983_N10073\">There exist many GitOps tools to implement the mentioned GitOps pipeline.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Some of the most common are:<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/argo-cd.readthedocs.io\/en\/stable\/\" target=\"_blank\">ArgoCD<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/fluxcd.io\/\" target=\"_blank\">Flux<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/jenkins-x.io\/\" target=\"_blank\">Jenkins X<\/a><\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1672991882983_N100B8\">As illustrated in the GitOps pipeline graphic, GitOps requires Git and Kubernetes. <\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';