var m_1674151136380Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Monitor and analyze<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1674151136380\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Monitor and analyze<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1674151136380_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1674151136380_N1000A\">The desired security controls should be in place after following the steps described in <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1662655604270.html\">How to establish security controls<\/a>. However, the attack surface might change over time (new vulnerabilities arise, ciphers are not secure anymore, etc.) or new best practices are established. Therefore, it is important to constantly monitor and analyze your environment and adjust the configuration dynamically.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Insights from this task may influence the following artifacts:<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421864983.html\">Templates<\/a> \u2013 If new settings must be enabled by default, they should be part of the templates.<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421866273.html\">Enforce policies<\/a> \u2013 Some settings may become deprecated or even prohibited. That could be enforced by a policy.<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421864857.html\">Assess the active configuration<\/a> \u2013 The active configuration must conform to the  desired settings.<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1672991886300.html\">Education and guidelines<\/a> \u2013 Make sure that best practices and training material is always up-to-date.<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421864969.html\">Blueprints<\/a> \u2013 In certain cases, even the blueprint may be reconsidered.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1674151136380_N1000B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Monitor<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1674151136380_N100741675241565026\">Some elements should be considered for constant monitoring.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Watch the allowed and blocked requests.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Keep an eye on the following:<\/li><li class=\"enum-element\">Amount of requests<\/li><li class=\"enum-element\">Originating geo-locations<\/li><li class=\"enum-element\">Kind of requests (GET, POST, ...)<\/li><li class=\"enum-element\">Request paths<\/li><li class=\"enum-element\">User agents (Firefox, Chrome, ...)<\/li><\/ul><p class=\"par\" id=\"1674151136380_N10089\">High numbers of blocked requests may indicate ongoing attacks, misconfiguration or application errors.<\/p><p class=\"par\" id=\"1674151136380_N1008B\">Deviation of allowed requests from normal patterns may indicate user behavior change, new types of clients or application errors.<\/p><li class=\"step\">Watch for errors in your logs.<\/li><p class=\"par\" id=\"1674151136380_N10092\">An increase of errors could be caused by misconfiguration, issues in a particular component or an attack.<\/p><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1674151136380_N1000E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Analyze<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1674151136380_N1009A\">Security controls allow for the enforcement of established policies. However, to improve the current policies, a deep dive analysis should be performed from time to time.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Deep dive analysis tasks, recommended from time to time:<\/li><li class=\"enum-element\">Run a penetration test by a specialized security company.<\/li><li class=\"enum-element\">Check the rating of your domains with <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/www.ssllabs.com\/ssltest\/\" target=\"_blank\">SSL Labs<\/a>. Trigger the according action if there are  suggestions.<\/li><li class=\"enum-element\">Check the rating of your domain with <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/securityheaders.com\" target=\"_blank\">Security Headers<\/a>. The website <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/caniuse.com\/\" target=\"_blank\">Can I use<\/a> informs about adoption of specific security headers. Guidelines on user agents that must be supported may help prioritize changes.<\/li><li class=\"enum-element\">Evalute new or currently unused features provided by Airlock. Think about how they could increase security.<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1674151136380_N100B71674743634148\">Depending on who is terminating the TLS connection and modifying HTTP headers, actions must be taken in different infrastructure components.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1674151136380_N1008F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421864969.html\">Blueprints<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421864983.html\">Templates<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421866273.html\">Enforce policies<\/a><\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">External links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/www.ssllabs.com\/ssltest\/\" target=\"_blank\">SSL Labs<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/securityheaders.com\" target=\"_blank\">Security Headers<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/caniuse.com\/\" target=\"_blank\">Can I use<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';