var m_1678772778804Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>CR Limits<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1678772778804\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">CR Limits<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1678772778804_N100081679059514049\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1678772778804_N1000A\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Microgateway<\/span> performs various size checks on requests with a default configuration to repel denial of service (DoS) attacks. The <i class=\"italics\">CR Limits<\/i> can be used to configure these limit checks on the route level. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Limit checks are available for:<\/strong><\/li><li class=\"enum-element\">Number and size of parameters.<\/li><li class=\"enum-element\">General request properties like body size or path length.<\/li><li class=\"enum-element\">Various aspects of JSON Payload.<\/li><li class=\"enum-element\">A global header size check (can be configured in the <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1661841842553.html#1661841842553_N1043E\">Limiting request headers length<\/a>).<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1689952158025_N10154\">This CR needs to be referenced in the <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1659430054462.html\">CR ContentSecurity<\/a>.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1678772778804_N10008\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Example configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1678772778804_N10009\">For the default and an example configuration, see the latest API Reference information in chapter <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"api\/crds\/limits\/\" target=\"_blank\">Limits<\/a>.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">All limits are calculated in bytes:<\/strong><\/li><li class=\"enum-element\">JSON limits will only be applied if the JSON parser in the <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1675772881974.html\">CR Parser<\/a> is enabled.<\/li><li class=\"enum-element\">Body size limits are calculated for the payload without percent or HTML decoding. Limits will only be applied for request bodies that Airlock Microgateway effectively parses.<\/li><li class=\"enum-element\">Other limits, such as parameter size, are counted in decoded form.<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1678772778804_N100BC\">The maximum <code class=\"codeinline\">headersLength<\/code> count includes Envoy pseudo headers and can be configured in the CR SidecarGateway as described here: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1661841842553.html#1661841842553_N1043E\">Limiting request headers length<\/a>.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1678772778804_N1002F\">Size limits like <code class=\"codeinline\">bodySize<\/code>, <code class=\"codeinline\">nameLength<\/code> , etc., can be specified in bytes or Kubernetes memory limit units.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Examples of Kubernetes memory limits:<\/strong><\/li><li class=\"enum-element\"><code class=\"codeinline\">1k<\/code> = 1\'000 bytes<\/li><li class=\"enum-element\"><code class=\"codeinline\">1Ki<\/code> = 1\'024 bytes<\/li><li class=\"enum-element\"><code class=\"codeinline\">1M<\/code> = 1\'000\'000 bytes<\/li><li class=\"enum-element\"><code class=\"codeinline\">1Mi<\/code> = 1\'048\'576 bytes<\/li><\/ul><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1678772778804_N100D1\">Limits can be deactivated with <code class=\"codeinline\">unlimited {}<\/code>. Keep in mind that this disables the denial of service (DoS) protection and therefore is not recommended in production environments.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1678772778804_N10066\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Threat handling mode settings<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1678772778804_N100E7\">When a request causes a block due to reaching the request size limit in <code class=\"codeinline\">Block<\/code> mode, it is possible that the total request size is not fully logged. For example, it can happen that the actual <i class=\"italics\">parameter name length<\/i> is not part of the logging information because the request size limit has already been reached before and the request is already blocked. This behavior is to mitigate the risk of being vulnerable to DoS attacks.<\/p><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1678772778804_N100FA\">Detailed limit violations can be logged with <code class=\"codeinline\">settings.threatHandlingMode: LogOnly<\/code>. Keep in mind that this disables the denial of service (DoS) protection and therefore is not recommended in production environments.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1678772778804_N100F4\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Logging<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1678772778804_N100F7\">The logs may vary depending on the <code class=\"codeinline\">settings.threatHandlingMode<\/code>. In <code class=\"codeinline\">Block<\/code> mode, only the available information are logged to still provide protection against denial of service attacks. This could lead that some information are missing. In <code class=\"codeinline\">LogOnly<\/code> mode, all limits-related information are logged but the Limits feature itself does not provide any protection against denial of service attacks.<\/p><p class=\"par\" id=\"1678772778804_N100FF\"><strong class=\"emphasis\">Example log output in both <code class=\"codeinline\">threadHandlingMode<\/code>:<\/strong><\/p><p class=\"par\" id=\"1678772778804_N10109\">The following examples show two types of limit violations, <code class=\"codeinline\">body size<\/code> and <code class=\"codeinline\">JSON key length<\/code>, in both threathandling modes.<\/p><p class=\"par\" id=\"1678772778804_N10112\">As expected, the <code class=\"codeinline\">body.size<\/code> value is not shown in <code class=\"codeinline\">Block<\/code> mode in opposition to the JSON <code class=\"codeinline\">key.length<\/code> value (which requires parsing the JSON body for length calculation).<\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table-BoldHeader table-BoldHeader table- table-block-description table-\" id=\"1678772778804_N1001A\"><col style=\"width:50%;\"\/><col style=\"width:50%;\"\/><thead class=\"thead-BoldHeader\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-header table-header-horizontal table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1678772778804_N1002C\">Block mode<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-header table-header-horizontal table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1678772778804_N10031\">LogOnly mode<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody-BoldHeader\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10134\"># body size, block \r\n \r\n    \"limits\": { \r\n      \"matches\": [ \r\n        { \r\n          \"blocked_data\": { \r\n            \"body\": {} \r\n          }, \r\n          \"rule\": \"Built-in: Request body size\", \r\n          \"threat_handling_mode\": \"block\" \r\n        } \r\n      ] \r\n    },<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-even-BoldHeader\"><div><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10042\"># body size, logOnly \r\n \r\n    \"limits\": { \r\n      \"matches\": [ \r\n        { \r\n          \"blocked_data\": { \r\n            \"body\": { \r\n              \"size\": 219 \r\n            } \r\n          }, \r\n          \"rule\": \"Built-in: Request body size\", \r\n          \"threat_handling_mode\": \"logOnly\" \r\n        } \r\n      ] \r\n    },<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-col-odd-BoldHeader\"><div><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1004B\"># JSON key length, block \r\n \r\n    \"limits\": { \r\n      \"matches\": [ \r\n        { \r\n          \"blocked_data\": { \r\n            \"json_key\": { \r\n              \"json_path\": \"$[\'username\']\", \r\n              \"key\": \"username\", \r\n              \"length\": 12 \r\n            } \r\n          }, \r\n          \"rule\": \"Built-in: JSON key length\", \r\n          \"threat_handling_mode\": \"block\" \r\n        } \r\n      ] \r\n    },<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-col-even-BoldHeader\"><div><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10053\"># JSON key length, logOnly \r\n \r\n    \"limits\": { \r\n      \"matches\": [ \r\n        { \r\n          \"blocked_data\": { \r\n            \"json_key\": { \r\n              \"json_path\": \"$[\'username\']\", \r\n              \"key\": \"username\", \r\n              \"length\": 12 \r\n            } \r\n          }, \r\n          \"rule\": \"Built-in: JSON key length\", \r\n          \"threat_handling_mode\": \"logOnly\" \r\n        } \r\n      ] \r\n    }, \r\n<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/td><\/tr><\/tbody><\/table><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1678772778804_N1017E\">If the request\'s body is not in UTF8, the body-size calculation will fail due to an internal check. In this case, no information about the body size is available.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1678772778804_N1011B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">API Reference:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"api\/crds\/limits\/\" target=\"_blank\">CR Limits reference documentation<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"api\/crds\/content-security\/\" target=\"_blank\">CR Content Security reference documentation<\/a><\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1659430054462.html\">CR ContentSecurity<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1675772881974.html\">CR Parser<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1672991879135.html\">Logging configuration and output formatting<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1674151144160.html\">Default access log field reference<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';