var m_1693917396975Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>CR OpenAPI<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1693917396975\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">CR OpenAPI<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1693917396975_N100081627032360239\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1693917396975_N1000D\">Published APIs can be protected by configuring the corresponding OpenAPI specification in the Airlock Microgateway.<br\/>Even though the Airlock Microgateway default settings work well for most upstream web application services, enforcing a tight OpenAPI specification reduces the attack surface significantly. HTTP requests and responses are checked against the OpenAPI specification and will be blocked in case of a violation.<\/p><p class=\"par\" id=\"1693917396975_N1000F1695130743091\">OpenAPI specifications are typically generated in an automated way by the API build pipeline. No reverse-engineering by security personnel is required and a <i class=\"italics\">DevSecOps<\/i> process can be established.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1689952158025_N10154\">This CR needs to be referenced in the <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1659430054462.html\">CR ContentSecurity<\/a>.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1693917396975_N10035\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1693917396975_N10038\">A valid OpenAPI specification is required with the key <code class=\"codeinline\">openapi.json<\/code>. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">There are two main error cases with missing or faulty OpenAPI specifications:<\/li><li class=\"enum-element\">If a specification cannot be parsed, an application log message is written, e.g., <code class=\"codeinline\">Failed to parse openapi config. JSON parse error: Missing a comma or \'}\'...<\/code>.<\/li><li class=\"enum-element\">If an empty OpenAPI specification is configured, the access log message <code class=\"codeinline\">OpenAPI schema is empty<\/code> is written and all requests are rejected.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1693917396975_N1000C\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Example configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Create a <i class=\"italics\">ConfigMap<\/i> with the key <code class=\"codeinline\">openapi.json<\/code> in the application namespace based on an OpenAPI specification file.<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10061\">kubectl -n &lt;my-app-namespace&gt; \\ \r\n  create cm &lt;open-api-example&gt; \\  \r\n  --from-file=openapi.json=&lt;my-local-openapi-filename.json&gt;<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step result\">This will result in a ConfigMap similar to the following example:<\/li><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1006C\">Version: v1 \r\nkind: ConfigMap \r\nmetadata: \r\n  name: &lt;open-api-example&gt; \r\ndata: \r\n    openapi.json: | { \r\n    \"openapi\": \"3.0.0\", \r\n    \"info\": { \r\n      \"title\": \"Simple API overview\", \r\n      \"version\": \"2.0.0\" \r\n    }, \r\n    \"paths\": { \r\n      \"\/\": { \r\n        \"get\": {...} \r\n        .... \r\n  }<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Create the CR OpenAPI and reference it in the <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1659430054462.html\">CR ContentSecurity<\/a>. For a CR OpenAPI example, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"api\/crds\/open-api\/\" target=\"_blank\">CR OpenAPI reference documentation<\/a>, tab <i class=\"italics\">Example<\/i>.<\/li><li class=\"step\">Check the status of your <code class=\"codeinline\">sidecargateways<\/code> to verify that the configuration works as expected.<br\/><strong class=\"emphasis\">Example:<\/strong><\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10013\">kubectl get sidecargateways.microgateway.airlock.com<\/pre><\/div><\/div><\/div><\/div><\/div><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1693917396975_N100B4\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Logging<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1693917396975_N100B7\">In case of a problem in the configured OpenAPI specification, Airlock Microgateway logs information in the application log.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">JSON syntax error in OpenAPI specification:<\/li><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100C7\">[2023-09-25 11:58:25.476][37802][warning][config] [airlock\/extensions\/filters\/http\/openapi\/openapi_filter_config.cc:125] Failed to parse OpenAPI configuration \"&lt;OpenAPI-reference-name&gt;\": JSON parse error: Missing a name for object member. offset 36<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"enum-element\">OpenAPI syntax error:<\/li><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100D51695641777380\">[2023-09-25 11:59:49.918][38151][critical][main] [external\/envoy\/source\/server\/server.cc:134] error initializing config \'  \/home\/jona\/devel\/airlock-microgateway-engine\/config\/openapi.yaml\': Failed to parse OpenAPI configuration \"&lt;OpenAPI-reference-name&gt;\": Expected key \"in\" not found $.paths.\/WebApplication.post.parameters[0]<\/pre><\/div><\/div><\/div><\/div><\/div><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1693917396975_N10043\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Feature scope and configuration options<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The OpenAPI filter supports the validation of requests and responses:<\/strong><\/li><li class=\"enum-element\">Path<\/li><li class=\"enum-element\">Query parameters<\/li><li class=\"enum-element\">Headers<\/li><li class=\"enum-element\">Cookies<\/li><li class=\"enum-element\">JSON syntax and objects<\/li><p class=\"par\" id=\"1693917396975_N100C9\">Body content checks are only applied to JSON documents, form-urlencoded parameters, and binary data (jpgs, gifs, ...).<\/p><p class=\"par\" id=\"1693917396975_N1007F\">API specification format must be in <strong class=\"emphasis\">OpenAPI version 3.0<\/strong> as JSON.<\/p><\/ul><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The OpenAPI feature does currently not support the following:<\/strong> <\/li><li class=\"enum-element\">For requests with form-urlencoded parameters, <code class=\"codeinline\">additionalProperties<\/code> can only be configured as a boolean.<\/li><li class=\"enum-element\">XML and YAML content types are unsupported. These content types are passed unchecked, even when specified in a schema.<\/li><li class=\"enum-element\">Multipart requests.<\/li><li class=\"enum-element\">Callback definitions.<\/li><li class=\"enum-element\">OpenAPI schema in YAML format.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1693917396975_N10020\">Specifications in other formats or versions, e.g., Swagger 2.0, must be converted before uploading. For Swagger to OpenAPI conversions, we recommend the Mermade converter, which is available as a <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/github.com\/Mermade\/swagger2openapi\" target=\"_blank\">command-line tool<\/a>. <\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1693917396975_N10011\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">API Reference:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"api\/crds\/open-api\/\" target=\"_blank\">CR OpenAPI reference documentation<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"api\/crds\/content-security\/\" target=\"_blank\">CR Content Security reference documentation<\/a><\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1659430054462.html\">CR ContentSecurity<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1662655596907.html\">Listing the SidecarGateway status<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';