var m_1697129075441Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Troubleshooting for network routing issues in the application pod<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1697129075441\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Troubleshooting for network routing issues in the application pod<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1697129075441_N1000A\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1697129075441_N1000B\">The articles in this chapter cover <i class=\"italics\">Microgateway CNI<\/i> DaemonSet, <i class=\"italics\">Microgateway CNI plugin<\/i> and the <i class=\"italics\">Microgateway Network Validator<\/i> issues and help with troubleshooting.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1697129075441_N10008\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Routing configuration schematics<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1697129075441_N10009\">Routing all traffic through the Microgateway Engine is crucial for application security. The following drawing is a simplified schematic of the components working together for routing configuration and the initial routing sanity check.<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1697129075441_N10021\"><img alt=\"CNI installation and verification\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/03_Media\/Vector_drawings\/Microgateway\/13555.CNI_installation_and_verification.theme\/1.0\/en-us.13555.CNI_installation_and_verification_original.svg\" style=\"width:;height:458px;border:0;\"\/><\/div><\/figure><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">The <i class=\"italics\">Microgateway CNI<\/i> DaemonSet installs the <i class=\"italics\">Microgateway CNI plugin<\/i> on each node (except the <code class=\"codeinline\">nodeAffinity<\/code> or <code class=\"codeinline\">nodeSelector<\/code> settings are configured otherwise).<\/li><li class=\"step\">Annotated web applications are deployed with a <i class=\"italics\">Microgateway Engine<\/i> and a <i class=\"italics\">Microgateway Network Validator<\/i>. The <i class=\"italics\">Microgateway CNI plugin<\/i> configures the routing within these web application Pods.<\/li><li class=\"step\">The <i class=\"italics\">Microgateway Network Validator<\/i> initContainer performs a sanity check that fails if the <i class=\"italics\">Microgateway CNI plugin<\/i> is not working\/installed or is not ready when the web application pod is deployed and running.<\/li><\/ol><p class=\"par\" id=\"1697129075441_N10018\">Network routing can fail for different reasons, mainly configuration issues. A good starting point is to check the basic configuration requirements as listed below.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1697129075441_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Basic requirements<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1697129075441_N100511700747537408\">Check the following basic configuration requirements, depending on your deployment.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Web application Pod:<\/strong><\/li><li class=\"enum-element\">For application Pods <code class=\"codeinline\">hostNetwork: false<\/code> must be configured. Otherwise, the <i class=\"italics\">Microgateway CNI plugin<\/i> is <strong class=\"emphasis\">not executed<\/strong>. <br\/>The <code class=\"codeinline\">hostNetwork: true<\/code> configuration option is currently unsupported by Airlock Microgateway.<\/li><li class=\"enum-element\">Install the web application pod only on nodes that have the <i class=\"italics\">Microgateway CNI plugin<\/i> installed. Check the <code class=\"codeinline\">nodeAffinity<\/code> and <code class=\"codeinline\">nodeSelector<\/code> of the Airlock Microgateway CNI and your application.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Microgateway Network Validator:<\/strong><\/li><li class=\"enum-element\">The image registry can be misconfigured, e.g., with an unsupported <i class=\"italics\">busybox<\/i> image (see <code class=\"codeinline\">networkValidator.image<\/code> in the Operator Helm chart). Refer to the example configuration in section <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1660804711846.html#1660804711846_N1009D\">How to use your custom image registry<\/a>.<\/li><li class=\"enum-element\">Port <code class=\"codeinline\">19003<\/code> must be reserved in the web application Pod for the <i class=\"italics\">Network Validator initContainer<\/i>. The port is required for the initial sanity check of the routing in the web application Pod.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Microgateway CNI plugin:<\/strong><\/li><li class=\"enum-element\">The <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1693917394386.html\">Microgateway CNI plugin<\/a> must be installed on the node and be in working order <strong class=\"emphasis\">before<\/strong> the web application Pod is deployed.<\/li><li class=\"enum-element\"><i class=\"italics\">Optional:<\/i> A <code class=\"codeinline\">nodeAffinity<\/code> and\/or a <code class=\"codeinline\">nodeSelector<\/code> can be configured in the <i class=\"italics\">CNI Helm chart<\/i> so that the <i class=\"italics\">Microgateway CNI plugin<\/i> is only installed on nodes with matching <code class=\"codeinline\">labels<\/code>. See official <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/kubernetes.io\/docs\/concepts\/scheduling-eviction\/assign-pod-node\/#node-affinity\" target=\"_blank\">Kubernetes node affinity documentation<\/a> for more information.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1697129075441_N10049\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Recommended quick check sequence<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1697129075441_N100511700467525092\">The following list is logically ordered for fast fault finding if you encounter <i class=\"italics\">Microgateway CNI<\/i> or routing problems.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">As part of each Airlock Microgateway installation, ensure the <i class=\"italics\">Microgateway CNI DaemonSet<\/i> is properly installed and running.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Before installation:<\/li><li class=\"enum-element\">Ensure the chosen <code class=\"codeinline\">&lt;environment&gt;-values.yaml<\/code> preset (GKE, OpenShift, ..) is correct for your cluster type.<\/li><li class=\"enum-element\">Ensure the version of the <i class=\"italics\">Microgateway CNI DaemonSet<\/i> and the <i class=\"italics\">Microgateway Operator<\/i> match to avoid incompatibilities (e.g., with updated routing configuration).<\/li><\/ul><li class=\"step\">Ensure the <i class=\"italics\">Microgateway CNI plugin<\/i> is installed on the target node when the <i class=\"italics\">web application with the Microgateway Engine<\/i> is deployed, as described chapter <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1660804708637.html\">Installation<\/a>.<\/li><li class=\"step\">Check the state of the <i class=\"italics\">Microgateway Network Validator<\/i> container inside the web application Pod.<\/li><\/ol><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';