var m_1702376369898Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Reducing false-positive blocks<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1702376369898\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Reducing false-positive blocks<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1702376369898_N100B8\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1702376369898_N100B9\">Sometimes, requests are blocked by deny rules due to content resembling attacks but may be valid for a web application. These blocks are called <i class=\"italics\">false positives<\/i>. You have several configuration options in the <i class=\"italics\">CR DenyRules<\/i> if you have verified that the target web application is working correctly and a blocked request is a false positive. <br\/>This article describes how and where to start reducing false positives.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702376369898_N100431702477989261\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Narrowing down and reducing false positives<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702376369898_N100461702477989261\">This instruction is a best practice for narrowing down and reducing false positives that can be followed in most cases.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1702376369898_N1004B\">While integrating an Airlock Microgateway with an existing application, you can use the <code class=\"codeinline\">threatHandlingMode: LogOnly<\/code> to analyze the impact of deny rules on an application running in production. This allows for identifying false positives and configuring exceptions without disturbing productive traffic.<\/p><\/div><\/div><\/div><\/div><\/div><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Analyze the logs to narrow down the <code class=\"codeinline\">block_reason<\/code>, <code class=\"codeinline\">rule_key<\/code> etc. of the false positives blocks. See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1674151144160.html\">Default access log field reference<\/a> for more information.<\/li><li class=\"step\">Consider choosing a lower security level for the corresponding deny rule group on the affected mapping (e.g., go back from level strict to standard).<\/li><li class=\"step\">Add deny rule exceptions. Deny rules allow the definition of fine-grained exceptions for all attributes. See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1667549240920.html\">CR DenyRules<\/a> for details, including exceptions for JSON content.<\/li><li class=\"step\">If the block pertains to a specific deny rule, the rule can be set to <code class=\"codeinline\">LogOnly<\/code>\u200B or  <code class=\"codeinline\">Unfiltered<\/code> to turn off blocking. Note that this should not be done lightly. Instead, you should consider changing the web application if possible.<\/li><li class=\"step result\">Check the access logs to verify the deny rule exception works as expected.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702376369898_N10080\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Tips for setting up deny rule exceptions<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702376369898_N10020\">In general, be as specific as possible when defining exceptions. For instance, adding an exception for content type <code class=\"codeinline\">application\/pdf<\/code> may allow bypassing a deny rule simply by adding a header to requests. Whether or not the content is interpreted as a PDF file depends on the application and cannot be controlled by Airlock Microgateway.<\/p><ol class=\"enum-enum-instruction container-enum enum-standard Alpha\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Possible deny rule configuration options:<\/strong><\/li><li class=\"enum-element\">Define a deny rule exception only with <code class=\"codeinline\">blockedData<\/code>. This way, the configured exception is applied unconditionally to all paths, HTTP methods, remote IP addresses, ...<\/li><li class=\"enum-element\">Define a deny rule exception with <code class=\"codeinline\">blockedData<\/code> and <code class=\"codeinline\">requestConditions<\/code>. This is the <strong class=\"emphasis\">recommended configuration<\/strong>, as it only applies the exceptions to requests that matches the <code class=\"codeinline\">requestConditions<\/code>.<\/li><li class=\"enum-element\">Define a deny rule exception only with <code class=\"codeinline\">requestConditions<\/code>. This configuration should be chosen carefully, as deny rule checks are not applied at all to requests which matches the <code class=\"codeinline\">requestConditions<\/code>.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702376369898_N10090\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1667549240920.html\">CR DenyRules<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1674151144160.html\">Default access log field reference<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';