var m_1702575901330Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Kubernetes cluster with Cilium<\/title><meta content=\"eBPF, BPF\" name=\"keywords\"\/><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1702575901330\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Kubernetes cluster with Cilium<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1702575901330_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702575901330_N1000F1652788695004\">This article shows the architecture of a small <i class=\"italics\">Cilium setup<\/i> with only one Airlock Microgateway-protected web application deployed in a Kubernetes cluster. Cilium is deployed to bring their features for the lower OSI layers (routing, observability, ...) with eBPF. Meanwhile, Airlock Microgateway brings security on <i class=\"italics\">layer 7<\/i> as a WAAP (web application and API protection, formerly known as WAF - web application firewall.<\/p><p class=\"par\" id=\"1702575901330_N100111702890964720\">The simple example shows a setup with a single web application, the <i class=\"italics\">Microgateway Operator<\/i> and the <i class=\"italics\">Cilium agent<\/i> in a single Node. In the <i class=\"italics\">Web application Pod<\/i> the <i class=\"italics\">Microgateway Engine<\/i> is injected as sidecar.<\/p><p class=\"par\" id=\"1702575901330_N1001D\">The <i class=\"italics\">Microgateway Operator<\/i> container injects the <i class=\"italics\">Microgateway Engine<\/i> Container into <i class=\"italics\">Web application Pods<\/i>, labeled with <code class=\"codeinline\">sidecar.microgateway.airlock.com\/inject: \"true\"<\/code>. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The <i class=\"italics\">Operator<\/i> configures the <i class=\"italics\">Engine<\/i> based on Custom Resources that contain the Engine configuration.<\/li><li class=\"enum-element\">The <i class=\"italics\">Microgateway CNI plugin<\/i> of the Node configures the network routing between <i class=\"italics\">Engine<\/i> and <i class=\"italics\">Web application<\/i> container.<\/li><li class=\"enum-element\">The <i class=\"italics\">Cilium CNI plugin<\/i> of the Node is used to bring the network capabilities provided by Cilium.<\/li><\/ul><figure class=\"media\"><div class=\"media-theme\" id=\"1702575901330_N1000F\"><img alt=\"Kubernetes resources with Cilium\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/03_Media\/Vector_drawings\/Microgateway\/13553.Kubernetes_resources_with_Cilium.theme\/1.3\/en-us.13553.Kubernetes_resources_with_Cilium_original.svg\" style=\"width:1024px;height:673.0685413005272px;border:0;\"\/><\/div><\/figure><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702575901330_N100521661955619775\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Traffic handling<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 Alpha\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">A <i class=\"italics\">Web client<\/i> wants to access the <i class=\"italics\">Web application<\/i>. The request is sent to the <i class=\"italics\">Ingress controller<\/i> of the <i class=\"italics\">Kubernetes cluster<\/i>.<\/li><li class=\"enum-element\">The <i class=\"italics\">Ingress controller<\/i> accepts the incoming traffic from outside the cluster and forwards it to the <i class=\"italics\">Web application<\/i> Service.<\/li><li class=\"enum-element\">The <i class=\"italics\">Web application<\/i> Service forwards the traffic to the <i class=\"italics\">Web application<\/i> Pod. <br\/>In this Pod, all traffic is routed through the <i class=\"italics\">Microgateway Engine<\/i> container and subsequently to the <i class=\"italics\">Web application<\/i> container as configured by the <i class=\"italics\">Microgateway CNI plugin<\/i>.<\/li><li class=\"enum-element\">The <i class=\"italics\">Microgateway Engine<\/i> container writes logs to <code class=\"codeinline\">\/dev\/stdout<\/code>. A logging service can collect and visualize these logs in a graphical reporting solution.<\/li><li class=\"enum-element\">The <i class=\"italics\">Prometheus<\/i> Pod scrapes metrics from the <i class=\"italics\">Microgateway Engine<\/i> containers that can be visualized, e.g., using Grafana.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702575901330_N100A7\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration handling<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">The <i class=\"italics\">Microgateway Operator<\/i> reads its configuration from the <i class=\"italics\">Microgateway Operator Configuration<\/i> at startup and watches for events such as Pod <code class=\"codeinline\">create<\/code>, <code class=\"codeinline\">update<\/code> , or <code class=\"codeinline\">delete<\/code>.<\/li><li class=\"step\">When a <i class=\"italics\">Web application Pod<\/i> is created with a <code class=\"codeinline\">sidecar.microgateway.airlock.com\/inject<\/code> label, the following happens:<\/li><ol class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 Alpha\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"> The <i class=\"italics\">Microgateway Operator<\/i> injects the <i class=\"italics\">Microgateway Engine<\/i> container.<\/li><li class=\"enum-element\">The <i class=\"italics\">Microgateway CNI plugin<\/i> configures the routing within the <i class=\"italics\">Web application Pod<\/i> so that all traffic is routed through the <i class=\"italics\">Microgateway Engine<\/i>.<\/li><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1702575901330_N100E0\">The CNI configuration is used to chain the Cilium with the Microgateway CNI plugin and use both products together.<\/p><\/div><\/div><\/div><\/div><\/div><li class=\"enum-element\">The <i class=\"italics\">Microgateway Network Validator<\/i> performs a quick sanity check of the network routing configured by the <i class=\"italics\">Microgateway CNI plugin<\/i>.<\/li><\/ol><li class=\"step\">The CustomResource <i class=\"italics\">SidecarGateway<\/i> includes a <code class=\"codeinline\">podSelector<\/code> that selects the group of Pods to which the configuration applies.<\/li><li class=\"step\">The CustomResource <i class=\"italics\">SidecarGateway<\/i> refers to other resources that should be applied.<\/li><li class=\"step\">The <i class=\"italics\">Microgateway Operator<\/i> reads the involved configuration and sends it to the <i class=\"italics\">Microgateway Engine<\/i>.<\/li><li class=\"step\">The <i class=\"italics\">Microgateway Operator<\/i> watches the <i class=\"italics\">Microgateway Engine<\/i> configuration resources. If these resources have been altered, the <i class=\"italics\">Microgateway Operator<\/i> updates the <i class=\"italics\">Microgateway Engine<\/i> with the new configuration.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702575901330_N1023D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1702575900737.html\">Cilium<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';