var m_1712854261792Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Uninstallation and upgrade instructions<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1712854261792\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Uninstallation and upgrade instructions<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1712854261792_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1712854261792_N10009\">This article covers various topics of uninstallation, cleanup, and upgrade of Airlock Microgateway. Note that some instructions in this article are release-dependent because upgrading from Microgateway versions 4.0 and 4.1 to helm-install-based Microgateway 4.2 (and newer) is not possible.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1712854261792_N1000B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Upgrade from Microgateway 4.1 to 4.2<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1712854261792_N10017\">When changing from any older Airlock Microgateway 4 version to Microgateway 4.2 and newer, you must uninstall the old version first. Except the CRDs and the CNI plugin have been installed via Helm. The following brief sequence describes the upgrade from a Microgatway 4.x release to 4.2 and newer. <br\/>Note that the instructions must be performed <strong class=\"emphasis\">in the correct order<\/strong>.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Label all the applications that should be protected with Airlock Microgateway with the new label <code class=\"codeinline\">sidecar.microgateway.airlock.com\/inject=true<\/code> . This is necessary because we switched from annotation to label. <\/li><li class=\"step\">Uninstall the Microgateway CNI plugin if it was installed with <code class=\"codeinline\">kustomize<\/code>.<\/li><p class=\"par\" id=\"1712854261792_N1002A\">Adapt the <code class=\"codeinline\">&lt;environment&gt;<\/code> part before running the following command:<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1003C\">kubectl kustomize --enable-helm https:\/\/github.com\/airlock\/microgateway\/deploy\/cni\/&lt;environment&gt; | kubectl delete -f -<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Upgrade the Microgateway CNI plugin. If the CNI plugin was installed with <code class=\"codeinline\">kustomize<\/code> the command is <code class=\"codeinline\">helm install<\/code> instead of <code class=\"codeinline\">helm upgrade<\/code>.<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100661713341888067\">helm upgrade airlock-microgateway-cni -n kube-system oci:\/\/quay.io\/airlockcharts\/microgateway-cni --version \'4.2.0\'<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Uninstall Microgateway deployments. Note that you must not uninstall the CRDs.<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10039\">kubectl delete -k https:\/\/github.com\/airlock\/microgateway\/deploy\/deployment\/\r\nkubectl delete -k https:\/\/github.com\/airlock\/microgateway\/deploy\/crd-rbac\/<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Apply the new license. This is important because the license format changed in Microgateway 4.2.<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100F2\">kubectl create namespace airlock-microgateway-system\r\nkubectl -n airlock-microgateway-system create secret generic airlock-microgateway-license --from-file=microgateway-license.txt<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Update the CRDs. This will not break your current installation <strong class=\"emphasis\">if not noted otherwise in the release notes<\/strong> of the new Microgateway version.<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N101321713340915942\">kubectl apply -k https:\/\/github.com\/airlock\/microgateway\/deploy\/charts\/airlock-microgateway\/crds\/?ref=4.2.0<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Install the new Microgateway Operator.<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10115\">helm install airlock-microgateway -n airlock-microgateway-system oci:\/\/quay.io\/airlockcharts\/microgateway --version \'4.2.0\'<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step result\">You can verify the current Pod status by checking the <code class=\"codeinline\">version<\/code> label. To finalize the upgrade process, manually restart all application Pods containing Microgateway Engine sidecars. See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-element\" href=\"..\/data\/1712854261792.html#1712854261792_N10126\">Uninstallation and upgrade<\/a> section in this article.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1712854261792_N1003E1713339989305\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Uninstalling Microgateway versions 4.0 and 4.1<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Remove the label <code class=\"codeinline\">sidecar.microgateway.airlock.com\/inject<\/code> from your applications and make sure they are restarted.<\/li><li class=\"step\">Uninstall Microgateway deployments and the CRDs.<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100501713339989305\">kubectl delete -k https:\/\/github.com\/airlock\/microgateway\/deploy\/deployment\/\r\nkubectl delete -k https:\/\/github.com\/airlock\/microgateway\/deploy\/crd-rbac\/\r\nkubectl delete -k https:\/\/github.com\/airlock\/microgateway\/deploy\/crds<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Uninstall the Microgateway CNI plugin.<\/li><p class=\"par\" id=\"1712854261792_N100561713339989305\">If the CNI plugin has been manually installed using <code class=\"codeinline\">kustomize<\/code> adapt the <code class=\"codeinline\">&lt;environment&gt;<\/code> part before running the following command:<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10067\">kubectl kustomize --enable-helm https:\/\/github.com\/airlock\/microgateway\/deploy\/cni\/&lt;environment&gt; | kubectl delete -f -<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1712854261792_N1003D\">If the CNI plugin has been installed using <code class=\"codeinline\">helm<\/code>, run:<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1004A\">helm uninstall -n kube-system airlock-microgateway-cni<\/pre><\/div><\/div><\/div><\/div><\/div><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1712854261792_N1004D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Uninstalling Microgateway version 4.2 and newer<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1712854261792_N10050\">Airlock Microgateway 4.2 and newer releases are helm-based and can be uninstalled using <code class=\"codeinline\">helm<\/code> commands. However, <code class=\"codeinline\">helm<\/code> does not support removing installed CRDs, which requires using <code class=\"codeinline\">kubectl delete<\/code> commands to complete the uninstallation process.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Remove the label <code class=\"codeinline\">sidecar.microgateway.airlock.com\/inject<\/code> from your applications and make sure they are restarted.<\/li><li class=\"step\">Uninstall the Microgateway Operator.<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1006D\">helm uninstall -n airlock-microgateway-system airlock-microgateway  <\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Uninstall the CRDs.<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1712854261792_N1010E1713960701966\">Before uninstalling the CRDs make sure that no other Airlock Microgateway installation is existing.<\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1007A\">kubectl delete -k \"https:\/\/github.com\/airlock\/microgateway\/deploy\/charts\/airlock-microgateway\/crds\/?ref=&lt;installed-release-version&gt;\"<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Uninstall the Microgateway CNI plugin.<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100611713254744992\">helm uninstall -n kube-system airlock-microgateway-cni<\/pre><\/div><\/div><\/div><\/div><\/div><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1712854261792_N10045\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Cleanup after installation tests for Microgateway version 4.2 and newer<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1712854261792_N10048\">CNI and operator test pods are not automatically uninstalled after test completion. We recommend uninstalling them after testing, even if they are inactive and do not require any resources.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Delete the CNI test Pods.<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1005F\">kubectl delete pod -n kube-system -l \"app.kubernetes.io\/instance=airlock-microgateway-cni,app.kubernetes.io\/component=test-install\"<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Delete the Operator test Pods.<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100AB\">kubectl delete pod -n airlock-microgateway-system -l \"app.kubernetes.io\/instance=airlock-microgateway,app.kubernetes.io\/component=test-install\"<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\">To remove remaining test resources, run:<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100B4\">helm upgrade airlock-microgateway -n airlock-microgateway-system --set tests.enabled=false --reuse-values oci:\/\/quay.io\/airlockcharts\/microgateway --version \'&lt;installed-version&gt;\'\r\nhelm upgrade airlock-microgateway-cni -n kube-system --set tests.enabled=false --reuse-values oci:\/\/quay.io\/airlockcharts\/microgateway-cni --version \'&lt;installed-version&gt;\'  <\/pre><\/div><\/div><\/div><\/div><\/div><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1712854261792_N10073\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Upgrading Microgateway 4.2 and newer<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1712854261792_N100E91713259051013\">The following upgrade instructions aim to upgrade running deployments to a newer version of Airlock Microgateway without interruption of service.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1712854261792_N100EE1713259051013\">This instruction may not apply to breaking release upgrades of Airlock Microgateway. Refer to the release notes of the Microgatway version you want to upgrade to before following the below instructions.<\/p><\/div><\/div><\/div><\/div><\/div><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Update the CRDs. This will not break your current installation <strong class=\"emphasis\">if not noted otherwise in the release notes<\/strong> of the new Microgateway version.<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10142\">kubectl apply -k https:\/\/github.com\/airlock\/microgateway\/deploy\/charts\/airlock-microgateway\/crds\/?ref=4.2.0<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Upgrade the Microgateway CNI plugin.<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1013E\">helm upgrade airlock-microgateway-cni -n kube-system oci:\/\/quay.io\/airlockcharts\/microgateway-cni --version \'4.2.0\'<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Upgrade the Microgateway Operator.<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1014B\">helm upgrade airlock-microgateway -n airlock-microgateway-system oci:\/\/quay.io\/airlockcharts\/microgateway --version \'4.2.0\'<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step result\">You can verify the current Pod status by checking the <code class=\"codeinline\">version<\/code> label. To finalize the upgrade process, manually restart all application Pods containing Microgateway Engine sidecars.<\/li><\/ol><p class=\"par\" id=\"1712854261792_N10126\"><strong class=\"emphasis\">Script-supported upgrading of deployments with outdated application Pods:<\/strong><\/p><p class=\"par\" id=\"1712854261792_N10130\">We have created a useful script to accelerate the deployment update process with multiple application Pods. The script can fetch Deployments, DaemonSets, and StatefulSets managing outdated application Pods.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Save the script <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-file sh\" href=\"..\/media\/02_Content_objects\/External_data_(non-XML)\/Scripts\/fetch-outdated-resources.theme\/1.1\/en-us.fetch-outdated-resources_original.sh\" target=\"_blank\">fetch-outdated-resources<\/a>, rename it to <code class=\"codeinline\">fetch-outdated-resources.sh<\/code>, and make it executable. <\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10132\">#!\/bin\/sh \r\nset -eu \r\nnamespace=${1:-\"default\"} \r\n \r\npod_selector=\"sidecar.microgateway.airlock.com\/incompatible=true\"\r\n \r\nrootController() { \r\n    namespace=$1 \r\n    resource=$2 \r\n    owner=$(kubectl get \"${resource}\" -n \"${namespace}\" -ojsonpath=\'{range .metadata.ownerReferences[?(@.controller==true)]}{.kind}\/{.name}{\"\\n\"}{end}\') \r\n    if [ -n \"$owner\" ]; then \r\n        rootController \"${namespace}\" \"${owner}\" \r\n    elif echo \"${resource}\" | grep -vq Pod\/; then \r\n        echo \"${resource}\" \r\n    fi \r\n} \r\n \r\nfor pod in $(kubectl get pods -n \"${namespace}\" -l \"${pod_selector}\" -ojsonpath=\'{range .items[*]}Pod\/{.metadata.name}{\"\\n\"}{end}\'); do \r\n        rootController \"${namespace}\" \"${pod}\" \r\ndone | sort -u<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\"><strong class=\"emphasis\">Variant 1<\/strong><\/li><p class=\"par\" id=\"1712854261792_N1012B\">Automatic rollout restart of outdated resources with the following command:<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10186\">.\/fetch-outdated-resources.sh &lt;application-namespace&gt; | xargs kubectl rollout restart -n &lt;application-namespace&gt;<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\"><strong class=\"emphasis\">Variant 2<\/strong><\/li><ol class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 Alpha\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Set the <code class=\"codeinline\">microgateway.airlock.com\/restartRequired=true<\/code> label.<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10166\">.\/fetch-outdated-resources.sh &lt;application-namespace&gt; | xargs -I{} kubectl label {} -n &lt;application-namespace&gt; \"restartRequired=true\"<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"enum-element\">Perform a rollout restart of the labeled resources.<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1013A\">kubectl rollout restart -n &lt;application-namespace&gt; deployments -l microgateway.airlock.com\/restartRequired=true\r\nkubectl rollout restart -n &lt;application-namespace&gt; daemonsets -l microgateway.airlock.com\/restartRequired=true\r\nkubectl rollout restart -n &lt;application-namespace&gt; statefulsets -l microgateway.airlock.com\/restartRequired=true    <\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"enum-element\">Remove the <code class=\"codeinline\">microgateway.airlock.com\/restartRequired=true<\/code> label after rollout.<\/li><\/ol><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1712854261792_N1000C\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\">See chapter <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1660804708637.html\">Installation<\/a> for available installation options and instructions.<\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';